﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="SyncProfile.aspx.cs" Inherits="_SyncProfile" MasterPageFile="~/MasterPage.master" %>

<%@ Register Assembly="enzigma.controls" Namespace="enzigma.web.controls" TagPrefix="enz" %>

<asp:Content ContentPlaceHolderID="PageContent" runat="server">
    <link href="css/vendor/slds/assets/styles/salesforce-lightning-design-system.min.css" rel="stylesheet" />
    <div class="slds-scope">
        <div class="slds-p-around_small">
            <div class="slds-page-header">
                <div class="slds-grid">
                    <div class="slds-col slds-has-flexi-truncate">
                        <div class="slds-media slds-no-space slds-grow">
                            <div class="slds-media__figure">
                                <span class="slds-icon_container slds-icon-standard-opportunity" title="Profile">
                                    <svg class="slds-icon slds-page-header__icon slds-p-around--xx-small" aria-hidden="true">
                                         <use xlink:href="css/vendor/slds/assets/icons/action-sprite/svg/symbols.svg#user"></use>
                                    </svg>
                                </span>
                            </div>
                            <div runat="server" id="tdTitle" class="slds-media__body">
                                <nav>
                                    <ol class="slds-breadcrumb slds-line-height_reset">
                                        <ul class="slds-breadcrumb__item">
                                             <span>Profile</span>
                                        </ul>
                                    </ol>
                                </nav>
                                <h1 class="slds-page-header__title slds-m-right_small slds-align-middle slds-truncate" title="Get Live Profile"><span class="slds-text-heading--small">Get Live Profile</span></h1>
                            </div>
                        </div>
                    </div>
                    <div class="slds-col slds-no-flex slds-grid slds-align-top">
                    </div>
                </div>
                <div class="slds-grid slds-page-header__detail-row">
                    <div class="slds-grid slds-wrap slds-p-around--small">
                        <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                            <p class="slds-text-body_regular">
                                Whenever your account information is updated on Orektic's live server by either creating
					           or purchasing a subscription, You will need to transfer the updated information from
					           our live server to your server.
                            </p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="slds-p-horizontal_small slds-p-bottom_small">
            <div class="slds-grid slds-wrap">
                <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                    <article class="slds-card slds-m-top_x-small">
                <div class="slds-card__header slds-grid">
                    <header class="slds-media slds-media_center slds-has-flexi-truncate">
                        <div class="slds-media__figure"></div>
                    </header>
                </div>
                <div class="slds-card__body slds-card__body_inner">
                    <article class="slds-card slds-card_boundary slds-p-around--small">
                                            
                             <asp:Panel ID="panelMessageToRedirect" runat="server" Visible="false">
                                 <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                                    <asp:Label ID="lbToRedirect" runat="server" SkinID="Error"></asp:Label>
                                </div>
                            </asp:Panel>
                             <asp:Panel ID="panelMessage" runat="server">
                              <div class="slds-grid slds-wrap slds-p-top_xx-small">
                                <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                                    <p class="slds-text-body_regular"></p>
                                </div>
                            </div>
                              <div class="slds-grid slds-wrap slds-p-top_small">
                                <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                                    <b class="slds-text-body_regular">Please enter your Orektic's live account login and password to continue.</b>
                                </div>
                            </div>
                                   <div class="slds-grid slds-wrap slds-p-top_small">
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2">
                                                <div class="slds-form-element">
                                                    <label class="slds-form-element__label" for="form-element-01"><span class="slds-text-body_regular"><asp:Label ID="lbLogin" runat="server" SkinID="Label" Text="Username"></asp:Label></span></label>
                                                    <div class="slds-form-element__control">
                                                        <asp:TextBox ID="edLogin" runat="server" CssClass="ControlCell slds-input"></asp:TextBox>
                                                        <asp:RequiredFieldValidator ID="reqdValidatorLogin" runat="server" ControlToValidate="edLogin" Display="Dynamic" CssClass="slds-text-color_error" ErrorMessage="Please enter Username"></asp:RequiredFieldValidator>
                                                        <asp:RegularExpressionValidator ID="regValLogin" runat="server" ErrorMessage="Invalid username" Display="Dynamic" ValidationExpression="\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*" ControlToValidate="edLogin"></asp:RegularExpressionValidator>
                                                    </div>
                                                </div>
                                           </div>
                                    </div>

                                  <div class="slds-grid slds-wrap slds-p-top_small">
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2">
                                                <div class="slds-form-element">
                                                    <label class="slds-form-element__label" for="form-element-01"><span class="slds-text-body_regular"><asp:Label ID="lbPassword" runat="server" SkinID="Label" Text="Password:" CssClass="slds-text-body_regular"></asp:Label></span></label>
                                                    <div class="slds-form-element__control">
                                                        <asp:TextBox ID="edPassword" runat="server" TextMode="Password" CssClass="ControlCell slds-input"></asp:TextBox>
                                                        <asp:RequiredFieldValidator ID="reqdValidatorPassword" runat="server" CssClass="slds-text-color_error" ControlToValidate="edPassword" Display="Dynamic" ErrorMessage="Please enter Password"></asp:RequiredFieldValidator>
                                                    </div>
                                                </div>
                                           </div>
                                    </div>
                              <div class="slds-grid slds-wrap slds-p-top_xx-small">
                                <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2">
                                    <asp:Label ID="lbError" runat="server" SkinID="Error"></asp:Label>
                                </div>
                              </div>   
                              <div class="slds-grid slds-wrap slds-p-top_xx-small">
                                <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2">
                                     <asp:Button ID="btnYes"  runat="server" Text="Update" OnClick="btnYes_Click" CssClass="slds-button slds-button_brand"></asp:Button>
                                     <asp:Button ID="btnNo" runat="server" OnClick="btnNo_Click" Text="No" Visible="false" CssClass="slds-button slds-button_brand"></asp:Button>       
                                </div>
                              </div>
                            </asp:Panel> 
                    </article>
                </div>
            </article>
                </div>
            </div>
        </div>
    </div>
    <script type="text/javascript" language="javascript">
        $(document).ready(function () {
            $('link[href="App_Themes/Default/common.css"]').remove();
        });
    </script>
</asp:Content>



