<%@ Page Language="C#" AutoEventWireup="true" Inherits="AdminOrderHistory" MasterPageFile="~/MasterPage.master" CodeBehind="OrderHistory.aspx.cs" %>

<%@ Register Assembly="enzigma.controls" Namespace="enzigma.web.controls" TagPrefix="cc1" %>
<asp:Content ID="AttachPage" ContentPlaceHolderID="PageContent" runat="server">

    <style type="text/css">
        div.scrollbar::-webkit-scrollbar {
            width: 12px;
            height: 12px;
        }

        ::-webkit-scrollbar-track {
            -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,0.3);
            border-radius: 10px;
            background: #136594;
        }

        ::-webkit-scrollbar-thumb {
            border-radius: 10px;
            -webkit-box-shadow: inset 0 0 6px rgba(0,0,0,0.5);
            background: white;
            height: 120px;
        }
    </style>

    <script language="javascript" type="text/javascript">
        function OnDelete(strOrderID) {
            if (confirm('Are you sure, you want to delete the selected Order?')) {
                //window.open('Purchase.aspx?OrderID=' + strOrderID + '&action=delete','_blank','width=600,height=500');
            }
            else {
                if (window.event) {
                    window.event.cancelBubble = true;
                    window.event.returnValue = false;
                }
                return false;//TransactionID
            }
        }

        function SaveOrderToSF(strOrderID) {
            document.getElementById('<%=hdOrderID.ClientID%>').value = strOrderID;
        }

        function SendMail(strCustomerID, strOrderID) {
            document.getElementById('<%=hdCustomerID.ClientID%>').value = strCustomerID;
            document.getElementById('<%=hdOrderID.ClientID%>').value = strOrderID;
        }
        function initHScroll() {
            $('.scrollbar').mousewheel(function (e, delta) {
                this.scrollLeft -= (delta * 40);
                e.preventDefault();
            });
        }

        $(document).ready(function () {
            initHScroll();
        });
    </script>

    <asp:ScriptManager ID="ScriptManager" runat="server">
    </asp:ScriptManager>
    <div class="slds-p-around_xx-small">
    <div class="slds-card slds-m-bottom_xx-large slds-p-around_x-small ">
    <div class="slds-box">
    <asp:UpdatePanel ID="UpdatePanel1" runat="server">
        <ContentTemplate>
            <table width="970px" border="0" cellpadding="0" cellspacing="0">
                <tbody>
                    <tr>
                        <td class="Heading" valign="bottom" align="center">Order History</td>
                    </tr>
                    <tr>
                        <td>
                            <p>You can view all the orders placed for different applications hosted by Orektic. You can even search for specific order by using the search facility below. </p>
                        </td>
                    </tr>
                </tbody>
            </table>

            <asp:HiddenField ID="hdnCustomerID" runat="server"></asp:HiddenField>
            <asp:ObjectDataSource ID="Orders" runat="server" TypeName="enzigma.sforce.webapp.code.Business" SelectMethod="SearchOrder">
                <SelectParameters>
                    <asp:ControlParameter ControlID="edSearch" Name="strKeyword" PropertyName="Text"
                        Type="String" />
                    <asp:ControlParameter ControlID="hdnCustomerID" Name="strCustomerID" PropertyName="Value"
                        Type="String" />
                    <asp:Parameter Name="maximumRows" Type="Int32" />
                    <asp:Parameter Name="startRowIndex" Type="Int32" />
                </SelectParameters>
            </asp:ObjectDataSource>
            <table border="0" cellpadding="0" cellspacing="0" width="970px">
                <tbody>
                    <tr>
                        <td class="searchbox">
                            <asp:TextBox ID="edSearch" runat="server" BorderColor="White" BorderStyle="None" Height="23px"></asp:TextBox>
                        </td>
                        <td style="text-align: left; width: 40px;">
                            <asp:Button ID="btnSearch" runat="server" class="SearchButton" OnClick="btnSearch_Click" />
                            <%--<asp:ImageButton ID="btnSearch" runat="server" CausesValidation="False" CssClass="SearchButton" OnClick="btnSearch_Click"/>--%>
                        </td>
                        <td style="float: left;">
                            <asp:UpdateProgress ID="UpdateProgress" runat="server">
                                <ProgressTemplate>
                                    <img alt="" src="../App_Themes/Default/images/progressbar-small.gif" />
                                </ProgressTemplate>
                            </asp:UpdateProgress>
                        </td>
                        <td></td>
                    </tr>
                    <tr>
                        <td colspan="4">
                            <p>
                                <asp:Label ID="lbError" runat="server" SkinID="Error"></asp:Label></p>
                        </td>
                    </tr>
                    <tr>
                        <td colspan="4">
                            <p><asp:Label ID="lbMsg" runat="server"></asp:Label></p>
                        </td>
                    </tr>
                </tbody>
            </table>
            <div style="text-align: left;">
                <asp:GridView ID="gridOrders" runat="server" OnRowDataBound="gridOrders_RowDataBound" OnDataBound="gridOrders_DataBound" CaptionAlign="Left" OnRowDeleting="gridOrders_RowDeleting" DataKeyNames="ID" DataSourceID="Orders" AutoGenerateColumns="False" PageSize="20" AllowSorting="True" AllowPaging="True" GridLines="Vertical">
                <PagerSettings Position="Bottom" FirstPageText="First" Mode="NumericFirstLast" LastPageText="Last" />
                     <Columns>
                        
                        <%--<asp:TemplateField HeaderText="Edit"><ItemTemplate>
					            <a href="EditOrder.aspx?OrderID=<%#Eval("ID")%>" target="_blank" >Edit</a>
				
            </ItemTemplate>
            </asp:TemplateField>--%>
                        <asp:TemplateField HeaderText="Order Number">
                            <EditItemTemplate>
                                <asp:TextBox ID="TextBox3" runat="server" Text='<%# Bind("OrderNumber") %>'></asp:TextBox>

                            </EditItemTemplate>
                            <ItemTemplate>
                                <a href="ViewOrder.aspx?OrderID=<%#Eval("ID")%>" target="_blank"><%# Eval("OrderNumber") %></a>

                            </ItemTemplate>

                            <%--<ItemStyle Wrap="False"></ItemStyle>--%>
                        </asp:TemplateField>
                        <%--                        <asp:TemplateField HeaderText="Stage"><ItemTemplate>
					            <asp:LinkButton ID="lnkUpdateToSF" runat="server" Text="Update To SF" OnClientClick='<%# "SaveOrderToSF(" + Eval("ID") +") "%>' OnClick="lnkUpdateToSF_Click"></asp:LinkButton>
				
            </ItemTemplate>
            <ItemStyle Wrap="False"></ItemStyle>
            </asp:TemplateField>--%>
                        <asp:BoundField DataField="StageName" HeaderText="Stage">
                            <ItemStyle Wrap="False"></ItemStyle>
                            <%--<HeaderStyle HorizontalAlign="Left" Width="200px" />--%>
                        </asp:BoundField>
                        <%-- <asp:BoundField DataField="TransactionID" HeaderText="TransactionID" SortExpression="TransactionID">
            <ItemStyle Wrap="False"></ItemStyle>
            </asp:BoundField>--%>
                        <asp:BoundField DataField="IsApproved" HeaderText="IsApproved">
                            <%--<ItemStyle Wrap="False"></ItemStyle>--%>
                            <HeaderStyle HorizontalAlign="Left" Width="200px" />
                        </asp:BoundField>
                        <asp:BoundField DataField="OrderType__c" HeaderText="Order Type">
                            <%--<ItemStyle Wrap="False"></ItemStyle>--%>
                            <%--<HeaderStyle HorizontalAlign="Left" Width="200px" />--%>
                        </asp:BoundField>
                        <%-- changes --%>
                        <%--<asp:BoundField DataField="Name" HeaderText="Name" SortExpression="Name">
            <ItemStyle Wrap="False"></ItemStyle>
            </asp:BoundField>--%>
                        <asp:BoundField DataField="OrgName" HeaderText="Company">
                            <ItemStyle Wrap="false"></ItemStyle>
                            <%--<HeaderStyle HorizontalAlign="Left" Width="200px" />--%>
                        </asp:BoundField>
                        <asp:BoundField DataField="Product" HeaderText="Product">
                            <ItemStyle Wrap="False"></ItemStyle>
                            <%--<HeaderStyle HorizontalAlign="Left" Width="200px" />--%>
                        </asp:BoundField>
                        <%-- chnges--add TYpe of Instance here --%>
                        <%--  <asp:BoundField DataField="Phone" HeaderText="Phone" SortExpression="Phone">
            <ItemStyle Wrap="False"></ItemStyle>
            </asp:BoundField>--%>

                        <%--     <asp:BoundField DataField="State" HeaderText="State" SortExpression="State">
            <ItemStyle Wrap="False"></ItemStyle>
            </asp:BoundField>--%>

                        <%-- <asp:BoundField DataField="Country" HeaderText="Country" SortExpression="Country">
            <ItemStyle Wrap="False"></ItemStyle>
            </asp:BoundField>--%>
                        <%-- <asp:TemplateField HeaderText="Date" SortExpression="Date"><EditItemTemplate>
					            <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("Date") %>'></asp:TextBox>
				
            </EditItemTemplate>
            <ItemTemplate>
					            <asp:Label ID="Label1" runat="server" Text='<%# Bind("Date", "{0:d}") %>'></asp:Label>
				
            </ItemTemplate>

            <ItemStyle Wrap="False"></ItemStyle>
            </asp:TemplateField>--%>

                        <%--                            <asp:BoundField DataField="PrevLicensedUsers" HeaderText="Old Users" SortExpression="PrevLicensedUsers">
            <HeaderStyle Wrap="False"></HeaderStyle>

            <ItemStyle Wrap="False"></ItemStyle>
            </asp:BoundField>--%>
                        <%-- <asp:TemplateField HeaderText="Old Expires On" SortExpression="PrevExpiresOn"><EditItemTemplate>
					            <asp:TextBox ID="edPrevExpiresOn" runat="server" Text='<%# Bind("PrevExpiresOn") %>'></asp:TextBox>
				
            </EditItemTemplate>
            <ItemTemplate>
					            <asp:Label ID="lbPrevExpiresOn" runat="server" Text='<%# Bind("PrevExpiresOn", "{0:d}") %>'></asp:Label>
				
            </ItemTemplate>

            <HeaderStyle Wrap="False"></HeaderStyle>

            <ItemStyle Wrap="False"></ItemStyle>
            </asp:TemplateField>--%>
                        <%-- <asp:TemplateField HeaderText="Old Hosting Expires On" SortExpression="PrevHostingExpiresOn"><EditItemTemplate>
					            <asp:TextBox ID="edPrevHostingExpiresOn" runat="server" Text='<%# Bind("PrevHostingExpiresOn") %>'></asp:TextBox>
				
            </EditItemTemplate>
            <ItemTemplate>
					            <asp:Label ID="lbPrevHostingExpiresOn" runat="server" Text='<%# Bind("PrevHostingExpiresOn", "{0:d}") %>'></asp:Label>
				
            </ItemTemplate>

            <HeaderStyle Wrap="False"></HeaderStyle>

            <ItemStyle Wrap="False"></ItemStyle>
            </asp:TemplateField>--%>
                        <asp:BoundField DataField="LicensedUsers" HeaderText="Users">
                            <%--<ItemStyle Wrap="False"></ItemStyle>--%>
                            <HeaderStyle HorizontalAlign="Left" Width="200px" />
                        </asp:BoundField>
                        <asp:TemplateField HeaderText="StandAlone">
                            <EditItemTemplate>
                                <asp:TextBox ID="edIsStandalone" runat="server" Text='<%# Bind("IsStandAlone") %>'></asp:TextBox>

                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="lbIsStandalone" runat="server" Text='<%# Bind("IsStandAlone") %>'></asp:Label>

                            </ItemTemplate>

                            <HeaderStyle Wrap="False"></HeaderStyle>

                            <%--<ItemStyle Wrap="False"></ItemStyle>--%>
                        </asp:TemplateField>
                        <asp:BoundField DataField="Months" HeaderText="Months">
                            <%--<ItemStyle Wrap="False"></ItemStyle>--%>
                            <HeaderStyle HorizontalAlign="Left" Width="200px" />
                        </asp:BoundField>

                        <asp:TemplateField HeaderText="Total Price">
                            <EditItemTemplate>
                                <asp:TextBox ID="edTotal" runat="server" Text='<%# Bind("Total") %>'></asp:TextBox>

                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="lbTotal" runat="server" Text='<%# enzigma.sforce.webapp.code.business.Ordering.FormatCurrency((decimal)Eval("Total"),(string)Eval("CurrencyCode")) %>'></asp:Label>

                            </ItemTemplate>

                            <%--<ItemStyle Wrap="False"></ItemStyle>--%>
                            <HeaderStyle HorizontalAlign="Left" Width="200px" />
                        </asp:TemplateField>
                        <asp:TemplateField HeaderText="Expires On">
                            <EditItemTemplate>
                                <asp:TextBox ID="edExpiresOn" runat="server" Text='<%# Bind("ExpiresOn") %>'></asp:TextBox>

                            </EditItemTemplate>
                            <ItemTemplate>
                                <asp:Label ID="lbExpiresOn" runat="server" Text='<%# Bind("ExpiresOn", "{0:d}") %>'></asp:Label>

                            </ItemTemplate>

                            <HeaderStyle Wrap="False"></HeaderStyle>
                            <HeaderStyle HorizontalAlign="Left" Width="200px" />
                            <%--<ItemStyle Wrap="False"></ItemStyle>--%>
                        </asp:TemplateField>

                        <%--                                                        <asp:TemplateField HeaderText="Hosting Expires On" SortExpression="HostingExpiresOn"><EditItemTemplate>
					            <asp:TextBox ID="edHostingExpiresOn" runat="server" Text='<%# Bind("HostingExpiresOn") %>'></asp:TextBox>
				
            </EditItemTemplate>
            <ItemTemplate>
					            <asp:Label ID="lbHostingExpiresOn" runat="server" Text='<%# Bind("HostingExpiresOn", "{0:d}") %>'></asp:Label>
				
            </ItemTemplate>

            <HeaderStyle Wrap="False"></HeaderStyle>

            <ItemStyle Wrap="False"></ItemStyle>
            </asp:TemplateField>--%>

                        <%--<asp:TemplateField HeaderText="Price" SortExpression="Price"><EditItemTemplate>
					            <asp:TextBox ID="edPrice" runat="server" Text='<%# Bind("Price") %>'></asp:TextBox>
				
            </EditItemTemplate>
            <ItemTemplate>
					            <asp:Label ID="lbPrice" runat="server" ToolTip='<%# Bind("Unit") %>' Text='<%# enzigma.sforce.webapp.code.business.Ordering.FormatCurrency((decimal)Eval("Price"),(string)Eval("CurrencyCode")) %>'></asp:Label>
				
            </ItemTemplate>

            <ItemStyle Wrap="False"></ItemStyle>
            </asp:TemplateField>--%>


                        <asp:TemplateField ShowHeader="False" HeaderText="Action">
                            <ItemTemplate>
                                <asp:LinkButton ID="lnkDelete" runat="server" CausesValidation="False" CommandName="Delete" OnClientClick='<%# "OnDelete(" + Eval("ID") + ")" %>' Text="Delete"></asp:LinkButton>

                            </ItemTemplate>
                            <HeaderStyle HorizontalAlign="center" Width="200px" />
                        </asp:TemplateField>
                    </Columns>
                </asp:GridView>
            </div>
        </ContentTemplate>
    </asp:UpdatePanel>

    <asp:HiddenField ID="hdOrderID" runat="server" />
    <asp:HiddenField ID="hdCustomerID" runat="server" />
    <br />
    &nbsp;
        </div></div></div>
</asp:Content>
