<%@ Control Language="C#" ClassName="DisplayHelp" %>

<script runat="server">

	private string m_strHelpMessage = "";
	public string HelpMessage
	{
		get
		{
			if( m_strHelpMessage != null && m_strHelpMessage.Length > 0 )
				return m_strHelpMessage;

			if (m_strHelpMessageID != null && m_strHelpMessageID.Length > 0 && m_strHelpMessageID.Contains("."))
			{
				string strResource = m_strHelpMessageID;
				int iFnd = strResource.LastIndexOf('.');
				string strClass = strResource.Substring(0, iFnd);
				Type type = Type.GetType(strClass + ",App_GlobalResources");
				if (type != null)
				{
					System.Reflection.PropertyInfo propInfo = type.GetProperty(strResource.Substring(iFnd + 1));
					if (propInfo != null)
						return (string)propInfo.GetValue(null, null);
				}
			}
			
			return "";
		}
		set { m_strHelpMessage = value; }
	}

	private string m_strHelpMessageID = "";
	public string HelpMessageID
	{
		get { return m_strHelpMessageID; }
		set { m_strHelpMessageID = value; }
	}

	private string m_strHelpTitle = "";
	public string HelpTitle
	{
		get { return m_strHelpTitle; }
		set { m_strHelpTitle = value; }
	}
	
	private string m_strScript =
@"
function showHideHelp(strID)
{
	var divLabel = document.getElementById('divLabel_' + strID);
	var divHelpMessage = document.getElementById('divHelpMessage_' + strID);
	if( divLabel && divHelpMessage )
	{
		if( divHelpMessage.style.display == 'none' )
		{	
			divHelpMessage.style.display = '';
			//divLabel.style.display = 'none';
		}		
		else
		{
			divHelpMessage.style.display = 'none'
			//divLabel.style.display = 'inline';		
		}		
	}
	if( window.event)
	{
		window.event.cancelBubble = true;
		window.event.returnValue = false;
	}
	return false;	
}
";

	private string m_strMessageDiv = 
	@"
<div id='divHelpMessage_{0}' style=""position: absolute;display:none;background-color:#eeeeee;"" >
<table border=""0"" cellpadding=""0"" cellspacing=""0"" style=""border-right: #999999 1px solid; border-top: #999999 1px solid; border-left: #999999 1px solid; border-bottom: #999999 1px solid"">
	<tr>
		<td align=""right"" style=""background-image: url({1}/App_Themes/Default/images/def-button-center-border.jpg);"" valign=""top"">
		{3}
		</td>
		<td align=""right"" style=""background-image: url({1}/App_Themes/Default/images/def-button-center-border.jpg);"" valign=""top"">
			<img onclick=""return OnToggleHelp('{0}');"" border=""0"" id=""{0}_btnClose"" Src=""{1}/App_Themes/Default/images/cancel.jpg"" ToolTip=""Cancel"" /></td>
	</tr>
	<tr>
	<td class=""MessageText"" colspan=""2"" >
	<div  style=""margin: 3px 3px 3px 3px; overflow:auto;width:350px;height:200px;"">
	{2}
	</div>
	</td>
	</tr>
</table>
</div>";

	protected void Page_Load(object sender, EventArgs e)
	{
		m_strMessageDiv = string.Format(m_strMessageDiv, ClientID, Request.ApplicationPath, HelpMessage, HelpTitle);
		ScriptManager.RegisterClientScriptBlock(this, this.GetType(), "Functions", m_strScript, true);
	}

</script>
<div id='divLabel_<%=ClientID %>' style="display:inline;"><a href="#" onmouseover="return showHideHelp('<%=ClientID %>')" onmouseout="return showHideHelp('<%=ClientID %>')">(?)</a></div>
<%=m_strMessageDiv%>