<%@ Page Language="C#" MasterPageFile="~/MasterPage.master" AutoEventWireup="true" Inherits="EmailDefaultSettingsPage" Title="Server Settings" CodeBehind="EmailDefaultSettings.aspx.cs" %>

<%@ Register Assembly="enzigma.controls" Namespace="enzigma.controls.web" TagPrefix="cc2" %>

<%@ Register Assembly="enzigma.controls" Namespace="enzigma.web.controls" TagPrefix="cc1" %>
<asp:Content ID="Content1" ContentPlaceHolderID="PageContent" runat="Server">
    <link href="<%=enzigma.sforce.webapp.code.Global.WebRoot%>css/vendor/slds/assets/styles/salesforce-lightning-design-system.min.css" rel="stylesheet" type="text/css" />
    <script src="../../scripts/jquery-3.6.0.min.js"></script>

    <script type="text/javascript">
        $(document).ready(function () {
            $('link[href="../../App_Themes/Default/common.css"]').remove();

            document.getElementById('PageContent_detailviewServerSettings').removeAttribute("style");
            $('tr').removeAttr('style');
            $('td').removeAttr('style');

        });
        function hideToast() {
            $('#PageContent_toast').css('display', 'none');
            document.getElementById('<%=lbSettingError.ClientID%>').value = "";
            return false;
        }
    </script>
    <asp:ScriptManager ID="ScriptManager1" runat="server">
    </asp:ScriptManager>
    <div class="slds-scope">
        <div class="slds-p-around_small">
            <div class="slds-page-header">
                <div class="slds-grid">
                    <div class="slds-col slds-has-flexi-truncate">
                        <div class="slds-media slds-no-space slds-grow">
                            <div class="slds-media__figure">
                                <span class="slds-icon_container slds-icon-standard-opportunity" title="SMTP Server Setting">
                                    <svg class="slds-icon slds-page-header__icon slds-p-around--xx-small" aria-hidden="true">
                                             <use xlink:href="../../css/vendor/slds/assets/icons/action-sprite/svg/symbols.svg#email" class="slds-p-around_small"></use>
                                        </svg>
                                </span>
                            </div>
                            <div class="slds-media__body">
                                <nav>
                                        <ol class="slds-breadcrumb slds-line-height_reset">
                                            <ul class="slds-breadcrumb__item">
                                                <span>Email Setting</span>
                                            </ul>
                                        </ol>
                                    </nav>
                                <h1 class="slds-page-header__title slds-m-right_small slds-align-middle slds-truncate" title="">SMTP Server Setting</h1>
                            </div>
                        </div>
                    </div>
                    <div class="slds-col slds-no-flex slds-grid slds-align-top">
                    </div>
                </div>
                <div class="slds-grid slds-page-header__detail-row">
                    <div class="slds-grid slds-wrap slds-p-around--small">
                        <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                            <p>Please enter the information to access your SMTP server here. These settings are used when you try to send an email with FTP Attachments through SMTP instead of sending it through Salesforce.</p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="slds-p-horizontal_small slds-p-bottom--small">
            <div class="slds-card">
                <div class="slds-media__body"></div>
                <div class="slds-card__body slds-card__body--inner slds-p-top--small">
                    <div class="slds-box">
                        <div class="slds-media slds-p-bottom--small">
                            <div class="slds-media__figure">
                                <h2 class="slds-text-heading--small">
                                    <span class="slds-text-heading_small slds-text-color--default">
                                        <b>SMTP Server Setting</b></span>
                                </h2>
                            </div>
                        </div>

                        <asp:UpdatePanel ID="UpdatePanel1" runat="server">
                            <ContentTemplate>
                                <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1 slds-align_absolute-center">
                                    <div runat="server" id="toast" class="slds-scrollable" style="display: none;">
                                        <div class="demo-only">
                                            <div class="slds-notify_container slds-is-relative">
                                                <div class="slds-notify slds-notify_toast slds-theme_success" role="alert">
                                                    <span class="slds-assistive-text">info</span>
                                                    <span class="slds-icon_container slds-icon-utility-info slds-m-right_small slds-no-flex slds-align-top" title="Success">
                                                        <svg class="slds-icon slds-icon_small" aria-hidden="true">
                                                               <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#success" />
                                                           </svg>
                                                    </span>
                                                    <div class="slds-notify__content">
                                                         <h2 class="slds-text-body_regular ">
                                                        <asp:Label ID="lbSettingError" runat="server"></asp:Label></h2>
                                                    </div>
                                                    <button class="slds-button slds-button_icon slds-notify__close slds-button_icon-inverse" title="Close" id="btnClose" onclick="return hideToast()">
                                                        <svg class="slds-button__icon slds-button__icon_large" aria-hidden="true">
                                                                <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#close" />
                                                           </svg>
                                                        <span class="slds-assistive-text">Close</span>
                                                    </button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="slds-p-top_small slds-col  slds-small-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_6-of-12 background-body-color--default slds-scrollable">

                                    <asp:DetailsView ID="detailviewServerSettings" runat="server" AutoGenerateRows="False" CellPadding="0" BorderWidth="0px" DataSourceID="odsServerSettings" OnItemUpdating="detailviewServerSettings_ItemUpdating" BorderStyle="None" GridLines="None">
                                        <Fields>
                                            <asp:TemplateField HeaderText="Max File Size(MB):" ItemStyle-CssClass="slds-p-vertical_xx-small">
                                                <EditItemTemplate>
                                                    <asp:TextBox ID="edMaxFileSize" runat="server" Text='<%# Bind("MaxFileSize") %>' CssClass="slds-input" Font-Bold="false"></asp:TextBox>
                                                    <asp:RegularExpressionValidator ID="regMaxmFileSize" runat="server" ControlToValidate="edMaxFileSize"
                                                        Display="Dynamic" ErrorMessage="Please enter number" ValidationExpression="[0-9]+" ForeColor="red"></asp:RegularExpressionValidator>
                                                </EditItemTemplate>
                                                <InsertItemTemplate>
                                                    <asp:TextBox ID="edMaxFileSize" runat="server" Text='<%# Bind("MaxFileSize") %>' Font-Bold="false" CssClass="slds-input"></asp:TextBox>
                                                    <asp:RegularExpressionValidator ID="regMaxmFileSize" runat="server" ControlToValidate="edMaxFileSize"
                                                        Display="Dynamic" ErrorMessage="Please enter number" ValidationExpression="[0-9]+" ForeColor="red"></asp:RegularExpressionValidator>
                                                </InsertItemTemplate>
                                                <ItemTemplate>
                                                    <asp:Label ID="lbMaxFileSize" runat="server" Text='<%# Bind("MaxFileSize") %>' Font-Bold="false"></asp:Label>
                                                </ItemTemplate>
                                                <HeaderTemplate>
                                                    <asp:Label ID="lblMaxFileSize" runat="server" Text="File Size(MB)" CssClass="slds-form-element__label"></asp:Label>
                                                    <div class="slds-float_right">
                                                        <cc2:Help ID="helpMaxFile" runat="server" HelpMessageID="Resources.Help.MaxFileSize">
                                                        </cc2:Help>
                                                    </div>
                                                </HeaderTemplate>
                                            </asp:TemplateField>

                                            <asp:TemplateField HeaderText="Max Total File Size(MB):" ItemStyle-CssClass="slds-p-vertical_xx-small">
                                                <EditItemTemplate>
                                                    <asp:TextBox ID="edMaxTotalFileSize" runat="server" Text='<%# Bind("MaxTotalFileSize") %>' Font-Bold="false" CssClass="slds-input slds-m-top--medium"></asp:TextBox>
                                                    <asp:RegularExpressionValidator ID="regTotalMaxFileSize" runat="server" ControlToValidate="edMaxTotalFileSize"
                                                        Display="Dynamic" ErrorMessage="Please enter number" ValidationExpression="[0-9]+" Font-Bold="false"></asp:RegularExpressionValidator>
                                                </EditItemTemplate>
                                                <InsertItemTemplate>
                                                    <asp:TextBox ID="edMaxTotalFileSize" runat="server" Text='<%# Bind("MaxTotalFileSize") %>' Font-Bold="false" CssClass="slds-input slds-m-top--medium"></asp:TextBox>
                                                    <asp:RegularExpressionValidator ID="regTotalMaxFileSize" runat="server" ControlToValidate="edMaxTotalFileSize"
                                                        Display="Dynamic" ErrorMessage="Please enter number" ValidationExpression="[0-9]+" ForeColor="red"></asp:RegularExpressionValidator>
                                                </InsertItemTemplate>

                                                <ItemTemplate>
                                                    <asp:Label ID="lbMaxTotalFileSize" runat="server" Text='<%# Bind("MaxTotalFileSize") %>' Font-Bold="false"></asp:Label>
                                                </ItemTemplate>
                                                <HeaderTemplate>

                                                    <asp:Label ID="lblTotalMaxFileSize" runat="server" Text="Max. Total  File Size(MB)" CssClass="slds-form-element__label"></asp:Label>
                                                    <div class="slds-float_right">
                                                        <cc2:Help ID="Help2" runat="server" HelpMessageID="Resources.Help.MaxTotalSize"></cc2:Help>
                                                    </div>
                                                </HeaderTemplate>

                                            </asp:TemplateField>

                                            <asp:TemplateField HeaderText="How Many Days Attachment Links Expires?:" ItemStyle-CssClass="slds-p-vertical_xx-small">
                                                <EditItemTemplate>
                                                    <asp:TextBox ID="edLinkExpirationDays" runat="server" Text='<%# Bind("LinkExpirationDays") %>' CssClass="slds-input  slds-m-top--medium" Font-Bold="false"></asp:TextBox>
                                                    <asp:RegularExpressionValidator ID="regMaxFileSize" runat="server" ControlToValidate="edMaxFileSize"
                                                        Display="Dynamic" ErrorMessage="Please enter number" ValidationExpression="[0-9]+" Font-Bold="false"></asp:RegularExpressionValidator>
                                                </EditItemTemplate>
                                                <InsertItemTemplate>
                                                    <asp:TextBox ID="edLinkExpirationDays" runat="server" Text='<%# Bind("LinkExpirationDays") %>' Font-Bold="false"></asp:TextBox>
                                                    <asp:RegularExpressionValidator ID="regMaxFileSize" runat="server" ControlToValidate="edLinkExpirationDays"
                                                        Display="Dynamic" ErrorMessage="Please enter number" ValidationExpression="[0-9]+" ForeColor="red" Font-Bold="false"></asp:RegularExpressionValidator>
                                                </InsertItemTemplate>
                                                <ItemTemplate>
                                                    <asp:Label ID="lblLinkExpirationDays" runat="server" Text='<%# Eval("LinkExpirationDays") %>' Font-Bold="false"></asp:Label>
                                                </ItemTemplate>
                                                <HeaderTemplate>
                                                    <asp:Label ID="lblExpirationDaysHeader" runat="server" Text="Links Expiry Days" CssClass="slds-form-element__label"></asp:Label>
                                                    <div class="slds-float_right">
                                                        <cc2:Help ID="Help3" runat="server" HelpMessageID="Resources.Help.ExpireLink"></cc2:Help>
                                                    </div>
                                                </HeaderTemplate>
                                            </asp:TemplateField>

                                            <asp:TemplateField HeaderText="Base Url For View Links:" ItemStyle-CssClass="slds-p-vertical_xx-small">
                                                <EditItemTemplate>
                                                    <asp:TextBox ID="edBaseUrl" runat="server" Text='<%# Bind("BaseUrl") %>' CssClass="slds-input slds-m-top--medium" Font-Bold="false"></asp:TextBox>
                                                    <asp:RequiredFieldValidator ID="reqUrl" runat="server" ControlToValidate="edBaseUrl"
                                                        ErrorMessage="Field cant be empty" Display="Dynamic" ForeColor="red"></asp:RequiredFieldValidator>
                                                </EditItemTemplate>
                                                <InsertItemTemplate>
                                                    <asp:TextBox ID="edBaseUrl" runat="server" Text='<%# Bind("BaseUrl") %>' CssClass="slds-input slds-m-top--medium" Font-Bold="false"></asp:TextBox>
                                                    <asp:RequiredFieldValidator ID="reqUrl" runat="server" ControlToValidate="edBaseUrl"
                                                        ErrorMessage="Field cant be empty" Display="Dynamic" ForeColor="red" Font-Bold="false"></asp:RequiredFieldValidator>
                                                </InsertItemTemplate>

                                                <ItemTemplate>
                                                    <asp:Label ID="lbBaseUrl" runat="server" Text='<%# Bind("BaseUrl") %>' Font-Bold="false"></asp:Label>
                                                </ItemTemplate>
                                                <HeaderTemplate>
                                                    <asp:Label ID="lblBaseUrlHeader" runat="server" Text="Base URL Link" CssClass="slds-form-element__label"></asp:Label>
                                                    <div class="slds-float_right">
                                                        <cc2:Help ID="Help4" runat="server" HelpMessageID="Resources.Help.EmailSettingsBaseUrl"></cc2:Help>
                                                    </div>
                                                </HeaderTemplate>
                                            </asp:TemplateField>

                                            <asp:TemplateField ItemStyle-CssClass="slds-p-vertical_xx-small">
                                                <EditItemTemplate>
                                                     <div class="slds-m-top_medium">
                                                    <asp:Button ID="btnUpdate" runat="server" Text="Update" CommandName="Update" CausesValidation="true" CssClass="slds-button slds-button--brand  slds-m-top_medium"></asp:Button>

                                                    <asp:Button ID="btnCancel" runat="server" Text="Cancel" CommandName="Cancel" CausesValidation="False" CssClass="slds-button slds-button_neutral slds-m-top_medium"></asp:Button>
                                                     </div>
                                                     <asp:UpdateProgress ID="UpdateProgress1" runat="server" DisplayAfter="200">
                                                        <ProgressTemplate>
                                                            <div class="demo-only">
                                                                <div class="slds-spinner_container">
                                                                    <div role="status" class="slds-spinner slds-spinner_medium slds-spinner_brand">
                                                                        <span class="slds-assistive-text">Loading</span>
                                                                        <div class="slds-spinner__dot-a"></div>
                                                                        <div class="slds-spinner__dot-b"></div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </ProgressTemplate>
                                       </asp:UpdateProgress>
                                                </EditItemTemplate>
                                                <ItemTemplate>
                                                    <asp:Button ID="btnEdit" runat="server" Text="Edit" CommandName="Edit" CssClass="slds-button slds-button_neutral"></asp:Button>
                                                </ItemTemplate>
                                            </asp:TemplateField>
                                        </Fields>
                                        <FieldHeaderStyle />
                                        <HeaderStyle />
                                    </asp:DetailsView>
                                </div>
                            </ContentTemplate>
                        </asp:UpdatePanel>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div class="slds-grid slds-wrap">
        <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
            <asp:ObjectDataSource ID="odsServerSettings" runat="server" SelectMethod="GetSettingsByID"
                TypeName="enzigma.sforce.webapp.code.business.EmailDefaultSettings">
                <SelectParameters>
                    <asp:QueryStringParameter Name="strID" QueryStringField="ID" Type="String" />
                </SelectParameters>
            </asp:ObjectDataSource>
            <asp:HiddenField ID="hdnID" runat="server" />
        </div>
    </div>
</asp:Content>

