angular.module('deDemoApp', ['deServices', 'deForm', 'deTable', 'deLayout', 'deDrawing'])
	.controller('FieldSettingsDemoCtrl', ['$scope', function ($scope) {
		$scope.fields = [{
			label: 'Label',
			name: 'label',
			type: 'text',
			required: true,
			max: 80,
		}, {
			label: 'Is Required?',
			name: 'required',
			type: 'checkbox',
		}, {
			label: 'Is Readonly?',
			name: 'readonly',
			type: 'checkbox',
		}, ];

		$scope.record = {
			label: 'First Name',
			name: 'FirstName',
			type: 'text',
			required: true,
			max: 80,
		};
	}])
	.controller('FormSystemDemoCtrl', ['$scope', '$de', 'toaster', function ($scope, $de, toaster) {
		$scope.editMode = 'design';
		$scope.displayMode = 'inline';
		$scope.formLayout = 'de-form';
		$scope.fields = demo.data.fields;
		$scope.record = $de.getSampleRecords($scope.fields);
		$scope.actions = demo.data.actions;
	}])
	.controller('DrawingSystemDemoCtrl', ['$scope', '$de', 'toaster', function ($scope, $de, toaster) {
		if (localStorage.drawingdata) {
			$scope.data = JSON.parse(localStorage.drawingdata);
		}
		else {
			$scope.data = { shapes: [] }
			$scope.data.shapes.push(Shape.create('rect', 30, 30, 200, 200, 'This is test text, let\'s see what happens there is lot of text, does it wrap?This is test text, let\'s see what happens there is lot of text, does it wrap?'));
			$scope.data.shapes.push(Shape.create('diamond', 300, 120, 200, 200, 'This is test text, let\'s see what happens there is lot of text, does it wrap?This is test text, let\'s see what happens there is lot of text, does it wrap?'));
			$scope.data.shapes.push(Shape.create('ellipse', 600, 240, 200, 200, 'This is test text, let\'s see what happens there is lot of text, does it wrap?This is test text, let\'s see what happens there is lot of text, does it wrap?'));
			$scope.data.shapes.push(Shape.create('ellipse', 300, 320, 200, 200, 'This is test text, let\'s see what happens there is lot of text, does it wrap?This is test text, let\'s see what happens there is lot of text, does it wrap?'));
			$scope.data.shapes.push(Shape.createConnector($scope.data.shapes[0].id, 'east', $scope.data.shapes[1].id, 'west'));
			$scope.data.shapes.push(Shape.createConnector($scope.data.shapes[1].id, 'east', $scope.data.shapes[2].id, 'west'));
			$scope.data.shapes.push(Shape.createConnector($scope.data.shapes[2].id, 'east', $scope.data.shapes[3].id, 'west'));
		}

		$scope.save = function () {
			localStorage.drawingdata = JSON.stringify(angular.copy($scope.data));
			toaster.pop('success', 'Saved successfully.');
		}
		$scope.actions = [{
			icon: 'fa-save',
			action: 'save',
			onclick: function ($event, data) {
				$scope.save();
			}
		}, ]
	}])
	.controller('LayoutSystemDemoCtrl', ['$scope', '$de', 'toaster', function ($scope, $de, toaster) {		
	    $scope.mode = 'design';	    
		$scope.fields = demo.data.fields;
		var strLayout = localStorage.getItem('layout')
		$scope.layout = (strLayout != null && strLayout != '{}') ? JSON.parse(strLayout) : { "relatedlists": [], "tabs": [], "sections": [], "buttons": [], "icon": null, "label": "" };

		$scope.record = $de.getSampleRecords($scope.fields);
		$scope.relatedObjectsMap = demo.data.relatedObjectsMap['DemoObject'];
		$scope.relatedObjects = demo.data.relatedObjects;
		$scope.$on('fetchRecords', function (event, keyword, field, onsuccess, onerror) {
		    var records = [];
		    for (var iIndex = 1; iIndex <= 100; ++iIndex)
		        records.push({ Id: 'Organization-' + iIndex, Name: 'Organization-'+ iIndex });
		    if (keyword == 'error')
		        onerror('Could not reach the server');
		    else
		    onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });

		}, function (error) { onerror('Could not reach the server'); });
		$scope.onSave = function ($event, layout, action) {
			layout = angular.copy(layout);
			var cache = [];
			localStorage.setItem('layout', JSON.stringify(layout, function (key, value) {
				if (typeof value === 'object' && value !== null) {
					if (cache.indexOf(value) !== -1)
						return;
					cache.push(value);
				}
				$de.hideProgress();
				
				return value;
			}))
			cache = null;
			$de.showSuccess("Successfully save layout","Success");
			//localStorage.setItem('layout', JSON.stringify(layout));
		}

	}])
	.controller('ActionSystemDemoCtrl', ['$scope', '$de', 'toaster', '$sce', function ($scope, $de, toaster, $sce) {
		$scope.mode = 'design';
		$scope.fields = demo.data.fields;
		$scope.record = $de.getSampleRecords($scope.fields);
		$scope.actions = demo.data.actions;
		$scope.takeAction = function ($event, action, data) {
			action.onclick($event, action, data, function () { });
		}
	}])
	.controller('TableSystemDemoCtrl', ['$scope', '$de', '$filter', '$rootScope', function ($scope, $de, $filter, $rootScope) {
	    $scope.mode = 'design';
		$scope.$on('fetchRecords', function (event, keyword, field, onsuccess, onerror) {
		    var records = [];
		    for (var iIndex = 1; iIndex <= 100; ++iIndex)
		        records.push({ Id: 'Organization-' + iIndex, Name: 'Organization-' + iIndex });
		    if (keyword == 'error')
		        onerror('Could not reach the server');
		    else
		        onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });

		}, function (error) { onerror('Could not reach the server'); });
		
		$scope.actions = [];// demo.data.actions;
		$scope.multiRecordActions = [];
		//$scope.actions.push(
		//	{
		//	    icon: 'fa-trash',
		//	    action: 'delete',
		//	    type: 'danger',
		//	    label: 'Delete',
		//	    allowOnInvalidForm: true,
		//	    onclick: function ($event, action, data, oncomplete) {
		//	        if (data.type == 'single-record') {
		//	            $de.remove($scope.records_5, data.record);
		//	            $de.remove($scope.records_120, data.record);
		//	            oncomplete(true);
		//	        } else if (data.type == 'multi-record') {
		//	            angular.forEach(data.records, function (record) {
		//	                $de.remove($scope.records_5, record);
		//	                $de.remove($scope.records_120, record);
		//	            })
		//	            oncomplete(true);
		//	        }
		//	    },
		//	});
		var options = localStorage.getItem('relatedlist-options');
		if (!options) {
			$scope.options = {
				object: 'Account',
				fields: 'FirstName,LastName,Email,DoB',
				orderBy: '',
				criteria: '',
				pageSize: 5,
				currentPage: 0,
				mobileTitle: '{{record.FirstName}} {{record.LastName}}',
				fieldDefs: {
				    FirstName: { 'name': 'FirstName', 'label': 'First Name', 'type': 'text' },
				    LastName: { 'name': 'LastName', 'label': 'Last Name', 'type': 'text' },
				    Email: { 'name': 'Email', 'label': 'Email', 'type': 'email' },
				    DoB: { 'name': 'DoB', 'label': 'Date of Birth', 'type': 'date' },
				},
				//isHighLighted: true,
				tableHeading: "Design Table",
				multiTable: false,
				singleRecordActions: [],
			    multiRecordActions:[],
			}
		}
		else
			$scope.options = JSON.parse(options);
        $scope.options.buttons=angular.copy($scope.actions)
		$scope.options1 = angular.copy($scope.options);
		$scope.options2 = angular.copy($scope.options);
		$scope.options2.buttons = angular.copy($scope.actions);
		$scope.options2.pageSize = 5;
		$scope.options2.currentPage = 0;
		$scope.$watch('options1', function (newValue) {
			localStorage.setItem('relatedlist-options', JSON.stringify(newValue));
			$scope.options2.fieldDefs = newValue.fieldDefs;
			$scope.options2.fields = $scope.options1.fields;
			//$scope.$broadcast('relatedlist-refresh');
		}, true);


		var fields = angular.copy(demo.data.fields);
		fields.splice(fields.length - 1, 1);
		$scope.fields = fields;
		$scope.fieldsMap = {};
		angular.forEach(fields, function (field) {
			$scope.fieldsMap[field.name.toLowerCase()] = field;
		});
		

		$scope.calculateOrderBy = function (strOrderBy) {
			var orderBy = [];
			if (strOrderBy) {
				var orderByFields = strOrderBy.split(',');
				angular.forEach(orderByFields, function (orderByField) {
					var orderByParts = orderByField.split(' ');
					if (orderByParts[1] && orderByParts[1] == 'desc') {
						orderBy.push('-' + orderByParts[0]);
					}
					else
						orderBy.push(orderByParts[0]);
				})
			}
			return orderBy;
		}
		
		$scope.highLightRecord = function () { 
		    var recordToBeHighLight = { FirstName: "First Name", LastName: "Last Name", Email: "customer@designer.expert", DoB: "2017-11-09", isHighlighted: true, recordStatus: "success" };
		    $rootScope.$broadcast('refreshFromLocal', recordToBeHighLight);
		};

		$scope.getfields = function (onsuccess, onerror) {
			onsuccess({ fields: angular.copy($scope.fields) });
		}

		$scope.getfield = function (name, onsuccess, onerror) {
   
			var field = $scope.fieldsMap[name.toLowerCase()];
			if (field) {
				onsuccess({ field: angular.copy(field) });
			}
			else
				onerror('Field named [' + name + '] could not be found.');
		}

		$scope.getRecords = function (options, onsuccess, onerror, count) {
			setTimeout(function () {
			    if (options) {
					if (!count || isNaN(count)) count = 120;
					if (!$scope['records_' + count]) $scope['records_' + count] = $de.getSampleRecords($scope.fields, count);
					var records = $scope['records_' + count];
					var orderBy = $scope.calculateOrderBy(options.orderBy);
					options.currentPage = parseInt(options.currentPage);
					options.pageSize = parseInt(options.pageSize);

					var fieldDefs = [];

					delete options.fieldDefs.ObjType;
					angular.forEach(options.fieldDefs, function (value, key) {
					    fieldDefs.push(angular.copy(value))
					})
					var filteredRecords = (orderBy.length) ? $filter('orderBy')(records, orderBy) : records;
					var pagedRecords = (isNaN(options.pageSize) || options.pageSize <= 0) ? filteredRecords : filteredRecords.slice(options.currentPage * options.pageSize, (options.currentPage + 1) * options.pageSize)
					var result = {
						records: pagedRecords,
						totalCount: records.length,
						currentPage: options.currentPage,
						pageSize: options.pageSize,
						fieldDefs: fieldDefs,
						orderBy: options.orderBy,
					};
					onsuccess(result);
				}
				else
					onerror('No options specified');
			}, 30);
		}
	}])

