angular.module('deLayout', ['deServices', 'ng-sortable', 'deForm', 'ngAnimate', 'ui.bootstrap', 'deTable'])
	.factory('$deLayout', ['$filter', '$rootScope', '$compile', function ($filter, $rootScope, $compile) {
	    var $deLayout = {
	        layoutFields: {
	            all: [
					{ name: 'icon', type: 'icon', label: 'Icon', required: true },
					{ name: 'label', type: 'text', label: 'Label', max: 80, required: true },
	            ],
	        },
	        sectionFields: {
	            all: [
						{ name: 'icon', type: 'icon', label: 'Icon', required: true },
						{ name: 'label', type: 'text', label: 'Label', max: 80, required: true },
						{ name: 'layout', type: 'picklist', label: 'Layout', max: 80, values: ['auto', 'stacked', 'grid'] },
						{ name: 'showHeader', type: 'checkbox', label: 'Show Header' },
	            ],
	        },
	        removeDialogTemplate: function (dialogId, dialogTemplate, currentScope) {
	            $('#' + dialogId).fadeOut(300);
	            $('.modal-backdrop').fadeOut(300);
	            setTimeout(function () {
	                dialogTemplate.remove();
	                $('.modal-backdrop').remove();
	            }, 500)
	            $('body').removeClass('modal-open');
	            $('body').removeAttr('style');
	            currentScope.$destroy();
	        },
	        settingWizard: function (componentType, fields, callback, component) {
	            var settingsWizardDialog = '';
	            var settingsWizardScope = $rootScope.$new();

	            settingsWizardScope.component = {
	                fields: fields,
	                component: component,
	                isValidation: false,
	                componentName: (componentType == 'Field') ? component.name : null,
	                componentType: componentType + ' Visibility',
	                saveCallback: function (criteria) {
	                    if (settingsWizardScope.component.isValidation)
	                        criteria['Validation'] = true;
	                    callback(criteria, function () { settingsWizardScope.component.removeTemplate(); });

	                },
	                removeTemplate: function () {
	                    $deLayout.removeDialogTemplate('component-settings-id', settingsWizardDialog, settingsWizardScope);
	                },
	                changeType: function (currentType) {
	                    settingsWizardScope.component.isValidation = currentType;
	                    settingsWizardScope.component.componentType = componentType + (currentType ? ' Validation' : ' Visibility');
	                }
	            }
	            settingsWizardDialog = '<div id="component-settings-id" class="modal fade" tabindex="-1" role="dialog">\
											<div class="modal-backdrop fade in" style="height: 100%; width: 100%;"></div>\
											<div class="modal-dialog modal-lg" style="z-index: 9999;">\
												<div class="modal-content">\
													<div class="modal-header">\
														<button type="button" class="close" ng-click="component.removeTemplate()"><h4 aria-hidden="true"><i class="fa fa-times-circle"></i></span></h4></button>\
														<h4 class="modal-title">{{component.componentType}} : {{component.component.label}}</h4>\
													</div>\
													<div class="modal-body container-fluid container-border">\
														<div class="col-md-12 no-padding" ng-if="component.componentName != null">\
															<div class="no-padding col-md-4"></div>\
															<div class="col-md-4 no-padding">\
																<div class="col-md-6 text-center comp-type" ng-class="!component.isValidation ? \'vis-type\' : \'\'" ng-click="component.changeType(false)">Visibility</div>\
																<div class="col-md-6 text-center comp-type" ng-class="component.isValidation ? \'val-type\' : \'\'" ng-click="component.changeType(true)">Validation</div>\
															</div>\
															<div class="col-md-4"></div>\
														</div>\
														<div ng-if="!component.isValidation" de-layout-component-visibility="component.fields" componentname="component.componentName" oncancel="component.removeTemplate()" onsave="component.saveCallback(criteria)" criteria="component.component.visibilityCriteria"></div>\
														<div ng-if="component.isValidation" de-field-validation="component.fields" component="component.component" oncancel="component.removeTemplate()" onsave="component.saveCallback(criteria)">\
													</div>\
												</div>\
											</div>\
										</div>'
	            settingsWizardDialog = $compile(settingsWizardDialog)(settingsWizardScope);
	            $('body').append(settingsWizardDialog);
	            $('#component-settings-id').modal('show');
	        },
	        actionWizard: function (button, callback) {
	            var actionPopup = '';
	            actionPopupScope = $rootScope.$new();
	            actionPopupScope.component = { component: angular.copy(button) };
	            actionPopupScope.component.label = angular.copy(button.label);
	            actionPopupScope.component.saveCallback = function (component) {
	                callback(component, function () {
	                    actionPopupScope.component.removeTemplate();
	                });
	            }
	            actionPopupScope.component.removeTemplate = function () {
	                $deLayout.removeDialogTemplate('action-wizard-id', actionPopup, actionPopupScope);
	            }
	            actionPopup = '<div id="action-wizard-id" class="modal fade" tabindex="-1" role="dialog">\
									<div class="modal-backdrop fade in" style="height: 100%; width: 100%;"></div>\
									<div class="modal-dialog" style="z-index: 9999;width: 75%;">\
										<div class="modal-content">\
											<div class="modal-header">\
												<button type="button" class="close" ng-click="component.removeTemplate()"><h4 aria-hidden="true"><i class="fa fa-times-circle"></i></span></h4></button>\
												<h4 class="modal-title">Edit Button: {{component.label}}</h4>\
											</div>\
											<div class="modal-body container-fluid container-border">\
												<div button-action="component.component" oncancel="component.removeTemplate()" onsave="component.saveCallback(newComponent)"></div>\
											</div>\
										</div>\
									</div>'
	            actionPopup = $compile(actionPopup)(actionPopupScope);
	            $('body').append(actionPopup);
	            $('#action-wizard-id').modal('show');
	        },
	        previewLayout: function (layout, record) {
	            var previewDialog = '';
	            var previewScope = $rootScope.$new();
	            previewScope.component = {
	                layout: layout,
	                record: record,
	                height: (screen.availHeight - 190),
	                removeTemplate: function () {
	                    $deLayout.removeDialogTemplate('preview-layout-id', previewDialog, previewScope);
	                }
	            };
	            previewScope.editMode = "read-only";
	            previewScope.$watch('editMode', function (newVal, oldVal) {
	                previewScope.$broadcast('modeChange', true);
	            })
	            previewDialog = '<div id="preview-layout-id" class="modal fade" tabindex="-1" role="dialog">\
										<div class="modal-backdrop fade in" style="height: 100%; width: 100%;"></div>\
										<div class="modal-dialog" style="z-index: 9999;">\
											<div class="modal-content">\
												<div class="modal-header">\
													<button type="button" class="close" ng-click="component.removeTemplate()"><h4 aria-hidden="true"><i class="fa fa-times-circle"></i></span></h4></button>\
													<h4 class="modal-title">Previewing Layout: {{component.layout.label}}</h4>\
												</div>\
												<div class="extended-modal-body container-fluid" style="overflow:vissible">\
												<center>\
                                                    <form class="radio radio-success">\
                                                        <label class="radio-inline"><input type="radio" ng-model="editMode" value="read-only">Read-Only</label>\
                                                        <label class="radio-inline"><input type="radio" ng-model="editMode" value="edit">Edit</label>\
                                                    </form>\
	                                                </center>\
                                                    <div class="padd-top" de-layout="component.layout" edit-mode="editMode" display-mode="\'edit\'" ng-model="component.record" ></div>\
													<div class="padd-top"></div>\
												</div>\
											</div>\
										</div>';
	            previewDialog = $compile(previewDialog)(previewScope);
	            $('body').append(previewDialog);
	            $('#preview-layout-id').modal('show');
	        },
	        actionbarSetting: function (options, callback, multitableOption) {
	            var actionbarSetting = ''
	            var actionbarSettingScope = $rootScope.$new();
	            actionbarSettingScope.component = {
	                options: options,
	                multitableOption: multitableOption,
	                height: (screen.availHeight - 190),
	                removeTemplate: function () {
	                    $deLayout.removeDialogTemplate('actionbar-setting-id', actionbarSettingDialog, actionbarSettingScope);
	                }
	            };
	            actionbarSettingScope.component.selected = actionbarSettingScope.component.options.selected;
	            actionbarSettingScope.component.saveCallback = function (selected, multitableOption) {
	                callback(selected, function () {
	                    actionbarSettingScope.component.removeTemplate();
	                }, multitableOption);
	            }
	            actionbarSettingDialog = '<div id="actionbar-setting-id" class="modal fade" tabindex="-1" role="dialog">\
										<div class="modal-backdrop fade in" style="height: 100%; width: 100%;"></div>\
										<div class="modal-dialog" style="z-index: 9999;width: 50%;">\
											<div class="modal-content">\
												<div class="modal-header">\
													<button type="button" class="close" ng-click="component.removeTemplate()"><h4 aria-hidden="true"><i class="fa fa-times-circle"></i></span></h4></button>\
													<h4 class="modal-title">{{component.options.header}} Setting</h4>\
												</div>\
												<div class="extended-modal-body container-fluid" style="max-height: {{component.height}}px;overflow:auto">\
                                                   <div class="padd-top">\
                                                   <form class="form-horizontal">\
                                                      <div class="form-group">\
                                                        <label for="select" class="control-label col-sm-4">Select Option</label>\
                                                         <div class="col-sm-4">\
                                                            <select class="form-control" id="sel1" ng-model="component.selected"><option ng-repeat="loc in component.options.option" value="{{loc.value}}">{{loc.key}}</option></select>\
                                                         </div>\
                                                     </div>\
                                                     <div class="form-group" ng-if="component.multitableOption!=undefined">\
                                                            <label class="control-label col-sm-4">MultiTable</label>\
                                                            <div class="col-sm-4 checkbox">\
		                                                        <input type="checkbox" class="" ng-model="component.multitableOption">\
                                                            </div>\
                                                    </div>\
                                                    </form>\
                                                  </div>\
												</div>\
                                                <div class="modal-footer">\
                                                        <button type="button" class="btn btn-sm btn-primary" ng-click="component.saveCallback(component.selected, component.multitableOption)">Save</button>\
                                                        <button type="button" class="btn btn-sm btn-default" data-dismiss="modal">Close</button>\
                                                </div>\
											</div>\
										</div>';
	            actionbarSettingDialog = $compile(actionbarSettingDialog)(actionbarSettingScope);
	            $('body').append(actionbarSettingDialog);
	            $('#actionbar-setting-id').modal('show');
	        },
	        criteriaEditor: function (fields, callback, relatedlist) {
	            var editorDialog = '';
	            var editorScope = $rootScope.$new();
	            editorScope.component = {
	                relatedlist: relatedlist,
	                removeTemplate: function () {
	                    $deLayout.removeDialogTemplate('criteria-editor-id', editorDialog, editorScope);
	                },
	                saveCriteria: function (criteria) {
	                    callback(false, criteria, function (success, errormessage) {
	                        if (success) {
	                            callback(true, criteria, function () {
	                                editorScope.component.removeTemplate();
	                            })
	                        } else
	                            editorScope.component.errorHandler(success, errormessage);
	                    })
	                },
	                criteriaValidator: function (criteria) {
	                    callback(false, criteria, editorScope.component.errorHandler)
	                },
	                errorHandler: function (success, message) {
	                    editorScope.component.validCriteria = success;
	                    editorScope.component.message = message;
	                }
	            };
	            editorDialog = '<div id="criteria-editor-id" class="modal fade" tabindex="-1" role="dialog">\
									<div class="modal-backdrop fade in" style="height: 100%; width: 100%; position: fixed;"></div>\
									<div class="modal-dialog" style="z-index: 9999;width: 50%;">\
										<div class="modal-content">\
											<div class="modal-header">\
												<button type="button" class="close" ng-click="component.removeTemplate()"><h4 aria-hidden="true"><i class="fa fa-times-circle"></i></span></h4></button>\
												<h4 class="modal-title">Criteria Editor: {{component.relatedlist.options.relatedListLabel}}</h4>\
											</div>\
											<div class="modal-body container-fluid">\
												<div class="col-md-12 form-group">\
													<div ng-if="component.message" class="alert" ng-class="(!component.validCriteria ? \'alert-danger\' : \'alert-success\')" role="alert">{{component.message}}</div>\
												</div>\
												<div class="col-md-12 form-group">\
													<label class="label label-default">Where Logic: </label>\
												</div>\
												<div class="col-md-12 form-group">\
													<textarea class="form-control" ng-model="component.relatedlist.criteria"/>\
												</div>\
												<div class="col-md-12 form-group">\
													<div class="col-md-5 text-right">\
														<button type="button" ng-click="component.criteriaValidator(component.relatedlist.criteria)" class="btn btn-default">Validate Criteria</button>\
													</div>\
													<div class="col-md-2 no-padding text-center">\
														<button type="button" ng-click="component.saveCriteria(component.relatedlist.criteria)" class="btn btn-default">Save Criteria</button>\
													</div>\
													<div class="col-md-5">\
														<button type="button" ng-click="component.removeTemplate()" class="btn btn-default">Cancel</button>\
													</div>\
												</div>\
											</div>\
										</div>\
									</div>\
								</div>';
	            editorDialog = $compile(editorDialog)(editorScope);
	            $('body').append(editorDialog);
	            $('#criteria-editor-id').modal('show');
	        }
	    }
	    angular.forEach($deLayout.layoutFields.all, function (field) { $deLayout.layoutFields[field.name] = field; });
	    angular.forEach($deLayout.sectionFields.all, function (field) { $deLayout.sectionFields[field.name] = field; });
	    return $deLayout;
	}])
	.directive('deLayoutEditor', ['$de', function ($de) {
	    return {
	        restrict: 'A',
	        templateUrl: $de.templatesFolder + 'layout-editor.htm',
	        scope: {
	            fields: '=deLayoutEditor',
	            layout: '=ngModel',
	            onSave: '&',
	            onCancel: '&',
	            relatedObjects: '=?',
	            relatedObjectsMap: '=?',
	            relatedRecordId: '=?',
	            record: '=?'
	        },
	        controller: ['$scope', '$attrs', '$element', '$de', '$deLayout', '$deForm', '$timeout', '$compile', '$templateCache', '$filter', function ($scope, $attrs, $element, $de, $deLayout, $deForm, $timeout, $compile, $templateCache, $filter) {
	            $scope.$de = $de;
	            $scope.$de.initUIControl($element, $scope, $attrs);
	            $scope.newRelatedlist = function () { return { id: $de.getUniqueId(), label: 'Blank Relatedlist', options: {}, actions: [], multirecordactions: [] }; }
	            $scope.newSection = function () { return { label: 'Blank Section', fields: [] }; }
	            $scope.newTab = function () { return { id: $de.getUniqueId(), label: 'Blank Tab', sections: [$scope.newSection()], relatedlists: [] }; }
	            $scope.newButton = function () { return { id: $de.getUniqueId(), label: 'Blank Button', action: '', name: ('Button' + ($scope.layout.buttons ? ($scope.layout.buttons.length + 1) : 'Button1')), type: 'default', label: 'New Button', actionType: 'layoutActions', isStandardAction: true }; }


	            $scope.capitalize = function (str) { return str[0].toUpperCase() + str.slice(1); }

	            $scope.mapComponentText = {
	                tab: 'Drag and drop to add new tab in main section.',
	                section: 'Drag and drop to add new section in any tab in main section.',
	                relatedlist: 'Drag and drop to add new related list.',
	                button: 'Drag and drop to add new button.'
	            }

	            $scope.dynamicPopover = {
	                templateUrl: $de.templatesFolder + 'dynamic-popover.htm'
	            }

	            $scope.sectionComponents = [$scope.newSection()];
	            $scope.tabComponents = [$scope.newTab()];
	            $scope.relatedlistComponents = [$scope.newRelatedlist()];
	            $scope.buttons = [$scope.newButton()];

	            if (!$scope.record)
	                $scope.record = $de.getSampleRecords($scope.fields, 1);
	            $scope.$on('SaveFieldCriteria', function (event, sectionIndex, fieldIndex, field) {
	                $scope.layout.sections[sectionIndex].fields[fieldIndex] = field;
	                $scope.onsave(event, $scope.layout);
	            })
	            $scope.$watch('fieldKeyword', function (newValue) {
	                $scope.filteredFields = $filter('filter')($scope.fields, newValue);
	                $scope.adjustHeight(1);
	            })

	            $scope.editorActions = [
                    {
                        type: 'primary',
                        label: 'Preview',
                        action: 'Preview'
                    }, {
                        type: 'success',
                        label: 'Save',
                        action: 'Save'
                    }, {
                        type: 'warning',
                        label: 'Save & Close',
                        action: 'Save&Close'
                    }, {
                        type: 'default',
                        label: 'Cancel',
                        action: 'Cancel'
                    }
	            ]

	            $scope.takeAction = function ($event, action) {
	                switch (action.action) {
	                    case 'Preview': $deLayout.previewLayout(angular.copy($scope.layout), angular.copy($scope.record)); break;
	                    case 'Save': $de.showProgress(); $scope.onSave({ '$event': $event, 'layout': $scope.layout }); break;
	                    case 'Save&Close': $de.showProgress(); $scope.onSave({ '$event': $event, 'layout': $scope.layout, 'action': action.action }); break;
	                    case 'Cancel': $scope.onCancel({ '$event': $event }); break;
	                }
	            }

	            $scope.sortComponents = {
	                relatedlistComponents: { group: { name: 'relatedlists', pull: 'clone', put: false } },
	                sectionComponents: { group: { name: 'sections', pull: 'clone', put: false } },
	                tabComponents: { group: { name: 'tabs', pull: 'clone', put: false } },
	                fieldComponents: { group: { name: 'fields', pull: 'clone', put: false } },
	                buttons: { group: { name: 'buttons', pull: 'clone', put: false } },
	                relatedLists: { group: { name: 'relatedlists', pull: false, put: true } },
	                relatedObjects: { group: { name: 'relatedobjects', pull: 'clone', put: false } }
	            }

	            $scope.headerHeight = '0px';
	            var flag = true;
	            $scope.adjustHeight = function (index) {
	                if (flag) {
	                    $timeout(function () {
	                        $scope.componentwidth = { 'width': $('#layoutdesignid').width() - 4 + 'px' };
	                    }, 20);
	                    flag = false;
	                }
	                $timeout(function () {
	                    $scope.headerheight = { 'top': $('#componentid').height() + 'px', };
	                }, 10);
	            }
	            $timeout(function () { $scope.adjustHeight(0); }, 50);

	            $(window).resize(function () {
	                setTimeout(function () {
	                    $scope.componentwidth = { 'width': $('#layoutdesignid').width() - 4 + 'px' };
	                    if (!$scope.$$phase && !$scope.$root.$$phase)
	                        $scope.$apply();
	                }, 500);
	                setTimeout(function () {
	                    $scope.headerheight = { 'top': $('#componentid').height() + 'px' };
	                    if (!$scope.$$phase && !$scope.$root.$$phase)
	                        $scope.$apply();
	                }, 1000);
	            });
	        }]
	    }
	}])
	.directive('deLayout', ['$de', '$engine', '$UIEngine', function ($de, $engine) {
	    return {
	        restrict: 'A',
	        template: '<div class="layout" ng-include="templateUrl"></div>',
	        scope: {
	            layout: '=deLayout',
	            editMode: '=',
	            displayMode: '=',
	            record: '=ngModel',
	            objFields: '=fields',
	            relatedObjectsMap: '=?',
	            relatedRecordId: '=?',
	        },
	        controller: ['$scope', '$attrs', '$element', '$de', '$deLayout', '$deForm', '$timeout', '$compile', '$templateCache', '$filter', '$UIEngine', '$rootScope', '$interpolate', function ($scope, $attrs, $element, $de, $deLayout, $deForm, $timeout, $compile, $templateCache, $filter, $UIEngine, $rootScope, $interpolate) {
	            $scope.$de = $de;
	            $scope.$de.initUIControl($element, $scope, $attrs);
	            $scope.attrs = $attrs;
	            $scope.fields = $deLayout.layoutFields;
	            $scope.id = (!$attrs.id) ? $de.getUniqueId() : $attrs.id;
	            $element.attr('id', $scope.id);
	            $scope.oldRecord = angular.copy($scope.record);
                $rootScope.rec = angular.copy($scope.record);
                var relatedLists = angular.copy($scope.layout.relatedlists); 
                //added bellow method to handle tha account object detailelayout condition
                $rootScope.removeRelatedlist = function (bussinessTypeValue) {
                    if ($scope.record.obj_type == 'account'){
                        if (bussinessTypeValue.toLowerCase() != "personal" && bussinessTypeValue.toLowerCase() != "family" && bussinessTypeValue.toLowerCase() != "")
                        {
                            var tempRealatedList = angular.copy(relatedLists);     
                            //remove account,invoice,user
                            var ralatedListToRemove1 = ["parent_account_id", "customer_account_id", "account_id", "account_id", "account_id" ];
                            angular.forEach(ralatedListToRemove1, function (relatedlistName) {
                                var index = -1
                                if (relatedlistName == "customer_account_id")
                                    index = tempRealatedList.findIndex(x => x.options.relatedObjectName == relatedlistName);
                                else
                                    index = tempRealatedList.findIndex(x => x.options.relatedObjectName == relatedlistName && x.options.object != 'store_product' && x.options.object != 'invoice');
                                if (index > -1)
                                    tempRealatedList.splice(index, 1);
                            })
                            $scope.layout.relatedlists = angular.copy(tempRealatedList);
                        }
                        else 
                        {
                            var tempRealatedList = angular.copy(relatedLists);     
                            //remove invoice and store_product
                            var ralatedListToRemove2 = ["account_id", "account_id"];
                            angular.forEach(ralatedListToRemove2, function (relatedlistName) {
                                var index = tempRealatedList.findIndex(x => x.options.relatedObjectName == relatedlistName && x.options.object != 'user');
                                if (index > -1)
                                    tempRealatedList.splice(index, 1);
                            })
                            $scope.layout.relatedlists = angular.copy(tempRealatedList);     
                                  
                        }             
                    }
                }
                $rootScope.removeRelatedlist($scope.record.business_type_code__r ? $scope.record.business_type_code__r.name : "");

	            $scope.saveVisibiltyCriteria = function (criteria, closeDialog) {
	                if (Object.keys(criteria).length == 0)
	                    delete $scope.layout.tabs[$scope.layout.tabs.indexOf($scope.currentTab)].visibilityCriteria;
	                else
	                    $scope.layout.tabs[$scope.layout.tabs.indexOf($scope.currentTab)].visibilityCriteria = JSON.stringify({ criteria: criteria });
	                closeDialog();
	            }

	            $scope.openSettingWizard = function ($event, tab) {
	                $scope.currentTab = tab;
	                $deLayout.settingWizard('Tab', $scope.objFields, $scope.saveVisibiltyCriteria, tab);
	            }

	            $scope.sortComponents = {
	                sections: { group: { name: 'sections', pull: true, put: true, handle: '.handle' }, onAdd: function (evt) { evt.model.id = $de.getUniqueId(); } },
	                tabRelatedlists: {
	                    group: { name: 'relatedlists', pull: true, put: true, handle: '.handle' }, onAdd: function (evt) {
	                        var index = evt.models.indexOf(evt.model);
	                        $scope.refresList[index] = true;
	                        tabIndex = $de.search($scope.layout.tabs, "id", $scope.layout.activeTabId)
	                        if (tabIndex == -1)
	                            tabIndex = 0;
	                        $scope.selectedObject(evt.model, index, true, tabIndex);
	                    },
	                },
	                relatedlists: {
	                    group: { name: 'relatedlists', pull: false, put: true, }, onAdd: function (evt) {
	                        var index = evt.models.indexOf(evt.model);
	                        $scope.refresList[index] = true;
	                        $scope.selectedObject(evt.model, index);
	                    }
	                },
	                tabs: { group: { name: 'tabs', pull: true, put: true }, onAdd: function (evt) { evt.model.id = $de.getUniqueId(); $scope.layout.activeTabId = evt.model.id } },
	                outersection: { group: { name: 'sections', pull: true, put: true }, onAdd: function (evt) { evt.model.id = $de.getUniqueId(); } },
	                buttons: { group: { name: 'buttons', pull: true, put: true } }
	            }

	            //New Changes Relatedlist
	            $scope.refresList = {};
	            $scope.listActions = [
					{ action: 'refresh', label: 'Refresh', icon: 'fa-refresh', type: 'default' },
					{ action: 'settings', label: 'Settings', icon: 'fa-cog', type: 'default' },
					{ action: 'remove', label: 'Delete', icon: 'fa-trash', type: 'default' }
	            ];

	            $scope.takeDesignAction = function ($event, action, index, tabRelatedist) {
	                switch (action.action) {
	                    case 'refresh':
	                        $scope.refresList[index] = !$scope.refresList[index];
	                        break;
	                    case 'remove':
	                        //var currentObj = $scope.layout.relatedlists[index].options.object;
	                        //if (mappedObjectCount[currentObj] <= 1) {
	                        //    delete fieldsMap[currentObj];
	                        //    delete mappedObjectCount[currentObj];
	                        //} else
	                        //    --mappedObjectCount[currentObj];
	                        if (tabRelatedist)
	                            $scope.layout.tabs[$de.search($scope.layout.tabs, "id", $scope.layout.activeTabId)].relatedlists.splice(index, 1);
	                        else
	                            $scope.layout.relatedlists.splice(index, 1);
	                        break;
	                    case 'settings':
	                        $scope.criteriaIndex = index;
	                        $deLayout.criteriaEditor($scope.relatedObjectsMap[$scope.layout.relatedlists[index].object], $scope.saveCriteria, $scope.layout.relatedlists[index]);
	                        break;
	                }
	            }

	            var fieldsMap = {};
	            var mappedObjectCount = {};
	            //method to provide criteria to related list
	            $scope.saveCriteria = function (isSave, newCriteria, closeCallback) {
	                if (isSave) {
	                    $scope.layout.relatedlists[$scope.criteriaIndex].displayCriteria = JSON.stringify({ criteria: newCriteria });
	                    closeCallback();
	                } else {
	                    if (newCriteria != undefined || newCriteria) {
	                        if (newCriteria.length < 10)
	                            closeCallback(false, 'Criteria you have given seems not working.');
	                        else
	                            closeCallback(true, 'Criteria you have given seems working.');
	                    }
	                    else
	                        closeCallback(false, 'Provide Criteria First');
	                }
	            }

	            //method to sort table record by column
	            $scope.calculateOrderBy = function (strOrderBy) {
	                var orderBy = [];
	                if (strOrderBy) {
	                    var orderByFields = strOrderBy.split(',');
	                    angular.forEach(orderByFields, function (orderByField) {
	                        var orderByParts = orderByField.split(' ');
	                        if (orderByParts[1] && orderByParts[1] == 'desc')
	                            orderBy.push('-' + orderByParts[0]);
	                        else
	                            orderBy.push(orderByParts[0]);
	                    })
	                }
	                return orderBy;
	            }

	            //method call to create map when we are in design mode
	            $scope.setDetails = function (options, index) {

	                if (!fieldsMap[options.object]) {
	                    var obj = {};
	                    delete options.fieldDefs.ObjType;
	                    angular.forEach(options.fieldDefs, function (field) {
	                        obj[field.name.toLowerCase()] = field;
	                    });
	                    fieldsMap[options.object] = obj;
	                }
	            }

	            //method to get records for related list object
	            $scope.getRecords = function (options, onsuccess, onerror, count) {
	                if (options.type == "relatedInnerObject") {
	                    var fieldDefs = [];
	                    delete options.fieldDefs.ObjType;
	                    angular.forEach(options.fieldDefs, function (value, key) {
	                        fieldDefs.push(angular.copy(value))
	                    })
	                    var pagedRecords = $scope.record[options.object];
	                    var result = {
	                        records: (pagedRecords) ? pagedRecords : [],
	                        totalCount: (pagedRecords) ? pagedRecords.length : 0,
	                        currentPage: options.currentPage,
	                        pageSize: 100,
	                        fieldDefs: fieldDefs,
	                        orderBy: options.orderBy,
	                    };
	                    onsuccess(result);
	                }
	                else
	                    $engine.getRecords(options, onsuccess, onerror);
	            }

	            //method call when we add field from multiselect
	            $scope.getfield = function (objname, name, onsuccess, onerror) {

	                var field = fieldsMap[objname][name.toLowerCase()];
	                if (field)
	                    onsuccess({ field: angular.copy(field) });
	                else
	                    onerror('Field named [' + name + '] could not be found.');
	            }

	            //method create field map with related objects 
	            $scope.getFields = function (obj, onsuccess, onerror) {

	                var mapField = {};
	                if (fieldsMap[obj]) {
	                    var fields = [];
	                    angular.forEach(Object.keys(fieldsMap[obj]), function (field) {
	                        fields.push(fieldsMap[obj][field]);
	                    });
	                    onsuccess({ fields: fields });
	                    mappedObjectCount[obj] = ++mappedObjectCount[obj];
	                }
	                else {
	                    angular.forEach($scope.relatedObjectsMap[obj], function (field) {
	                        mapField[field.name.toLowerCase()] = field;
	                    });
	                    fieldsMap[obj] = mapField;
	                    onsuccess({ fields: angular.copy($scope.relatedObjectsMap[obj]) });
	                    mappedObjectCount[obj] = 1;
	                }
	            }

	            //method call when we add any related list in layout 
	            $scope.selectedObject = function (relatedObject, index, addToTab, tabIndex) {
	                var relatedList = {
	                    id: $de.getUniqueId(),
	                    options: {
	                        index: index,
	                        object: relatedObject.ObjectName.Name,
	                        fields: 'Name',
	                        fieldDefs: { 'ObjType': 'JsonObject', 'Name': { 'ObjType': 'JsonObject', 'name': 'Name', 'label': 'Name', 'type': 'text', 'linkdetails': { 'ObjType': 'JsonObject', 'url': 'r/{{record.Id}}', 'target': '_blank' } } },
	                        orderBy: '',
	                        criteria: "[" + relatedObject.Name + "]" + "='{{$root.relatedListRecord.Id}}'",
	                        pageSize: 5,
	                        currentPage: 0,
	                        mobileTitle: '{{record.Name}}',
	                        multiRecordActions: [{ "ObjType": "JsonObject", "name": "Create", "label": "Create", "action": "function(selectedRecords,parentRecord,callback) {\n $UIEngine.create(selectedRecords,parentRecord,callback); \n}", "type": "primary", "isStandardAction": true, "singleRecordAction": false, "actionType": "tableMultiRecordActions", "css": "btn-sm", "mode": "read-only", "id": "id_1491554412670", "customFunction": "function(selectedRecords,parentRecord,callback) {\n $UIEngine.create(selectedRecords,parentRecord,callback); \n}" }, { "ObjType": "JsonObject", "name": "Delete", "label": "Delete", "action": "function(selectedRecords,parentRecord,callback) { \n $UIEngine.delete(selectedRecords,parentRecord,callback);  \n }", "type": "danger", "isStandardAction": true, "singleRecordAction": false, "actionType": "tableMultiRecordActions", "css": "btn-sm", "mode": "read-only", "id": "id_1491554426110", "customFunction": "function(selectedRecords,parentRecord,callback) { \n $UIEngine.delete(selectedRecords,parentRecord,callback);  \n }" }],
	                        singleRecordActions: [{ "ObjType": "JsonObject", "name": "Edit", "label": "Edit", "action": "function(record,parentRecord,callback) {$UIEngine.edit(record,parentRecord,callback); }", "type": "primary", "isStandardAction": true, "singleRecordAction": true, "actionType": "tableSignleRecordActions", "css": "btn-sm", "mode": "read-only", "id": "id_1491554433765", "customFunction": "function(record,parentRecord,callback) {$UIEngine.edit(record,parentRecord,callback); }" }, { "ObjType": "JsonObject", "name": "Delete", "label": "Delete", "action": "function(record,parentRecord,callback) {\n $UIEngine.delete(record,parentRecord,callback); \n}", "type": "danger", "isStandardAction": true, "singleRecordAction": true, "actionType": "tableSignleRecordActions", "css": "btn-sm", "mode": "read-only", "id": "id_1491554420214", "customFunction": "function(record,parentRecord,callback) {\n $UIEngine.delete(record,parentRecord,callback); \n}" }],
	                        relatedListLabel: (relatedObject.ObjectName) ? relatedObject.ObjectName.Label : relatedObject.label + ' Relatedlist',
	                        referenceField: (relatedObject.Name) ? relatedObject.Name : relatedObject.reference_object_name,
                            type: "relatedObject",
                           
	                    }
	                };
	                if (!relatedObject.Name) {
	                    relatedList.options.criteria = "c." + relatedObject.name + " = '" + $rootScope.relatedListRecord.Id + "'";
                        relatedList.options.fields = 'id';
                        relatedList.options.fieldDefs = { 'ObjType': 'JsonObject', 'id': { 'ObjType': 'JsonObject', 'name': 'id', 'label': 'Id', 'type': 'text', 'linkdetails': { 'ObjType': 'JsonObject', 'url': 'r/{{record.Id}}', 'target': '_blank' } } }
                        relatedList.options.reference_name = relatedObject.reference_name;
                        relatedList.options.relatedObjectName = relatedObject.name;

                    }
	                if (relatedObject.type == "array") {
	                    relatedList.options.criteria = "";
                        relatedList.options.multiRecordActions = [{ "ObjType": "JsonObject", "name": "Create", "label": "Create", "action": "function(selectedRecords,parentRecord,callback) {\n $scope.addRecord(); \n}", "type": "primary", "isStandardAction": true, "singleRecordAction": false, "actionType": "tableMultiRecordActions", "css": "btn-sm", "mode": "read-only", "id": "id_1491554412670", "customFunction": "function(selectedRecords,parentRecord,callback) {\n $scope.addRecord(); \n}" } ];
	                    relatedList.options.singleRecordActions = [];
	                    relatedList.options.type = "relatedInnerObject";
	                }

	                if (addToTab) {
	                    $scope.layout.tabs[tabIndex].relatedlists[index] = relatedList;
	                }
	                else
	                    $scope.layout.relatedlists[index] = relatedList;
	            }

	            //related list changes end 

	            //New Changes Relatedlist ends here
                $scope.errorHandler = function (errorDescription, errorMessage) {
                    //$de.showError(errorMessage, 'Error', '');
                    $de.showError(errorDescription, errorMessage ? errorMessage: 'Error', '');
	                $scope.disabledAllAction(false);
	            }

	            $scope.successHandler = function (message) {
	                $de.showSuccess(message, 'Success', '');
	                $scope.disabledAllAction(false);
	            }

	            $scope.onEdit = function (record, sucess, error) {
	                $scope.editMode = 'edit';
	            }
	            $scope.onSave = function (record, success, error) {
	                $engine.upsert(record, true, function (error) {
	                    if (error.success) {
	                        $scope.editMode = 'read-only'
	                        success("Record Saved Successfully")
	                    }
	                    else
	                        error((error.data.Data) ? error.data.Data[0].ErrorMessage : error.data.ErrorMessage, (error.data.Data) ? error.data.Data[0].Code : error.data.Code)
	                });
	            }
	            $scope.onDelete = function (record, success, error) {
	                $engine.delete(record, true, function (error) {
	                    if (error.success)
	                        success("Record Deleted Successfully")
	                    else
	                        utills.showError(error.data.ErrorMessage);
	                });
	            }
	            $scope.disabledAllAction = function (isDisabled) {
	                $scope.allActionDisabled = isDisabled;
	            }

	            //Preview mode change from edit to read-only and back-n-forth.
	            $scope.$on('modeChange', function (testing) {
	                $scope.disabledAllAction(true);
	            })

                $scope.callAction = function (action) {
                        try {
                            eval('var execute = ' + action + '($scope.record, $scope.errorHandler, $scope.successHandler, $scope.$root.errorMessage)');
                            if (!$scope.$$phase && !$scope.$root.$$phase)
                                $scope.$apply();
                        } catch (exception) {
                            $scope.errorHandler(exception.message);
                        }
	            }
	            $scope.saveButtonAction = function (button, closeCallback) {
	                var stopExecution = false;
	                if (/^[a-zA-Z0-9_]*[^_]$/.test(button.name)) {
	                    for (var i = 0; i < $scope.layout.buttons.length; ++i) {
	                        if ($scope.layout.buttons[i].name == button.name && $scope.layout.buttons[i].id != button.id) {
	                            stopExecution = true;
	                            break;
	                        }
	                    }
	                    if (stopExecution) {
	                        $scope.errorHandler('Duplicate button name not allowed.Button ' + button.name + ' already exist.');
	                        return;
	                    }
	                } else {
	                    $scope.errorHandler('The name can only contain underscores and alphanumeric characters. It must begin with a letter and be unique, and must not include spaces, end with an underscore, or contain two consecutive underscores.');
	                    return;
	                }
	                $scope.layout.buttons[$scope.buttonIndex] = button;
	                closeCallback();
	            }
	            $scope.editButton = function (index) {
	                $scope.buttonIndex = index;
	                $deLayout.actionWizard($scope.layout.buttons[$scope.buttonIndex], $scope.saveButtonAction);
	            }
	            $scope.deleteButton = function ($event, button) {
	                $event.preventDefault();
	                $event.stopPropagation();
	                $de.remove($scope.layout.buttons, button);

	            }
	            $scope.actionbarCallback = function (location, callback) {
	                $scope.layout.actionbarPosition = location;
	                callback();
	            }
	            var showButton = { option: [{ key: "Show On Top", value: "ShowOnTop" }, { key: "Show On Bottom", value: "ShowOnBottom" }, { key: "Show On Top and Bottom", value: "ShowOnTopAndBottom" }, { key: "Hide Actions", value: "HideActions" }], header: "Action Bar" }
	            $scope.actionbarSetting = function () {
	                showButton.selected = ($scope.layout.actionbarPosition) ? $scope.layout.actionbarPosition : "ShowOnTop";
	                $deLayout.actionbarSetting(showButton, $scope.actionbarCallback);
	            }
	            $scope.deleteTab = function ($event, tab) {
	                $event.preventDefault();
	                $event.stopPropagation();
	                var del = window.confirm("Are you sure you want to delete Tab?");
	                if (del == true) {
	                    $de.remove($scope.layout.tabs, tab);
	                    if ($scope.layout.tabs.length > 0)
	                        $scope.layout.activeTabId = $scope.layout.tabs[$scope.layout.tabs.length - 1].id;
	                }
	            }

	            $scope.activateTab = function ($event, tab) {
	                $scope.layout.activeTabId = tab.id;
	            }

	            $scope.serverCriteriaContainer = {};
	            $scope.criteriaContainer = {};

	            $scope.operators = {
	                '==': function (a, b) { return a === b },
	                '!=': function (a, b) { return a != b },
	                '<=': function (a, b) { return a <= b },
	                '>=': function (a, b) { return a >= b },
	                '>': function (a, b) { return a > b },
	                '<': function (a, b) { return a < b },
	                'starts with': function (a, b) { return a.startsWith(b) },
	                'contains': function (a, b) { return a.indexOf(b) >= 0 },
	                'does not contain': function (a, b) { return a.indexOf(b) < 0 }
	            };

	            $scope.mapOperator = { 'or': '||', 'and': '&&', '(': '(', ')': ')' };

	            $scope.validateCondition = function (value) {
	                var evalCriteria;
	                if ($scope.record[value[0]] != undefined) {
	                    var valueInRecord = $scope.record[value[0]];
	                    if ($scope.record[value[0]] instanceof Date)
	                        valueInRecord = $filter('date')($scope.record[value[0]], 'yyyy/MM/dd');
	                    if (value[2] instanceof Array)
	                        evalCriteria = $scope.operators[value[1]](value[2], valueInRecord);
	                    if ($scope.record[value[0]] instanceof Object)
	                        evalCriteria = $scope.operators[value[1]](valueInRecord.Name, value[2]);
	                    else
	                        evalCriteria = $scope.operators[value[1]](valueInRecord, value[2]);
	                }
	                else
	                    evalCriteria = 'true';
	                return evalCriteria;
	            }

	            $scope.setVisibility = function (visibility, componentIndex) {
	                var splitComponentIndex = componentIndex.split('_');
	                switch (splitComponentIndex.length) {
	                    case 1:
	                        $scope.layout.tabs[splitComponentIndex[0]]['isVisible'] = visibility;
	                        break;
	                    case 2:
	                        if (componentIndex.indexOf('section') != -1)
	                            $scope.layout.sections[splitComponentIndex[1]]['isVisible'] = visibility;
	                        else
	                            $scope.layout.tabs[splitComponentIndex[0]].sections[splitComponentIndex[1]]['isVisible'] = visibility;
	                        break;
	                    case 3:
	                        if (componentIndex.indexOf('section') != -1)
	                            $scope.layout.sections[splitComponentIndex[1]].fields[splitComponentIndex[2]]['isVisible'] = visibility;
	                        else {
	                            $scope.layout.tabs[splitComponentIndex[0]].sections[splitComponentIndex[1]].fields[splitComponentIndex[2]]['isVisible'] = visibility;
	                            $scope.record[$scope.layout.tabs[splitComponentIndex[0]].sections[splitComponentIndex[1]].fields[splitComponentIndex[2]]['name']] = '';
	                        }
	                        break;
	                }
	                if (!$scope.$$phase && !$scope.$root.$$phase)
	                    $scope.$apply();
	            }

	            $scope.evaluateStandardCriteria = function (componentIndex) {
	                var evalCriteria = ''; standardCriteria = $scope.criteriaContainer[componentIndex].criteria;
	                if (standardCriteria.filterLogic) {
	                    var criteria = standardCriteria.filterLogic.replace(/\(/g, '( ').replace(/\)/g, ' )').split(' ');
	                    angular.forEach(criteria, function (crt) {
	                        if (isNaN(crt))
	                            evalCriteria += $scope.mapOperator[crt.toLocaleLowerCase()];
	                        else
	                            evalCriteria += $scope.validateCondition(standardCriteria.arrFilterObj[(parseInt(crt) - 1)]);
	                    });
	                }
	                else if (standardCriteria.type) {
	                    for (iIndex = 0; iIndex < standardCriteria.arrFilterObj.length; iIndex++) {
	                        evalCriteria += $scope.validateCondition(standardCriteria.arrFilterObj[iIndex]);
	                        evalCriteria += (standardCriteria.arrFilterObj.length - 1 != iIndex) ? $scope.mapOperator[standardCriteria.type.toLowerCase()] : '';
	                    }
	                }
	                $scope.setVisibility(eval(evalCriteria), componentIndex);
	            }

	            $scope.criteriaExecuter = function (componentIndex, isClientExec) {
	                try {
	                    switch (isClientExec) {
	                        case null:
	                            $scope.evaluateStandardCriteria(componentIndex);
	                            break;
	                        case true:
	                            $scope.setVisibility(eval($scope.criteriaContainer[componentIndex].criteria + '($scope.record)'), componentIndex);
	                            break;
	                        case false:
	                            eval($scope.serverCriteriaContainer[componentIndex] + '($scope.record, componentIndex, $scope.setVisibility)');
	                            break;
	                    }
	                } catch (ex) {
	                    $scope.setVisibility(false, componentIndex);
	                    return false;
	                }

	            }

	            $scope.$watchCollection('record', function (newVal, oldVal) {
	                if (newVal != oldVal)
	                    angular.forEach($scope.criteriaContainer, function (value, key) {
	                        $scope.criteriaExecuter(key, value.isClient ? value.isClient : null);
	                    });
	            })

	            $scope.evaluateVisibilityCriteria = function (componentCriteria, componentIndex) {
	                if (componentCriteria['standard']) {
	                    $scope.criteriaContainer[componentIndex] = { criteria: componentCriteria['standard'], isClient: false };
	                    $scope.criteriaExecuter(componentIndex, null);
	                } else if (componentCriteria['server']) {
	                    $scope.serverCriteriaContainer[componentIndex] = 'execute = ' + componentCriteria['server']
	                    $scope.criteriaExecuter(componentIndex, false);
	                    if (componentCriteria.fields.length > 0) {
	                        var arrFields = [];
	                        angular.forEach(componentCriteria.fields, function (field) {
	                            $de.add(arrFields, 'record.' + field);
	                        });
	                        arrFields = '[' + arrFields.toString() + ']'
	                        $scope.$watch(arrFields, function (newVal, oldVal) {
	                            if (newVal != oldVal)
	                                $scope.criteriaExecuter(componentIndex, false);
	                        });
	                    }
	                } else if (componentCriteria['client']) {
	                    $scope.criteriaContainer[componentIndex] = { criteria: 'execute = ' + componentCriteria['client'], isClient: true };
	                    $scope.criteriaExecuter(componentIndex, true);
	                }
	            }

	            $scope.evaluateComponentEnability = function (component, componentIndex) {
	                if (component)
	                    if (component.visibilityCriteria) {
	                        component.visibilityCriteria = component.visibilityCriteria.replace(/'/g, '"').replace(/\n/g, " ");
	                        var componentCriteria = JSON.parse(component.visibilityCriteria);
	                        if (componentCriteria.criteria.isEnabled)
	                            $scope.evaluateVisibilityCriteria(componentCriteria.criteria, componentIndex.toString());
	                        else
	                            component.isVisible = true;
	                        delete component.visibilityCriteria;
	                    }
	                    else
	                        component.isVisible = true;
	            }

	            $scope.initSectionVisibilityCriteria = function (section, index) {
	                var sectionIndex = 'section_' + index;
	                $scope.evaluateComponentEnability(section, sectionIndex);
	                angular.forEach(section.fields, function (field, fIndex) {
	                    var fieldIndex = sectionIndex + '_' + fIndex;
	                    $scope.evaluateComponentEnability(field, fieldIndex);
	                });
	            }

	            $scope.initVisibilityCriteria = function (tab, tabIndex) {
	                $scope.evaluateComponentEnability(tab, tabIndex);
	                angular.forEach(tab.sections, function (section, sIndex) {
	                    var sectionIndex = tabIndex + '_' + sIndex;
	                    $scope.evaluateComponentEnability(section, sectionIndex);
	                    angular.forEach(section.fields, function (field, fIndex) {
	                        var fieldIndex = sectionIndex + '_' + fIndex;
	                        $scope.evaluateComponentEnability(field, fieldIndex);
	                    });
	                });
	            }
	            var templateName = $de.templatesFolder + 'layout';
	            $scope.templateUrl = templateName + ($scope.designMode ? '-design.htm' : '.htm');

	        }]
	    }
	}])
	.directive('deLayoutSection', ['$de', function ($de) {
	    return {
	        restrict: 'A',
	        template: '<div class="section" ng-include="templateUrl" ></div>',
	        scope: {
	            section: '=deLayoutSection',
	            editMode: '=',
	            displayMode: '=',
	            record: '=ngModel',
	            tab: '=',
	            sectionindex: '=',
	            objFields: '=fields'
	        },
	        controller: ['$scope', '$attrs', '$element', '$de', '$deLayout', '$deForm', '$timeout', '$compile', '$templateCache', function ($scope, $attrs, $element, $de, $deLayout, $deForm, $timeout, $compile, $templateCache) {
	            $scope.$de = $de;
	            $scope.$de.initUIControl($element, $scope, $attrs);
	            $scope.fields = $deLayout.sectionFields;
	            if ($scope.tab != undefined)
	                var isTabSection = (Object.keys($scope.tab).length > 0);
	            $scope.sortFields = {
	                group: {
	                    name: 'fields',
	                    pull: true,
	                    put: true,
	                },
	                onAdd: function (evt) { $scope.addFieldToSection(evt.model) }
	            }

	            $scope.addFieldToSection = function (field) {
	                if (sectionFields[field.name]) {
	                    if (field.ObjectDepth) {
	                        if (field.ObjectDepth == sectionFields[field.name].ObjectDepth) {
	                            $de.showInfo('Field [' + field.label + '] already available in this section', 'Duplicate Entry.', '');
	                            $de.remove($scope.section.fields, field);
	                        }
	                        else
	                            sectionFields[field.name] = field;
	                    }
	                    else {
	                        $de.showInfo('Field [' + field.label + '] already available in this section', 'Duplicate Entry.', '');
	                        $de.remove($scope.section.fields, field);
	                    }
	                }
	                else
	                    sectionFields[field.name] = field;

	            }
	            var sectionFields = {};
	            $scope.initSectionFileds = function () {
	                if (Object.keys(sectionFields).length <= 0)
	                    angular.forEach($scope.section.field, function (val) {
	                        sectionFields[val.name] = val;
	                    })
	            }();


	            $scope.$watch('section.layout', function (newValue) {
	                switch (newValue) {
	                    case 'grid': $scope.formClass = 'de-form--grid'; break;
	                    case 'stacked': $scope.formClass = 'de-form--stacked'; break;
	                    default: $scope.formClass = 'de-form'; break;
	                }
	            })

	            $scope.$on('remove-field', function (event, field) {
	                $de.remove($scope.section.fields, field);
	                delete sectionFields[field.name];
	            })

	            $scope.addComponentCriteria = function (criteria, component) {
	                if (Object.keys(criteria).length == 0)
	                    delete component.visibilityCriteria;
	                else
	                    component.visibilityCriteria = JSON.stringify({ criteria: criteria });
	            }

	            $scope.saveVisibiltyCriteria = function (criteria, closeDialog) {
	                switch ($scope.currentComponent) {
	                    case 'section':
	                        if (isTabSection)
	                            $scope.addComponentCriteria(criteria, $scope.tab.sections[$scope.sectionIndex]);
	                        else
	                            $scope.addComponentCriteria(criteria, $scope.$parent.layout.sections[$scope.sectionIndex]);
	                        break;
	                    case 'field':
	                        if (criteria.Validation) {
	                            delete criteria.Validation;
	                            if (Object.keys(criteria).length == 1 || criteria == '') {
	                                if (isTabSection)
	                                    delete $scope.tab.sections[$scope.sectionIndex].fields[$scope.fieldIndex].validationCriteria;
	                                else
	                                    delete $scope.$parent.layout.sections[$scope.sectionIndex].fields[$scope.fieldIndex].validationCriteria;
	                            } else {
	                                if (isTabSection)
	                                    $scope.tab.sections[$scope.sectionIndex].fields[$scope.fieldIndex].validationCriteria = JSON.stringify({ criteria: criteria });
	                                else
	                                    $scope.$parent.layout.sections[$scope.sectionIndex].fields[$scope.fieldIndex].validationCriteria = JSON.stringify({ criteria: criteria });
	                            }
	                        } else {
	                            if (isTabSection)
	                                $scope.addComponentCriteria(criteria, $scope.tab.sections[$scope.sectionIndex].fields[$scope.fieldIndex]);
	                            else
	                                $scope.addComponentCriteria(criteria, $scope.$parent.layout.sections[$scope.sectionIndex].fields[$scope.fieldIndex]);
	                            break;
	                        }
	                }
	                closeDialog();
	            }

	            $scope.openSettingWizard = function (index, type) {
	                $scope.currentComponent = type;
	                switch (type) {
	                    case 'section':
	                        if (isTabSection)
	                            $deLayout.settingWizard('Section', $scope.objFields, $scope.saveVisibiltyCriteria, $scope.tab.sections[index]);
	                        else
	                            $deLayout.settingWizard('Section', $scope.objFields, $scope.saveVisibiltyCriteria, $scope.$parent.layout.sections[index]);
	                        break;
	                    case 'field':
	                        $scope.sectionIndex = parseInt(index.split('_')[0]);
	                        $scope.fieldIndex = parseInt(index.split('_')[1]);
	                        if (isTabSection)
	                            $deLayout.settingWizard('Field', $scope.objFields, $scope.saveVisibiltyCriteria, $scope.tab.sections[$scope.sectionIndex].fields[$scope.fieldIndex]);
	                        else
	                            $deLayout.settingWizard('Field', $scope.objFields, $scope.saveVisibiltyCriteria, $scope.$parent.layout.sections[$scope.sectionIndex].fields[$scope.fieldIndex]);
	                        break;
	                }
	            }

	            $scope.takeDesignAction = function ($event, action, index) {
	                switch (action.action) {
	                    case 'form-auto':
	                        $scope.section.layout = 'auto';
	                        break;
	                    case 'form-stacked':
	                        $scope.section.layout = 'stacked';
	                        break;
	                    case 'form-grid':
	                        $scope.section.layout = 'grid';
	                        break;
	                    case 'remove':
	                        if (isTabSection) {
	                            //if ($scope.tab.sections.length == 1) {
	                            //    $de.showError('You can not remove this section.Atleast one section is required in a tab.', 'Not Allowed.', '');
	                            //    return;
	                            //}
	                            var del = window.confirm("Are you sure you want to delete Section?");
	                            if (del == true) {
	                                $de.remove($scope.tab.sections, $scope.section);
	                            }
	                        }
	                        else {
	                            var del = window.confirm("Are you sure you want to delete Section?");
	                            if (del == true) {
	                                $de.remove($scope.$parent.layout.sections, $scope.section);
	                            }
	                        }
	                        break;
	                    case 'settings':
	                        $scope.sectionIndex = index;
	                        $scope.openSettingWizard(index, 'section');
	                        break;
	                }
	            }

	            $scope.designActions = [
					{ action: 'settings', label: 'Settings', icon: 'fa-cog', type: 'primary' },
					{ action: 'form-auto', label: 'Auto Form', icon: 'fa-th-list', type: 'default' },
					{ action: 'form-grid', label: 'Grid Form', icon: 'fa-th', type: 'default' },
					{ action: 'form-stacked', label: 'Stacked Form', icon: 'fa-align-justify', type: 'default' },
					{ action: 'remove', label: 'Delete', icon: 'fa-trash', type: 'default' },
	            ];

	            $scope.$watch('section.visibilityCriteria', function (newVal, oldVal) {
	                if (newVal != undefined)
	                    $scope.designActions[0].type = 'default criteria-enabled';
	                else
	                    $scope.designActions[0].type = 'default';
	            })

	            var templateName = $de.templatesFolder + 'layout-section';
	            $scope.templateUrl = templateName + ($scope.designMode ? '-design.htm' : '.htm');
	        }]
	    }
	}])
	.directive('deLayoutComponentVisibility', ['$de', function ($de) {
	    return {
	        restrict: 'A',
	        template: '<div ng-include="templateUrl" ></div>',
	        scope: {
	            fields: '=deLayoutComponentVisibility',
	            sectionVisibilityCriteria: '=criteria',
	            onsave: '&',
	            oncancel: '&',
	            componentname: '&'
	        },
	        controller: ['$scope', '$attrs', '$element', '$de', '$deLayout', '$timeout', '$compile', '$templateCache', '$filter', function ($scope, $attrs, $element, $de, $deLayout, $timeout, $compile, $templateCache, $filter) {

	            $scope.type = 'Visibility';
	            $scope.componentname = $scope.componentname();
	            $scope.mapFieldWithName = {};
	            $scope.selectedOperators = [];
	            $scope.filterObj = [];
	            $scope.filter = {};
	            var visitedRow = {};
	            $scope.isPickVal = {};
	            $scope.arrPicklistValues = {};
	            $scope.arrIdIndex = [];
	            $scope.clearCriteria = false;
	            $scope.reEvaluate = {
	                client: { def: 'function(record){}', onfieldUpdate: false, requiredFields: [] },
	                server: { def: 'function(record,index,callback){}', onfieldUpdate: false, requiredFields: [] }
	            };
	            $scope.invalid = { invalidLogic: false };
	            $scope.typeSelected = 'Standard';
	            $scope.sideBarList = [
					{ name: 'Standard', isVisible: true },
					{ name: 'Client', isVisible: true },
					{ name: 'Server', isVisible: true }
	            ]

	            $scope.mapIcon = {
	                Standard: 'fa-hourglass-end', Client: 'fa-desktop', Server: 'fa-server', Visibility: 'fa-binoculars'
	            };

	            angular.forEach($scope.fields, function (f) {
	                $scope.mapFieldWithName[f.name] = f;
	            })
	            var arrType1 = ['password', 'phone', 'lookup', 'email', 'double', 'text', 'date', 'datetime', 'percent', 'currency', 'checkbox'];
	            var arrType2 = ['password', 'phone', 'double', 'date', 'datetime', 'percent', 'currency'];
	            var arrType3 = ['password', 'phone', 'lookup', 'email', 'text', 'textarea'];
	            var arrType4 = ['password', 'phone', 'lookup', 'email', 'text', 'textarea', 'picklist'];

	            $scope.condition = { opr: true }

	            var arrClientInstructions = [
					'Record will be availbale as only parameter to execute the function.',
					'Function can return only either true or false.',
					'Anything out of these paramaters won\'t be available to inject as function parameters and will cause execution failure.',
	            ]

	            var arrServerInstructions = [
					'Record, a reference of callback method and an index variable will be available as first, second and third parameter respectively to execute the function.',
					'Callback function can return either callback(true, index) or callback(false, index) only as per criteria evaluation.',
					'Anything out of these paramaters won\'t be available to inject as function parameters and will cause execution failure.',
	            ]

	            $scope.arrInstructions = arrClientInstructions;

	            $scope.disableCriteria = false;
	            $scope.addExpression = false;
	            $scope.editorActions = [
					[{ action: 'enable-filter-logic', label: 'Advance Filter Logic', type: 'default' }],
					[{ action: 'disable-filter-logic', label: 'Remove Filter Logic', type: 'default' }],
					[{ action: 'clear-filter-logic', label: 'Clear Visiblity Criteria', type: 'default' }],
					[{ action: 'remove-criteria', label: 'Remove Existing Criteria and Save', type: 'default' }],
                    [{ action: 'enable-criteria', label: 'Enable Existing Criteria', type: 'default' }],
                    [{ action: 'disable-criteria', label: 'Disable Existing Criteria', type: 'default' }]
	            ]

	            $scope.errorInDefinition = {};
	            $scope.opr = 'AND';
	            $scope.changeCondition = function (condition) {
	                if ($scope.filterObj.length > 1) {
	                    $scope.opr = (condition) ? 'AND' : 'OR';
	                    angular.forEach($scope.filterObj, function (obj, index) {
	                        if (index < $scope.filterObj.length - 1)
	                            obj.nextOpr = $scope.opr;
	                    })
	                }
	            }

	            $scope.allOperators = [
					{ key: "==", value: "equals", forTypes: arrType1 },
					{ key: "!=", value: "not equal to", forTypes: arrType1 },
					{ key: "<", value: "less than", forTypes: arrType2 },
					{ key: ">", value: "greater than", forTypes: arrType2 },
					{ key: "<=", value: "less or equal", forTypes: arrType2 },
					{ key: ">=", value: "greater or equal", forTypes: arrType2 },
					{ key: "starts with", value: "starts with", forTypes: arrType3 },
					{ key: "contains", value: "contains", forTypes: arrType4 },
					{ key: "does not contain", value: "does not contain", forTypes: arrType4 }
	            ];

	            $scope.removeSelectList = function (id, currentIndex, isPicklist) {
	                if ($(id).children().length > 0)
	                    if (($($(id).children()[0]).children()[0].tagName != 'SELECT' && isPicklist) || ($($(id).children()[0]).children()[0].tagName == 'SELECT' && !isPicklist)) {
	                        $scope.filterObj[currentIndex]['filterValue'] = '';
	                        $($(id).children()[0]).hide();
	                    }
	                $scope.isPickVal[currentIndex] = isPicklist;
	                $scope.arrPicklistValues[currentIndex] = [];

	                if (!$scope.$$phase && !$scope.$root.$$phase)
	                    $scope.$apply();
	            }

	            $scope.destroyDatepicker = function (id, currentIndex) {
	                if ($(id).find('input').data("DateTimePicker")) {
	                    if ($scope.filterObj[currentIndex].filterValue)
	                        $scope.filterObj[currentIndex].filterValue = '';
	                    $(id).find('input').data("DateTimePicker").destroy();
	                }
	            }

	            $scope.changeField = function (field, currentIndex, isEdit) {
	                var id = '#filtervalue' + (currentIndex + 1);
	                if (['date', 'datetime'].indexOf($scope.mapFieldWithName[field].type) != -1) {
	                    $scope.destroyDatepicker(id, currentIndex);
	                    $scope.dateTimeFormat = ($scope.mapFieldWithName[field].type == 'datetime') ? 'YYYY/MM/DD hh:mm A' : 'YYYY/MM/DD';
	                    setTimeout(function () {
	                        $($element).find(id).find('input').datetimepicker({
	                            format: $scope.dateTimeFormat,
	                            sideBySide: $attrs.sidebyside
	                        }).on('dp.change', function (event) {
	                            $scope.filterObj[currentIndex].filterValue = $(event.currentTarget).val();
	                        });
	                    }, 50);
	                } else
	                    $scope.destroyDatepicker(id, currentIndex);
	                if ($scope.mapFieldWithName[field].type == 'picklist') {
	                    $scope.removeSelectList(id, currentIndex, true);
	                    $scope.arrPicklistValues[currentIndex] = [];
	                    if ($scope.mapFieldWithName[field].controlledBy != undefined)
	                        angular.forEach($scope.mapFieldWithName[field].values, function (value, key) {
	                            if (value != 'JsonObject')
	                                angular.forEach(value, function (val) {
	                                    $de.add($scope.arrPicklistValues[currentIndex], { value: val, country: key });
	                                })
	                        })
	                    else
	                        angular.forEach($scope.mapFieldWithName[field].values, function (value, key) {

	                            $de.add($scope.arrPicklistValues[currentIndex], value);
	                        })
	                    if (!$scope.$$phase && !$scope.$root.$$phase)
	                        $scope.$apply();
	                } else
	                    $scope.removeSelectList(id, currentIndex, false);
	                $scope.selectedOperators[currentIndex] = [];
	                angular.forEach($scope.allOperators, function (opr) {
	                    if (opr.forTypes.indexOf($scope.mapFieldWithName[field].type) != -1 || opr.forTypes[0] == 'all')
	                        $de.add($scope.selectedOperators[currentIndex], { key: opr.key, value: opr.value });
	                });
	                if (!isEdit)
	                    $scope.filterObj[currentIndex].operator = $scope.selectedOperators[currentIndex][0].key;
	            }

	            $scope.setCloudTagContainerWidth = function () {
	                setTimeout(function () {
	                    $('.chosen-container').removeAttr('style');
	                    $('.chosen-container').addClass('col-md-12 no-padding');
	                }, 100);
	            }

	            $scope.defaultStandardCriteria = function () {
	                $scope.filterObj = [{ filterField: '', operator: '', filterValue: '', nextOpr: '' }];
	                $scope.setCloudTagContainerWidth();
	            }

	            $scope.fetchVisibilityCriteria = function () {
	                if ($scope.sectionVisibilityCriteria) {
	                    $scope.sectionVisibilityCriteria = $scope.sectionVisibilityCriteria.replace(/'/g, '"').replace(/\n/g, " ");
	                    var objCriteria = JSON.parse($scope.sectionVisibilityCriteria);
	                    $scope.disableCriteria = !objCriteria.criteria.isEnabled;
	                    if (objCriteria.criteria['server'] != undefined) {
	                        $scope.reEvaluate.server.def = objCriteria.criteria.server;
	                        if (objCriteria.criteria.fields.length > 0) {
	                            $scope.reEvaluate.server.onfieldUpdate = true;
	                            angular.forEach(objCriteria.criteria.fields, function (field) {
	                                $de.add($scope.reEvaluate.server.requiredFields, $scope.mapFieldWithName[field]);
	                            })
	                        }
	                        $scope.defaultStandardCriteria();
	                        $scope.selectType('Server');
	                    } else if (objCriteria.criteria['client'] != undefined) {
	                        $scope.reEvaluate.client.def = objCriteria.criteria.client;
	                        $scope.defaultStandardCriteria();
	                        $scope.selectType('Client');
	                    }
	                    else {
	                        $scope.filter.filterLogic = objCriteria.criteria.standard.filterLogic != undefined ? objCriteria.criteria.standard.filterLogic : '';
	                        $scope.enableAdvanceLogic = objCriteria.criteria.standard.filterLogic != undefined ? true : false;
	                        $scope.opr = objCriteria.criteria.standard.type != undefined ? objCriteria.criteria.standard.type : 'AND';
	                        $scope.condition.opr = $scope.opr == 'AND' ? true : false;
	                        angular.forEach(objCriteria.criteria.standard.arrFilterObj, function (row, index) {
	                            $scope.changeField(row[0], index, true);
	                            if (row[2] instanceof Array) {
	                                var arrObj = [];
	                                angular.forEach(row[2], function (val) {
	                                    $de.add(arrObj, { value: val })
	                                })
	                                row[2] = arrObj;
	                            }
	                            $de.add($scope.filterObj, { filterField: row[0], operator: row[1], filterValue: row[2], nextOpr: (objCriteria.criteria.standard.arrFilterObj.length == 1 || index == (objCriteria.criteria.standard.arrFilterObj.length - 1)) ? '' : $scope.opr });
	                        });
	                        $scope.setCloudTagContainerWidth();
	                        $scope.selectType('Standard');
	                    }
	                }
	                else {
	                    $scope.defaultStandardCriteria();
	                    $scope.selectType('Standard');
	                }
	                $scope.oldFilterObj = angular.copy($scope.filterObj);
	            }

	            $scope.addOrRemoveFilter = function (isRemove, currentIndex) {
	                if (isRemove) {
	                    if (!(currentIndex < ($scope.filterObj.length - 1)))
	                        $scope.filterObj[currentIndex - 1].nextOpr = '';
	                    angular.forEach($scope.filterObj, function (obj, index) {
	                        if (currentIndex <= index && index != $scope.filterObj.length - 1) {
	                            if ($scope.mapFieldWithName[$scope.filterObj[index + 1].filterField] != undefined)
	                                if ($scope.mapFieldWithName[$scope.filterObj[index + 1].filterField].type == 'picklist') {
	                                    $scope.isPickVal[index] = true;
	                                    $scope.arrPicklistValues[index] = $scope.arrPicklistValues[index + 1];
	                                } else
	                                    $scope.isPickVal[index] = false;
	                            else
	                                $scope.isPickVal[index] = false;
	                        }
	                    });
	                    $scope.filterObj.splice(currentIndex, 1);
	                    $scope.selectedOperators.splice(currentIndex, 1);
	                    delete $scope.arrPicklistValues[$scope.filterObj.length];
	                } else {
	                    $scope.filterObj[$scope.filterObj.length - 1].nextOpr = $scope.opr != undefined ? $scope.opr : '';
	                    $de.add($scope.filterObj, { filterField: '', operator: '', filterValue: '', nextOpr: '' });
	                    setTimeout(function () {
	                        $('#standard-row').animate({ scrollTop: $('#standard-row').scrollTop() + $("#filter-row" + $scope.filterObj.length).position().top }, 500);
	                    }, 100);
	                }
	            }

	            $scope.clearFilterLogic = function () {
	                if ($scope.idIndex)
	                    $scope.resetError('');
	                $scope.enableAdvanceLogic = false;
	                $scope.filter.filterLogic = '';
	                $scope.invalid.invalidLogic = false
	            }

	            $scope.markError = function (index, id) {
	                $de.add($scope.arrIdIndex, index);
	                if (id) {
	                    $('#row' + index).children().css('background', '#DA0000');
	                    $('#' + id + index).find('.form-control').css('border-color', '#DA0000');
	                    $('#standard-row').animate({ scrollTop: $("#filter-row" + index).position().top }, 500);
	                } else
	                    $scope.resetError(index, '#137915');
	            }

	            $scope.resetError = function (index, color) {
	                $('#row' + index).children().css('background', color);
	                $('#filterfield' + index).children().css('border-color', color);
	                $('#filteroperator' + index).children().css('border-color', color);
	                $('#filtervalue' + index).find('.form-control').css('border-color', color);
	            }

	            $scope.catchError = function (field, index) {
	                $scope.typeSelected = 'Standard';
	                if (field != null) {
	                    var id = (field == 'blank') ? '' : (!field.filterField) ? 'filterfield' : !field.operator ? 'filteroperator' : 'filtervalue';
	                    if (field == 'blank')
	                        $de.showWarning('Row ' + index + ' has been created but remain no use in filter logic.', 'Saving Failed.');
	                    else
	                        $de.showError('Missing filter details for row ' + index + '.', 'Saving Failed.');
	                    $scope.markError(index, id);
	                } else
	                    $de.showError('Row ' + index + ' does not exist.', 'Saving Failed.');
	            }

	            $scope.collectAllCriteria = function () {
	                var copyObj = angular.copy($scope.filterObj);
	                var criteriaDetails = [];
	                angular.forEach(copyObj, function (row) {
	                    delete row.$$hashKey;
	                    delete row.nextOpr;
	                    var fDetails = [];
	                    $de.add(fDetails, row.filterField);
	                    $de.add(fDetails, row.operator);
	                    if ($scope.mapFieldWithName[row.filterField].type == 'picklist') {
	                        var arrValues = [];
	                        angular.forEach(row.filterValue, function (val) {
	                            $de.add(arrValues, val.value);
	                        });
	                        $de.add(fDetails, arrValues);
	                    } else
	                        $de.add(fDetails, row.filterValue);
	                    $de.add(criteriaDetails, fDetails);
	                });
	                if ($scope.filter.filterLogic)
	                    $scope.criteriaObj = { arrFilterObj: criteriaDetails, filterLogic: $scope.filter.filterLogic };
	                else
	                    $scope.criteriaObj = { arrFilterObj: criteriaDetails, type: $scope.opr };
	            }

	            $scope.validateCriteria = function (rowIndex) {
	                var row = $scope.filterObj[rowIndex];
	                if (row.filterField && row.operator && row.filterValue) {
	                    visitedRow[rowIndex + 1] = true;
	                    if ($scope.mapFieldWithName[row.filterField].type == 'checkbox')
	                        $scope.filterObj[rowIndex].filterValue = eval(row.filterValue);
	                    return true;
	                } else
	                    return false;
	            }

	            $scope.saveObjCriteria = function () {
	                if ($scope.typeSelected == 'Standard') {
	                    if ($scope.arrIdIndex.length > 0) {
	                        angular.forEach($scope.arrIdIndex, function (index) {
	                            $scope.resetError(index, '');
	                        })
	                        $scope.arrIdIndex = [];
	                    }
	                    visitedRow = {};
	                    if ($scope.filterObj.length > 0) {
	                        var validFilterCriteria = true, viewObj = { name: $scope.newViewName, tableheaders: [], querystring: '' };
	                        if ($scope.filter.filterLogic) {
	                            if (!$scope.invalid.invalidLogic) {
	                                var logic = $scope.filter.filterLogic.replace(/\(/g, '').replace(/\)/g, '').split(' ');
	                                for (iIndex = 0; iIndex < logic.length; iIndex++) {
	                                    var indexVal = parseInt(logic[iIndex]);
	                                    if (indexVal) {
	                                        if (indexVal <= $scope.filterObj.length) {
	                                            if (!$scope.validateCriteria(indexVal - 1)) {
	                                                validFilterCriteria = false;
	                                                $scope.catchError($scope.filterObj[indexVal - 1], indexVal);
	                                                break;
	                                            }
	                                        } else {
	                                            validFilterCriteria = false;
	                                            $scope.catchError(null, indexVal);
	                                            break;
	                                        }
	                                    }
	                                }
	                            } else {
	                                var errorMsg = ($scope.specialCharsFound) ? 'Filter Logic contains one or more un-recognized characters.' : 'Improper filter logic.';
	                                return $de.showError(errorMsg, 'Saving Failed.');
	                            }
	                        }
	                        else {
	                            for (iIndex = 0; iIndex < $scope.filterObj.length; iIndex++) {
	                                if (!$scope.validateCriteria(iIndex)) {
	                                    if ($scope.filterObj.length == 1) {
	                                        var row = $scope.filterObj[0];
	                                        if (row.filterField == "" && row.operator == "" && row.filterValue == "") {
	                                            $scope.emptyFilterObj = true;
	                                            validFilterCriteria = true;
	                                            break;
	                                        }
	                                    }
	                                    $scope.emptyFilterObj = false
	                                    validFilterCriteria = false;
	                                    $scope.catchError($scope.filterObj[iIndex], (iIndex + 1));
	                                    break;
	                                }
	                            }
	                        }
	                        if (validFilterCriteria) {
	                            var rowNotAddedInLogic = false;
	                            for (iIndex = 0; iIndex < $scope.filterObj.length; iIndex++) {
	                                if (!visitedRow[iIndex + 1] || visitedRow[iIndex + 1] == undefined) {
	                                    if (angular.equals($scope.oldFilterObj, $scope.filterObj)) {
	                                        rowNotAddedInLogic = true;
	                                        $scope.catchError('blank', (iIndex + 1));
	                                    }
	                                }
	                            }
	                            if (!rowNotAddedInLogic) {
	                                if (!$scope.emptyFilterObj) {
	                                    $scope.collectAllCriteria();
	                                    $scope.onsave({ criteria: { standard: $scope.criteriaObj, isEnabled: !$scope.disableCriteria } });
	                                }
	                                else
	                                    $scope.onsave({ criteria: {} });
	                            }
	                        }
	                    }
	                } else {
	                    if ($scope.typeSelected == 'Client') {
	                        if ($scope.errorInDefinition[$scope.typeSelected])
	                            return $de.showError('Syntax error in Client function definition.');
	                        if ('function(record){}' != $scope.reEvaluate.client.def.replace(/ /g, '') && $scope.reEvaluate.client.def != '')
	                            $scope.onsave({ criteria: { client: $scope.reEvaluate.client.def, isEnabled: !$scope.disableCriteria } });
	                        else
	                            $scope.onsave({ criteria: {} });
	                    } else {
	                        if ($scope.errorInDefinition['Server'])
	                            return $de.showError('Syntax error in Server function definition.');
	                        if ('function(record,index,callback){}' != $scope.reEvaluate.server.def.replace(/ /g, '') && $scope.reEvaluate.server.def != '') {
	                            var selectedFields = [];
	                            if ($scope.reEvaluate.server.onfieldUpdate) {
	                                if ($scope.reEvaluate.server.requiredFields.length > 0) {
	                                    angular.forEach($scope.reEvaluate.server.requiredFields, function (field) {
	                                        $de.add(selectedFields, field.name);
	                                    });
	                                }
	                            }
	                            $scope.onsave({ criteria: { server: $scope.reEvaluate.server.def, fields: selectedFields, isEnabled: !$scope.disableCriteria } });
	                        } else
	                            $scope.onsave({ criteria: {} });
	                    }
	                }
	            }

	            $scope.takeAction = function ($event, action, index) {
	                switch (action.action) {
	                    case 'enable-filter-logic':
	                        $scope.enableAdvanceLogic = true;
	                        break;
	                    case 'disable-filter-logic':
	                        $scope.clearFilterLogic();
	                        break
	                    case 'clear-filter-logic':
	                        $scope.filter.filterLogic = '';
	                        $scope.invalid.invalidLogic = false;
	                        $scope.filterObj = [{ filterField: '', operator: '', filterValue: '', nextOpr: '' }];
	                        break;
	                    case 'remove-criteria':
	                        $scope.onsave({ criteria: '', isStandard: true });
	                        break;
	                    case 'disable-criteria':
	                        $scope.disableCriteria = true;
	                        break;
	                    case 'enable-criteria':
	                        $scope.disableCriteria = false;
	                        break;
	                    case 'add-expression':
	                        $scope.addExpression = true;
	                        break;
	                    case 'save-expression':
	                        $scope.addExpression = true;
	                        break;

	                }
	            }

	            $scope.isValidLogicalStatement = function (text) {
	                if (text) {
	                    var noSpecialChars = /^[a-z A-Z()0-9]*$/;
	                    if (noSpecialChars.test(text)) {
	                        $scope.specialCharsFound = false;
	                        var re_paren = /\(\s*[+-]?\d+(?:(?:\s+AND\s+[+-]?\d+)+|(?:\s+OR\s+[+-]?\d+)+)\s*\)/ig;
	                        var re_valid = /^\s*[+-]?\d+(?:(?:\s+AND\s+[+-]?\d+)+|(?:\s+OR\s+[+-]?\d+)+)\s*$/ig;
	                        while (text.search(re_paren) !== -1) {// Iterate from the inside out. 
	                            text = text.replace(re_paren, "0");// Replace innermost parenthesized units with integer. 
	                        }
	                        $scope.invalid.invalidLogic = !(text.search(re_valid) === 0);
	                    } else {
	                        $scope.invalid.invalidLogic = true;
	                        $scope.specialCharsFound = true;
	                    }
	                } else
	                    $scope.invalid.invalidLogic = false;

	            }

	            $scope.selectType = function (type) {
	                $scope.typeSelected = type;
	                switch (type.toLowerCase()) {
	                    case 'standard':
	                        //$scope.setCloudTagContainerWidth();
	                        break;
	                    case 'client':
	                        $scope.arrInstructions = arrClientInstructions;
	                        break;
	                    case 'server':
	                        $scope.arrInstructions = arrServerInstructions;
	                        break;
	                }
	                setTimeout(function () {
	                    $('.' + type.toLowerCase()).animate({ opacity: '1' }, 'Slow')
	                }, 500);
	            }

	            $scope.fetchVisibilityCriteria();
	            $scope.templateUrl = $de.templatesFolder + 'component-setting-wizard.htm';
	        }]
	    }
	}])
	.directive('deFieldValidation', ['$de', function ($de) {
	    return {
	        restrict: 'A',
	        template: '<div ng-include="templateUrl" ></div>',
	        scope: {
	            fields: "=deFieldValidation",
	            currentField: '=component',
	            onsave: '&',
	            oncancel: '&',
	        },
	        controller: ['$scope', function ($scope) {
	            $scope.type = 'Validation';
	            $scope.arrClientInstructions = [
					'Record will be availbale as only parameter to execute the function.',
					'Function can return only either true or false.',
					'Anything out of these paramaters won\'t be available to inject as function parameters and will cause execution failure.',
	            ]

	            $scope.arrServerInstructions = [
					'Record and reference of callback method will be available as first and second parameter respectively to execute the function.',
					'Callback function can return either callback(true) or callback(false) only as per criteria evaluation.',
					'Anything out of these paramaters won\'t be available to inject as function parameters and will cause execution failure.',
	            ];
	            $scope.mapFieldWithName = {};
	            angular.forEach($scope.fields, function (f) {
	                $scope.mapFieldWithName[f.name] = f;
	            })

	            $scope.manageControls = function () {
	                switch ($scope.currentField.type.toLowerCase()) {
	                    case 'password':
	                    case 'checkbox':
	                    case 'picklist':
	                    case 'date':
	                    case 'datetime':
	                        $scope.textField = true;
	                        break;
	                    case 'text':
	                        $scope.col = 6;
	                        $scope.textField = false;
	                        $scope.patternField = false;
	                        break;
	                    case 'email':
	                    case 'phone':
	                        $scope.col = 12;
	                        $scope.textField = false;
	                        $scope.patternField = true;
	                        break;
	                }
	            }
	            $scope.manageControls();

	            $scope.sideBarList = [
					{ name: 'Reg-Ex', isVisible: !$scope.textField },
					{ name: 'Client', isVisible: true },
					{ name: 'Server', isVisible: true }
	            ]

	            $scope.sortRelatedLists = {
	                group: {
	                    name: 'relatedlists',
	                    pull: false,
	                    put: true
	                },
	            };
	            $scope.fieldValidator = {
	                server: { def: 'function(record,callback){}', onfieldUpdate: false, requiredFields: [], errMsg: '', disable: false },
	                client: { def: 'function(record){}', onfieldUpdate: false, requiredFields: [], errMsg: '', disable: false }
	            }
	            $scope.objExpression = {};
	            $scope.arrObjExpression = [];
	            $scope.isEdit = false;
	            $scope.errorInDefinition = {};
	            $scope.mapIcon = {
	                'Reg-Ex': 'fa-lock', Server: 'fa-external-link', Client: 'fa-laptop', Validation: 'fa-puzzle-piece'
	            };
	            $scope.preDefinedRegEx = [
					{ name: 'Numeric', regex: '^(0|[1-9][0-9]*)$' },
					{ name: 'Non Numeric', regex: '^[a-zA-Z]+$' },
					{ name: 'AlphaNumeric', regex: '^[a-zA-Z0-9]+$' },
					{ name: 'Non-Alphanumeric', regex: '^[A-Za-z0-9!@#$%^&*()_]$' }
	            ]
	            $scope.dynamicPopover = {
	                templateUrl: $de.templatesFolder + 'dynamic-popover.htm'
	            }
	            $scope.editorActions = [
                    [{ action: 'add-regexp', label: 'Add New Regular Expression', type: 'default' }],
					[{ action: 'pre-defined-exp', label: 'Choose From Predefined Expressions', type: 'default' }],
					[{ action: 'exp-cancel', label: 'Cancel', type: 'default' }],
					[{ action: 'disable', label: 'Disable All', type: 'default' }],
					[{ action: 'enable', label: 'Enable All', type: 'default' }]
	            ]

	            $scope.takeAction = function ($event, action, index) {
	                switch (action.action) {
	                    case 'add-regexp':
	                        $scope.displayToggle(true, false);
	                        break;
	                    case 'pre-defined-exp':
	                        $scope.displayToggle(false, true);
	                        break;
	                    case 'exp-cancel':
	                        $scope.displayToggle(false, false);
	                        break;
	                    case 'disable':
	                        $scope.toggleEnable(true);
	                        break;
	                    case 'enable':
	                        $scope.toggleEnable(false);
	                        break;
	                }
	            }

	            $scope.toggleEnable = function (disableAll) {
	                angular.forEach($scope.arrObjExpression, function (exp) {
	                    exp.isdisabled = disableAll;
	                });
	            }

	            $scope.enableExecution = function (isServer, isDisable) {
	                if (isServer)
	                    $scope.fieldValidator.server.disable = isDisable;
	                else
	                    $scope.fieldValidator.client.disable = isDisable;
	            }

	            $scope.selectType = function (type) {
	                $scope.typeSelected = type;
	                setTimeout(function () { $('.' + type.toLowerCase()).animate({ opacity: '1' }, "slow") }, 100);
	            }
	            $scope.selectType(!$scope.textField ? 'Reg-Ex' : 'Client');

	            $scope.disableValidation = function (value) {
	                $scope.disableAllValidations = value;
	            }

	            $scope.getAllValidationCriteria = function () {
	                if ($scope.currentField.validationCriteria) {
	                    var validationCriteria = $scope.currentField.validationCriteria.replace(/'/g, '"').replace(/\n/g, " ");
	                    var obj = JSON.parse(validationCriteria).criteria;
	                    $scope.disableAllValidations = !obj.isEnabled;
	                    if (obj.exp) {
	                        angular.forEach(obj.exp, function (regex) {
	                            $de.add($scope.arrObjExpression, regex)
	                        })
	                    }
	                    if (obj.server) {
	                        $scope.fieldValidator.server.def = obj.server.def;
	                        $scope.fieldValidator.server.disable = obj.server.isdisabled;
	                        $scope.fieldValidator.server.errMsg = obj.server.servermsg ? obj.server.servermsg : '';
	                        if (obj.server.fields) {
	                            $scope.fieldValidator.server.onfieldUpdate = true;
	                            angular.forEach(obj.server.fields, function (field) {
	                                $de.add($scope.fieldValidator.server.requiredFields, $scope.mapFieldWithName[field]);
	                            })
	                        }
	                    }
	                    if (obj.client) {
	                        $scope.fieldValidator.client.def = obj.client.def;
	                        $scope.fieldValidator.client.disable = obj.client.isdisabled;
	                        $scope.fieldValidator.client.errMsg = obj.client.clientmsg ? obj.client.clientmsg : '';
	                        if (obj.client.fields) {
	                            $scope.fieldValidator.client.onfieldUpdate = true;
	                            angular.forEach(obj.client.fields, function (field) {
	                                $de.add($scope.fieldValidator.client.requiredFields, $scope.mapFieldWithName[field]);
	                            })
	                        }
	                    }
	                }
	            }
	            $scope.getAllValidationCriteria();

	            $scope.displayToggle = function (isNew, isPredefined) {
	                if (isPredefined && !$scope.preRegEx || isNew && !$scope.newRegEx)
	                    $scope.objExpression = {};
	                if (!isNew && !isPredefined) {
	                    $('.newRegEx').slideUp(800);
	                    $('.preRegEx').slideUp(800);
	                    setTimeout(function () {
	                        $scope.preRegEx = isPredefined;
	                        $scope.newRegEx = isNew;
	                    }, 1000)
	                } else {
	                    $scope.preRegEx = isPredefined;
	                    $scope.newRegEx = isNew;
	                    $scope.btnText = 'Add';
	                    if (isNew || isPredefined)
	                        setTimeout(function () { $((isNew) ? '.newRegEx' : '.preRegEx').slideDown(800) }, 20);
	                }
	            }
	            $scope.displayToggle(false, false);

	            $scope.expressionAction = function (action, expression) {
	                switch (action) {
	                    case true:
	                        $scope.expressionIndex = $scope.arrObjExpression.indexOf(expression);
	                        $scope.displayToggle(!expression.predefined, expression.predefined);
	                        $scope.btnText = 'Save';
	                        $scope.isEdit = true;
	                        if (expression.predefined) {
	                            $scope.objExpression.errmsg = expression.errmsg;
	                            $scope.objExpression.expression = { name: expression.name, regex: expression.regex, predefined: expression.predefined };
	                        }
	                        else
	                            $scope.objExpression = { name: expression.name, expression: expression.regex, errmsg: expression.errmsg, predefined: expression.predefined };
	                        break;
	                    case false:
	                        if ($scope.arrObjExpression.indexOf(expression) == $scope.expressionIndex)
	                            $scope.isEdit = false;
	                        $scope.arrObjExpression.splice($scope.arrObjExpression.indexOf(expression), 1);
	                        break;
	                }
	            }

	            function getobj(isPredefined, isdisabled) {
	                return {
	                    name: isPredefined ? $scope.objExpression.expression.name : $scope.objExpression.name,
	                    regex: isPredefined ? $scope.objExpression.expression.regex : $scope.objExpression.expression,
	                    errmsg: $scope.objExpression.errmsg,
	                    predefined: isPredefined,
	                    isdisabled: isdisabled
	                }
	            }

	            $scope.addExpression = function (isPredefined) {
	                if ($scope.isEdit)
	                    $scope.arrObjExpression[$scope.expressionIndex] = getobj(isPredefined, $scope.arrObjExpression[$scope.expressionIndex].isdisabled);
	                else
	                    $de.add($scope.arrObjExpression, getobj(isPredefined, false));
	                if ($scope.isEdit) {
	                    $scope.displayToggle(false, false);
	                    $scope.isEdit = false;
	                }
	                $scope.objExpression = {};
	            }

	            $scope.saveObjCriteria = function () {
	                if ('function(record,callback){}' != $scope.fieldValidator.server.def.replace(/ /g, '') || $scope.fieldValidator.server.def != '') {
	                    if ($scope.errorInDefinition['Server']) {
	                        $scope.selectType('Server');
	                        return $de.showError('Syntax error in Server function definition.');
	                    }
	                }
	                if ('function(record){}' != $scope.fieldValidator.client.def.replace(/ /g, '') || $scope.fieldValidator.client.def != '') {
	                    if ($scope.errorInDefinition['Client']) {
	                        $scope.selectType('Client');
	                        return $de.showError('Syntax error in Client function definition.');
	                    }
	                }
	                var criteria = { criteria: { isEnabled: !$scope.disableAllValidations } };
	                if ($scope.arrObjExpression.length > 0) {
	                    var objSave = [];
	                    angular.forEach($scope.arrObjExpression, function (exp) {
	                        $de.add(objSave, { name: exp.name, regex: exp.regex, errmsg: exp.errmsg, isdisabled: exp.isdisabled, predefined: exp.predefined })
	                    })
	                    criteria.criteria.exp = objSave;
	                }
	                if ('function(record,callback){}' != $scope.fieldValidator.server.def.replace(/ /g, '')) {
	                    criteria.criteria['server'] = { def: $scope.fieldValidator.server.def };
	                    criteria.criteria['server']['servermsg'] = $scope.fieldValidator.server.errMsg;
	                    criteria.criteria['server']['isdisabled'] = $scope.fieldValidator.server.disable;
	                    if ($scope.fieldValidator.server.requiredFields.length > 0 && $scope.fieldValidator.server.onfieldUpdate) {
	                        criteria.criteria['server']['fields'] = [];
	                        angular.forEach($scope.fieldValidator.server.requiredFields, function (field) {
	                            $de.add(criteria.criteria['server']['fields'], field.name);
	                        });
	                    }
	                }
	                if ('function(record){}' != $scope.fieldValidator.client.def.replace(/ /g, '')) {
	                    criteria.criteria['client'] = { def: $scope.fieldValidator.client.def };
	                    criteria.criteria['client']['isdisabled'] = $scope.fieldValidator.client.disable;
	                    criteria.criteria['client']['clientmsg'] = $scope.fieldValidator.client.errMsg;
	                    if ($scope.fieldValidator.client.requiredFields.length > 0 && $scope.fieldValidator.client.onfieldUpdate) {
	                        criteria.criteria['client']['fields'] = [];
	                        angular.forEach($scope.fieldValidator.client.requiredFields, function (field) {
	                            $de.add(criteria.criteria['client']['fields'], field.name);
	                        });
	                    }
	                }
	                $scope.onsave(criteria);
	            };

	            $scope.capitalize = function (str) {
	                return str[0].toUpperCase() + str.slice(1);
	            }

	            $scope.templateUrl = $de.templatesFolder + 'field-validation-wizard.htm';
	        }]
	    }
	}])
	.directive('deCloudTag', ['$compile', function ($compile) {
	    var __indexOf = [].indexOf || function (item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };
	    var CHOSEN_OPTION_WHITELIST, NG_OPTIONS_REGEXP, isEmpty, snakeCase;
	    NG_OPTIONS_REGEXP = /^\s*(.*?)(?:\s+as\s+(.*?))?(?:\s+group\s+by\s+(.*))?\s+for\s+(?:([\$\w][\$\w]*)|(?:\(\s*([\$\w][\$\w]*)\s*,\s*([\$\w][\$\w]*)\s*\)))\s+in\s+(.*?)(?:\s+track\s+by\s+(.*?))?$/;
	    CHOSEN_OPTION_WHITELIST = ['noResultsText', 'allowSingleDeselect', 'disableSearchThreshold', 'disableSearch', 'enableSplitWordSearch', 'inheritSelectClasses', 'maxSelectedOptions', 'placeholderTextMultiple', 'placeholderTextSingle', 'searchContains', 'singleBackstrokeDelete', 'displayDisabledOptions', 'displaySelectedOptions', 'width'];
	    snakeCase = function (input) {
	        return input.replace(/[A-Z]/g, function ($1) {
	            return "_" + ($1.toLowerCase());
	        });
	    };
	    isEmpty = function (value) {
	        var key;
	        if (angular.isArray(value)) {
	            return value.length === 0;
	        } else if (angular.isObject(value)) {
	            for (key in value) {
	                if (value.hasOwnProperty(key)) {
	                    return false;
	                }
	            }
	        }
	        return true;
	    };
	    return {
	        restrict: 'AE',
	        require: 'ngModel',
	        scope: {
	            searchInOptions: "@",
	            ngModel: "=",
	            options: '='
	        },
	        terminal: true,
	        link: function (scope, element, attr) {
	            scope.$watch(attr.chosen, function (newVal, oldVal) {
	                element.trigger('chosen:updated');
	            });
	            var options = scope.$eval(attr.chosen) || {};
	            angular.forEach(attr, function (value, key) {
	                if (__indexOf.call(CHOSEN_OPTION_WHITELIST, key) >= 0)
	                    return options[snakeCase(key)] = scope.$eval(value);
	            });
	            scope.$watch(function (scope) {
	                return scope.ngModel;
	            }, function () {
	                element.trigger('chosen:updated');
	            })
	            var chosenStructure = element.chosen(options);
	            if (scope.searchInOptions == "true") {
	                var inputElement = angular.element(chosenStructure[0].nextSibling).find('input');
	                inputElement.bind('keyup', function ($event) {
	                    if (scope.ngModel == undefined || scope.ngModel == null) {
	                        scope.ngModel = new Array();
	                    }
	                    var chosenDiv = element[0].nextSibling;
	                    if ($event.which == 13 && angular.element(chosenDiv).find('li.no-results').length > 0) {
	                        var option = $("<option>").val(this.value).text(this.value);
	                        element.prepend(option);
	                        element.find(option).prop('selected', true);
	                        element.trigger("chosen:updated");
	                        scope.ngModel.push(this.value);
	                    }
	                });
	            }
	        },
	        controller: ["$scope", "$element", function ($scope, $element) {
	            $scope.$watchCollection("options", function () {
	                $element.trigger('chosen:updated');
	            })
	        }]
	    };
	}])
	.directive('rightSideBar', ['$de', function ($de) {
	    return {
	        restrict: 'AE',
	        template: '<div ng-include="templateUrl" ></div>',
	        controller: ['$scope', function ($scope) {
	            $scope.templateUrl = $de.templatesFolder + 'right-side-bar.htm';
	        }]
	    }
	}])
	.directive('functionDef', ['$de', function ($de) {
	    return {
	        restrict: 'AE',
	        templateUrl: $de.templatesFolder + 'function-definition.htm',
	        scope: {
	            arrinstruction: '=',
	            criteria: '=',
	            fields: '=',
	            errmsg: '=',
	            validdef: '='
	        },
	        controller: ['$scope', function ($scope) {
	            $scope.options = {
	                useWrapMode: true,
	                mode: 'javascript',
	                showPrintMargin: false,
	                theme: 'twilight',
	                onBlur: function () {
	                    $scope.validdef = $($('.ace_editor .ace_gutter')[0]).find('.ace_error').length > 0;
	                },
	                onLoad: function (editor) {
	                    $scope.editor = editor;
	                },
	                onFocus: function () { }
	            }
	        }]
	    }
	}])
	.directive('helpTextLabel', ['$de', function ($de) {
	    return {
	        restrict: 'AE',
	        scope: {
	            text: '=',
	            label: '='
	        },
	        template: '<div ng-include="templateUrl" ></div>',
	        controller: ['$scope', function ($scope) {
	            $scope.templateUrl = $de.templatesFolder + 'help-text-label.htm';
	        }]
	    }
	}])
	.directive('activeListItem', ['$de', function ($de) {
	    return {
	        restrict: 'AE',
	        templateUrl: $de.templatesFolder + 'active-list-item.htm',
	    }
	}])
	.directive('buttonAction', ['$de', function ($de) {
	    return {
	        restrict: 'AE',
	        templateUrl: $de.templatesFolder + 'button-action.htm',
	        scope: {
	            component: '=buttonAction',
	            onsave: '&',
	            oncancel: '&'
	        },
	        controller: ['$scope', function ($scope) {
	            var stanadardActionsMap = {
	                "layoutActions": {
	                    "actions": [
                                       { "ActionType": "Standard Action", "name": "Edit", "label": "Edit" },
                                       { "ActionType": "Standard Action", "name": "Delete", "label": "Delete" },
                                       { "ActionType": "Standard Action", "name": "Clone", "label": "Clone" },
                                       { "ActionType": "Standard Action", "name": "Share", "label": "Share" },
                                       { "ActionType": "Standard Action", "name": "Save", "label": "Save" },
                                       { "ActionType": "Standard Action", "name": "SaveAndNew", "label": "Save & New" },
                                       { "ActionType": "Standard Action", "name": "SaveAndClose", "label": "Save & Close" },
                                       { "ActionType": "Standard Action", "name": "Cancel", "label": "Cancel" },
                                       { "ActionType": "Custom Action", "name": "CustomAction", "label": "Custom Action" },
	                    ],
	                    "instructions": [
                                            'Record and error callback and success callback will be available as parameters to execute the function.',
                                            'Use error(\'Error Message\') for error display or success(\'Success Message\') for success display.',
                                            'Anything out of these paramaters won\'t be available to inject as function parameters and will cause execution failure.'
	                    ],
	                },
	                "tableSignleRecordActions": {
	                    "actions": [
                                       { "ActionType": "Standard Action", "name": "Edit", "label": "Edit" },
                                       { "ActionType": "Standard Action", "name": "Delete", "label": "Delete" },
                                       { "ActionType": "Custom Action", "name": "CustomAction", "label": "Custom Action" },
	                    ],
	                    "instructions": [
                                            'record and  callback  will be available as parameters to execute the function.',
                                            'Use callback( boolean var true,\'success Message\') for success display or callback(boolean var false,\'Error Message\') for error display.',
                                            'Anything out of these paramaters won\'t be available to inject as function parameters and will cause execution failure.'
	                    ]
	                },
	                "tableMultiRecordActions": {
	                    "actions": [
                                          { "ActionType": "Standard Action", "name": "Create", "label": "Create" },
                                          { "ActionType": "Standard Action", "name": "Delete", "label": "Delete" },
                                          { "ActionType": "Custom Action", "name": "CustomAction", "label": "Custom Action" },
	                    ],
	                    "instructions": [
                                            'selectedRecord and  callback  will be available as parameters to execute the function.',
                                            'Use callback( boolean var true,\'success Message\') for success display or callback(boolean var false,\'Error Message\') for error display.',
                                            'Anything out of these paramaters won\'t be available to inject as function parameters and will cause execution failure.'
	                    ]
	                },

	            };
	            $scope.stanadardActions = stanadardActionsMap[$scope.component.actionType].actions;
	            $scope.arrInstructions = stanadardActionsMap[$scope.component.actionType].instructions;
	            $scope.showStandardAction = $scope.component.isStandardAction
	            $scope.selectedAction = { name: $scope.component.name, label: $scope.component.label };
	            $scope.stdActionChange = function (action) {
	                $scope.component.name = action.name;
	                $scope.component.label = action.label;
	                $scope.component.css = "btn-sm";
	                switch (action.name.toLowerCase()) {
	                    case "create":
	                    case "save":
	                    case "saveandnew":
	                        $scope.component.isStandardAction = true;
	                        $scope.component.type = "primary"
	                        if (action.name.toLowerCase() == "create")
	                            $scope.component.mode = "read-only";
	                        else
	                            $scope.component.mode = "edit";
	                        if ($scope.component.actionType == "layoutActions") {
	                            if (action.name.toLowerCase() == "save")
                                {
                                    $scope.actionDefinition = {
                                        def: $scope.component.action = "function(record, errorFn, successFn){\n; $engine.upsert(angular.copy(record), true, function (error) {\n if (error.success) {\n ;$scope.editMode = 'read-only';\n successFn('Record Saved Successfully') \n} else \n errorFn((error.data.Data) ? error.data.Data[0].ErrorMessage : error.data.ErrorMessage, (error.data.Data) ? error.data.Data[0].Code : error.data.Code)}); }", onfieldUpdate: false, requiredFields: [], disableActionDef: true
                                    };
                                    if (window.platform = 'cella') {
                                        $scope.component.action = `function (record, errorFn, successFn) {
                                                debugger;
                                             if (Object.keys($scope.$root.errorMessage).length > 0) 
                                            {
                                               var errorString = '';
                                                for(var key in $scope.$root.errorMessage)
                                                { 
                                                   errorString = key + ' : ' + $scope.$root.errorMessage[key].errorMsg; 
                                                } 
                                                errorFn(errorString);
                                            }else{
                                             $engine.upsert(angular.copy(record), true, function (result) {
                                                if (result.success) {
                                                    $scope.editMode = 'read-only';
                                                    successFn('Record Saved Successfully')
                                                } else {
                                                    function errorMsg() {
                                                        var errorString = '';
                                                        angular.forEach(result.data[0].error, function (value, key) {
                                                            errorString += key + ': ';
                                                            errorString += value.join(',');
                                                            errorString += '\\n';
                                                        });
                                                        return errorString;
                                                    }
                                                    errorFn( (result.data) ? errorMsg() : result.errorcode, (result.data) ? result.errormessage : result.errormessage );
                                                }
                                            });
                                        }
                                    }`;
                                        $scope.actionDefinition.def = $scope.component.action;
                                    }

                                }
	                            else {
	                                $scope.actionDefinition = {
	                                    def: $scope.component.action = "function(record, errorFn, successFn){\n $engine.upsert(angular.copy(record), true, function (error) {\n if (error.success) {\n ;$scope.record={ObjType:record.ObjType}\n successFn('Record Saved Successfully') \n} else \n errorFn((error.data.Data) ? error.data.Data[0].ErrorMessage : error.data.ErrorMessage, (error.data.Data) ? error.data.Data[0].Code : error.data.Code)}); }", onfieldUpdate: false, requiredFields: [], disableActionDef: true
	                                };
	                                $scope.component.type = "success"
	                            }
	                        }
	                        else
	                            $scope.actionDefinition = {
	                                def: ($scope.component.singleRecordAction) ? $scope.component.action = "function(record,parentRecord,callback) {\$UIEngine.create(record,parentRecord,callback); \}"
                                        : $scope.component.action = "function(selectedRecords,parentRecord,callback) {\n $UIEngine.create(selectedRecords,parentRecord,callback); \n}", onfieldUpdate: false, requiredFields: [], disableActionDef: true
	                            };
	                        break;
	                    case "cancel":
	                        $scope.component.isStandardAction = true;
	                        $scope.component.type = "default";
	                        $scope.component.mode = "edit";
	                        if ($scope.component.actionType == "layoutActions")
	                            $scope.actionDefinition = {
	                                def: $scope.component.action = "function(record, error, success){\n $scope.record=$scope.oldRecord;$scope.editMode =\'read-only\';\n}", onfieldUpdate: false, requiredFields: [], disableActionDef: true
	                            };
	                        break;
	                    case "edit":
	                        $scope.component.isStandardAction = true;
	                        $scope.component.type = "primary"
	                        $scope.component.mode = "read-only";
	                        if ($scope.component.actionType == "layoutActions")
	                            $scope.actionDefinition = {
	                                def: $scope.component.action = "function(record, errorFn, successFn){\n $scope.oldRecord=angular.copy(record); $scope.editMode = \'edit\';\n }", onfieldUpdate: false, requiredFields: [], disableActionDef: true
	                            };
	                        else
	                            $scope.actionDefinition = {
	                                def: ($scope.component.singleRecordAction) ? $scope.component.action = "function(record,parentRecord,callback) {\$UIEngine.edit(record,parentRecord,callback); \}"
                                        : $scope.component.action = "function(selectedRecords,parentRecord,callback) { \n $UIEngine.edit(selectedRecords,parentRecord,callback); \n}", onfieldUpdate: false, requiredFields: [], disableActionDef: true
	                            };
	                        break;
	                    case "delete":
	                        $scope.component.isStandardAction = true;
	                        $scope.component.type = 'danger';
	                        $scope.component.mode = "read-only";
	                        if ($scope.component.actionType == "layoutActions")
                            {
                             $scope.actionDefinition = {
                                def: $scope.component.action = "function(record, errorFn, successFn){\n if (confirm(\'Are you sure you want to delete this record \'+ record.Name+\' ?\')) { $engine.delete(angular.copy(record), true, function (error) {\n if (error.success) {\n successFn(\'Record Deleted Successfully\', \'Success\');\n}\n else \n errorFn((error.data.Data) ? error.data.Data[0].ErrorMessage : error.data.ErrorMessage, (error.data.Data) ? error.data.Data[0].Code : error.data.Code); \n});}\n }", onfieldUpdate: false, requiredFields: [], disableActionDef: true
                                };
                             if (window.platform = 'cella'){
                                 $scope.component.action = `
                                                        function(record, errorFn, successFn) {
                                                          debugger;
                                                            if (confirm('Are you sure you want to delete this record ' + record.name + ' ?')) {
                                                                $engine.delete(angular.copy(record), true, function(result) {
                                                                    if (result.success) {
                                                                        successFn('Record Deleted Successfully', 'Success');
                                                                        window.open('/v/' + record.obj_type , '_self');
                                                                    } else
                                                                        errorFn( (result.data) ?  result.errorcode : result.errorcode, (result.data) ? result.errormessage : result.errormessage );
                                                                });
                                                            }
                                                        }` ;
                                 $scope.actionDefinition.def = $scope.component.action;
                             }
                            }
	                        else
	                            $scope.actionDefinition = {
	                                def: ($scope.component.singleRecordAction) ? $scope.component.action = "function(record,parentRecord,callback) {\n $UIEngine.delete(record,parentRecord,callback); \n}"
                                        : $scope.component.action = "function(selectedRecords,parentRecord,callback) { \n $UIEngine.delete(selectedRecords,parentRecord,callback);  \n }", onfieldUpdate: false, requiredFields: [], disableActionDef: true
	                            };
	                        break;
	                    case "customaction":
	                        $scope.component.isStandardAction = false;
	                        $scope.component.mode = "read-only";
	                        if ($scope.component.actionType == "layoutActions")
	                            $scope.actionDefinition = {
	                                def: $scope.component.action = "function(record, errorFn, successFn){ }", onfieldUpdate: false, requiredFields: [], disableActionDef: false
	                            };
	                        else
	                            $scope.actionDefinition = {
	                                def: ($scope.component.singleRecordAction) ? $scope.component.action = "function(record,parentRecord,callback) {\n}"
                                        : $scope.component.action = "function(selectedRecords,parentRecord,callback) { \n}", onfieldUpdate: false, requiredFields: [], disableActionDef: false
	                            };
	                        break;
	                    case "share":
	                        $scope.component.isStandardAction = true;
	                        $scope.component.type = 'info';
	                        $scope.component.mode = "read-only";
	                        if ($scope.component.actionType == "layoutActions")
	                            $scope.actionDefinition = {
	                                def: $scope.component.action = "function(record, errorFn, successFn){\n $scope.$emit('share',record, errorFn, successFn); \n}", onfieldUpdate: false, requiredFields: [], disableActionDef: true
	                            };
	                        break;
	                    case "clone":
	                        $scope.component.isStandardAction = true;
	                        $scope.component.type = 'warning';
	                        $scope.component.mode = "read-only";
	                        if ($scope.component.actionType == "layoutActions")
	                            $scope.actionDefinition = {
	                                def: $scope.component.action = "function(record, errorFn, successFn){ \n $scope.oldRecord=angular.copy(record);\n delete $scope.record.Id; $scope.editMode = \'edit\';\n\n}", onfieldUpdate: false, requiredFields: [], disableActionDef: true
	                            };
	                        break;
	                    case "saveandclose":
	                        $scope.component.isStandardAction = true;
	                        $scope.component.type = "info";
	                        $scope.component.mode = "edit";
	                        if ($scope.component.actionType == "layoutActions")
	                            $scope.actionDefinition = {
	                                def: $scope.component.action = "function(record, error, success){\n $scope.$emit('onSaveAndClose',record,error,success);}", onfieldUpdate: false, requiredFields: [], disableActionDef: true
	                            };
	                        break;
	                }
	            }

	            $scope.$watch('component.name', function () {
	                if (!$scope.component.isStandardAction)
	                    $scope.component.label = angular.copy($scope.component.name);
	            });

	            $scope.buttonTypes = [
					{ name: 'default', label: 'Default' },
					{ name: 'primary', label: 'Primary' },
					{ name: 'success', label: 'Success' },
					{ name: 'info', label: 'Info' },
					{ name: 'warning', label: 'Warning' },
					{ name: 'danger', label: 'Danger' },
					{ name: 'link', label: 'Link' }
	            ]
	            $scope.actionDefinition = {
	                def: ($scope.component.action) ? $scope.component.action : 'function(record, errorFn, successFn){\n}', onfieldUpdate: false, requiredFields: [], disableActionDef: $scope.component.isStandardAction
	            };

	            $scope.saveComponent = function () {
	                if ($scope.component.label && $scope.component.name) {
	                    var component = $scope.component;
	                    component.action = $scope.actionDefinition.def;

	                }
	                $scope.onsave({ newComponent: component });
	            }

	        }]
	    }
	}])
    .directive('fieldSelector', ['$de', '$deForm', function ($de, $deForm) {
        return {
            template: '<div class="input-group">' + $deForm.requiredAddon + '\
			<div class="col-sm-10 col-xs-8"><input  data-toggle="dropdown" ng-click="onclick($event)" ng-model="name" \
			ng-model-options="{ debounce: 200 }" ng-keydown="onKeyDown($event,selectedField)"\
			placeholder="Search and add reference fields..." class="form-control" type="search" ng-blur="hideFields()"/></div><div class="col-sm-2 col-xs-4"><button type="button" class="btn btn-default" ng-click="addField(selectedField)">Add Field</button></div>\
			<div ng-show="showFields" class="dropdown-menu" style="width: 80% ;margin-left:5px"><table class="table table-striped table-responsive">\
		    <thead ng-show="lookupError"><tr><td><div class="alert alert-danger" role="alert">\
		    <span class="glyphicon glyphicon-exclamation-sign" aria-hidden="true"></span>\
		    <span class="sr-only">Error:</span>{{lookupError}}</div></td></tr></thead>\
		    <tr  ng-repeat="recordField in lookupFields | filter: {label : searchFilter }" ng-click="rowSelected(recordField)" ng-keydown="onKeyDown($event, recordField)" id="{{$de.getValue(recordField, lookupIdField)}}"\
		    ng-class="{info: $parent.selected == $index}"\
		    ng-mouseover="$parent.selected = $index">\
		    <td>{{recordField.label}}</td></tr>\
            <tr ng-if="showProcess" >\
		    <td style="margin: 0 auto; text-align: center"><img ng-src="/application_css/images/loading.gif"><br/>Loading....</td></tr>\
            </table></div></div>',
            controller: ['$scope', '$attrs', '$element', '$de', '$deForm', '$timeout', '$compile', '$filter', function ($scope, $attrs, $element, $de, $deForm, $timeout, $compile, $filter) {
                $scope.designerUrl = window.designerUrl;
                $scope.templatesFolder = $de.templatesFolder;
                $scope.showProcess = false;
                $scope.lookupFields = [];
                var tempLookupFields = [];
                angular.forEach($scope.fields, function (value, key) {
                    if (value.ReferenceObjectName != null && value.ReferenceObjectName != undefined && value.ReferenceObjectName != '')
                        $scope.lookupFields.push(value);
                })
                tempLookupFields = $scope.lookupFields;
                $scope.showFields = true;
                $scope.hideFields = function () {
                    setTimeout(function () {
                        $scope.showFields = false;
                        $scope.$apply();
                    }, 200);
                }
                $scope.$watch('name', function (newvalue, oldvalue) {
                    var rpt = true;
                    if (!$scope.showProcess && newvalue != undefined) {
                        if (newvalue.indexOf('.') !== -1 && (newvalue.split('.').length - 1) >= 1) {
                            var serchField = newvalue.substring(0, newvalue.lastIndexOf('.'))
                            var arrSearchField = serchField.split('.');
                            for (var i = 0; i < arrSearchField.length; i++)
                                if (!demo.data.lookupObjFields[arrSearchField[i].toLowerCase()]) {
                                    $scope.lookupError = 'Wrong input';
                                    rpt = false;
                                    break;
                                }
                        }
                    }
                    if (rpt) {
                        if (!!oldvalue && oldvalue.lastIndexOf('.') > newvalue.lastIndexOf('.')) {
                            $scope.lookupError = !!$scope.lookupError ? '' : '';
                            var serchField = newvalue.substring(0, newvalue.lastIndexOf('.'));
                            var arrSearchField = serchField.split('.')[serchField.split('.').length - 1];
                            if (!!arrSearchField && demo.data.lookupObjFields[arrSearchField.toLowerCase()])
                                $scope.lookupFields = demo.data.lookupObjFields[arrSearchField.toLowerCase()];
                            else
                                $scope.lookupFields = tempLookupFields;
                        }

                        if ($scope.name != undefined) {
                            if ($scope.name.slice(-1) == '.' && !$scope.lookupError)
                                $scope.searchFilter = '';

                            if ($scope.name.lastIndexOf('.') >= 1)
                                $scope.searchFilter = $scope.name.substr($scope.name.lastIndexOf('.') + 1);
                            else
                                $scope.searchFilter = newvalue;
                            if (!!$scope.lookupFields) {
                                var records = $filter('filter')($scope.lookupFields, $scope.searchFilter);
                                if (records.length == 0)
                                    $scope.lookupError = 'No field found';
                                else if ($scope.lookupError && $scope.name.slice(-1) != '.')
                                    $scope.lookupError = '';
                            }
                        }
                    }
                });

                $scope.onKeyDown = function ($event, recordField) {
                    $scope.showFields = true;
                    switch ($event.keyCode) {
                        case 40://Key Down
                            if (isNaN($scope.selected))
                                $scope.selected = 0;
                            else if ($scope.lookupFields) {
                                if ($scope.selected < ($scope.lookupFields.length - 1))
                                    ++$scope.selected;
                            }
                            break;
                        case 38://Key Up
                            if (isNaN($scope.selected))
                                $scope.selected = 0;
                            else if ($scope.lookupFields) {
                                if ($scope.selected > 0)
                                    --$scope.selected;
                            }
                            break;
                        case 27: //Kye Escape
                            $scope.name = $de.getValue($scope.record, $scope.field.nameField);
                            break;
                        case 9: //Key Tab
                        case 13: //Key Enter
                            if ($element.find('.input-group').hasClass('open')) {
                                var records = $filter('filter')($scope.lookupFields, $scope.name);
                                if (records.length == 0)
                                    records = $scope.lookupFields;
                                $scope.rowSelected(records[$scope.selected]);
                            }
                            break;
                    }

                    //40 for Down; 38 for Up 
                    if ($event.keyCode == 40 || $event.keyCode == 38) {
                        if ($element.find('table tr').length <= $scope.selected)
                            $scope.selected--;
                        var position = $element.find('table tr:nth-child(' + $scope.selected + ')').position();
                        if (position) {
                            var elementTop = position.top;
                            var scrollTop = $element.find('.dropdown-menu').scrollTop();
                            var scrollTo = elementTop + scrollTop;
                            $element.find('.dropdown-menu').scrollTop(scrollTo);
                        }
                    }

                    //KeyCode = 8; for backspace
                    if ($event.keyCode == 127 || $event.keyCode == 8) {
                        //RegEx to check if more than one "." is entered
                        var regEx = new RegExp("/[.]{2}/i", "g");
                        if (!regEx.test($scope.name)) {
                            if ($scope.name.slice(-1) == '.') {
                                $scope.lookupError = !!$scope.lookupError ? '' : '';
                                var SerchField = $scope.name.substring(0, $scope.name.lastIndexOf('.'));
                                var arrSearchField = SerchField.split('.')[SerchField.split('.').length - 2];
                                if (!!arrSearchField && demo.data.lookupObjFields[arrSearchField.toLowerCase()])
                                    $scope.lookupFields = demo.data.lookupObjFields[arrSearchField.toLowerCase()];
                                else
                                    $scope.lookupFields = tempLookupFields;
                            }
                        }
                        else
                            $scope.lookupError = 'wrong input';
                    }

                    //keycode 190 = period(.); 46 for delete
                    if ($event.keyCode == 190 || $event.keyCode == 46) {
                        if (!!$scope.name) {
                            //if ($scope.name.split(".").length >= 1)
                            //    $scope.getObjectName = $scope.name.substr($scope.name.lastIndexOf('.') + 1);
                            //else
                            //    $scope.getObjectName = $scope.name;
                            for (var i = 0; i < $scope.lookupFields.length; i++)
                                if ($scope.lookupFields[i].name.toLowerCase() == recordField.name.toLowerCase()) {
                                    $scope.lookUpObjectDetails = $scope.lookupFields[i];
                                    break;
                                }

                            if (!!$scope.lookUpObjectDetails && $scope.lookUpObjectDetails.type.toLowerCase() == 'lookup') {
                                $scope.searchFilter = '';
                                $scope.lookupFields = '';
                                $scope.showProcess = true;

                                $scope.getAllFields = function (keyword, onsuccess, onerror) {
                                    angular.element('[ng-app]').injector().get('platform').getParseFields(keyword, function (error) {
                                        var records = error.parseData;
                                        if (records.length <= 0)
                                            onerror('Could not reach the server');
                                        else
                                            onsuccess({ totalCount: records.length, idField: 'Id', nameField: 'Name', fields: [{ label: 'Name', type: 'text', name: 'Name' }], records: records });
                                    });
                                }
                                if (!$scope.selectedField.getAllFields)
                                    $scope.getAllFields($scope.lookUpObjectDetails.ReferenceObjectName, function (result) {
                                        $scope.showProcess = false;
                                        angular.forEach(result.records, function (record) {
                                            //record.ObjectDepth = $scope.lookUpObjectDetails.name.substring(0, $scope.lookUpObjectDetails.name.lastIndexOf('.'))
                                            record.ObjectDepth = $scope.lookUpObjectDetails.name;
                                            record.name = record.ObjectDepth + '.' + record.name;
                                        });
                                        $scope.lookupFields = result.records;
                                        demo.data.lookupObjFields[$scope.lookUpObjectDetails.label.toLowerCase()] = result.records;
                                        if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
                                    }, function (error) {
                                        $scope.showProcess = false;
                                        $de.showError(error);
                                        if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
                                    });
                                else
                                    $scope.selectedField.getAllFields($scope.lookUpObjectDetails.ReferenceObjectName, function (result) {
                                        $scope.showProcess = false;
                                        angular.forEach(result.records, function (record) {
                                            record.ObjectDepth = $scope.lookUpObjectDetails.name.substring(0, $scope.lookUpObjectDetails.name.lastIndexOf('.'));
                                            record.name = record.ObjectDepth + '.' + record.name;
                                        });
                                        $scope.lookupFields = result.records;
                                        demo.data.lookupObjFields[$scope.lookUpObjectDetails.label.toLowerCase()] = result.records;
                                        if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
                                    }, function (error) {
                                        $scope.showProcess = false;
                                        $de.showError(error);
                                        if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
                                    });
                                //$timeout(function () {
                                //    demo.data.lookupObjFields[$scope.lookUpObjectDetails.label.toLowerCase()] = angular.copy(demo.data.relatedListFields["Object1"]);
                                //    $scope.lookupFields = demo.data.lookupObjFields[$scope.lookUpObjectDetails.label.toLowerCase()];
                                //    angular.forEach(demo.data.lookupObjFields[$scope.lookUpObjectDetails.label.toLowerCase()], function (fieldDetails) {
                                //        fieldDetails.label = 'inner-' + $scope.lookUpObjectDetails.label + '-' + fieldDetails.label;
                                //    })
                                //    $scope.lookupRecords = '';
                                //    $scope.lookupIdField = "ID";
                                //    $scope.lookupNameField = "Name";
                                //    $scope.showProcess = false;
                                //    //$scope.getDescribeObjectByName($scope.lookUpObjectDetails.name, function (result) {
                                //    //    $scope.lookupFields = result.fields;
                                //    //    demo.data.lookupObjFields[$scope.lookUpObjectDetails.name]  = [result.fields];
                                //    //    $scope.lookupRecords = result.records;
                                //    //    $scope.lookupIdField = result.idField;
                                //    //    $scope.lookupNameField = result.nameField;
                                //    //    if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
                                //    //}, function (error) {
                                //    //    $de.showError(error);
                                //    //    if (!$scope.$$phase && !$scope.$root.$$phase) $scope.$apply();
                                //    //});
                                //}, 800);
                            }
                            else
                                $scope.lookupError = 'Not a lookup field';
                        }
                        else
                            $scope.lookupError = 'wrong input';
                    }

                    switch ($event.keyCode) {
                        case 9: //Key Tab
                        case 13: //Key Enter
                        case 27: //Key Escape
                        case 46: //Key Delete
                            $element.find('.input-group').removeClass('open');
                            break;
                        default:
                            $element.find('.input-group').addClass('open');
                    }
                }

                //$scope.$watch('field.readonly', function (newValue) {
                //    if (!newValue) {
                //        $scope.lookupFields = $scope.fields;
                //        $scope.lookupRecords = '';
                //        $scope.lookupIdField = "id";
                //        $scope.lookupNameField = "name";
                //    }
                //})

                $scope.rowSelected = function (record) {
                    $scope.selectedField = record;
                    if (!!$scope.name)
                        $scope.name = $scope.name.substring(0, $scope.name.lastIndexOf('.') + 1) + record.label;
                    else
                        $scope.name = record.label;
                    //record.ObjectDepth = $scope.name.substring(0, $scope.name.lastIndexOf('.'));
                    $scope.showFields = false;
                }

                $scope.addField = function (record) {
                    if (record) {
                        for (var i = 0; i < $scope.filteredFields.length; i++)
                            if ($scope.filteredFields[i].name == record.name && $scope.filteredFields[i].ObjectDepth == record.ObjectDepth) {
                                $scope.lookupError = 'Sorry field is already present';
                                $element.find('.input-group').addClass('open');
                                return;
                            }
                        $scope.filteredFields.push(record);
                        $scope.name = '';
                        $scope.searchFilter = '';
                        $scope.selectedField = '';
                    }
                }
            }]
        }
    }])