﻿/*
Created By : Satyendra Rawat, Jan 25, 2013
Summary  :  multipart and multithread uploading files , slice the file and upload part.
*/
var enzigma = enzigma || {};
enzigma.business = enzigma.business || {};
enzigma.business.uploaders = {};

enzigma.business.fileCacheInfo = function (file, folderPath) {
    this.fileName = file.name;
    this.folderPath = folderPath;
    this.key;
    this.md5Hash; // = ''; //Calculate MD5 Hash using http://marcu87.github.com/hashme/
    this.getKey = function () {
        return this.fileName + '~' + this.md5Hash;
    };
    this.uploader = null;
    this.genrateMd5 = function (file) {
        var currentObj = this;
        new hashMe(file, function OutputHash(msg) {
            currentObj.key = currentObj.fileName + msg;
        });
    }
    this.genrateMd5(file);
}

enzigma.business.multiPartUploader = function (file, fileIndex, onCompleteCallback, onInitCompletedResetValueId) {
    this.partsUploaded = 0;
    this.UploadId;
    this.FileName = file.name;
    this.FieldName;
    this.ServerFileName;
    this.FieldValue;
    this.FileSize = file.size;
    this.Folder;
    this.Status;
    this.SFAttachId;
    this.SFAttachVersionId;
    this.SFUrl;
    this.ServerUploadID;
    this.partSize;
    this.SessionId;
    this.file = file;
    this.IsAmazon;
    this.cancelled = false;
    this.strKey;
    this.bucket;
    this.IsRestore;
    this.fileIndex = fileIndex;
    this.LastTime;
    this.LastUpload;
    this.startTime = (new Date()).getTime();
    this.onCompleted = onCompleteCallback;
    this.baseUrl;
    this.onInitCompleted = onInitCompletedResetValueId;
    this.abortRead = function () {
        this.cancelled = true;
    };
    this.pause = function () {
        this.cancelled = true;
    };
    this.resume = function () {
        this.cancelled = false;
        this.upload();
    };

    this.totalUploadingPercent = function () {
        var itotalpercent = 0;
        for (var iThreadIndex = 0; iThreadIndex < this.Threads.length; ++iThreadIndex) {
            itotalpercent += this.Threads[iThreadIndex].partPercent;
        }
        var totalPercent = ((this.partsUploaded * 100) + itotalpercent) / this.numberOfParts;
        if (totalPercent > 100)
            totalPercent = 100;
        return totalPercent;
    },
    this.fileSizeUnit = function () {
        var oneMB = 1024 * 1024;
        var fileUnit;
        if (this.file) {
            if (this.file.size > oneMB * 1024)
                fileUnit = 'GB';
            else if (this.file.size > oneMB)
                fileUnit = 'MB';
            else
                fileUnit = 'KB';
        }
        this.fileUnit = fileUnit;
        return this.fileUnit;
    },
    this.uploadedSize = function (totalpercentage) {
        var uploaded = (this.FileSize * totalpercentage) / 100;
        var oneMB = 1024 * 1024;
        if (this.fileUnit == 'GB')
            return (Math.round(uploaded * 100 / (oneMB * 1024)) / 100).toString();
        else if (this.fileUnit == 'MB')
            return (Math.round(uploaded * 100 / (oneMB)) / 100).toString();
        else
            return (Math.round(this.file.size * 100 / 1024) / 100).toString();
    },
    this.uploadingSpeedFile = function (totalpercentage) {

        var currentTime = (new Date()).getTime();
        var nTimeDelta = currentTime - this.LastTime;
        if ((!nTimeDelta) || (nTimeDelta == 0))
            nTimeDelta = 1;
        this.LastUpload = (this.LastUpload) ? this.LastUpload : 0;
        totalpercentage = (totalpercentage > 0) ? totalpercentage : 1;

        var uploaded = ((totalpercentage * this.FileSize) / 100);
        var nCurrentUpload = uploaded - this.LastUpload;
        var UploadRate = (nCurrentUpload * 1000) / nTimeDelta;
        if (UploadRate <= 0)
            return this.LastSpeed;
        var iSpeed = (Math.round(UploadRate)).toString() + 'B/s';

        if (UploadRate > 1024 * 1024 * 1024) {
            iSpeed = (Math.round(UploadRate * 100 / (1024 * 1024)) / 100).toString() + 'GB/s';
        }
        else if (UploadRate > 1024 * 1024) {
            iSpeed = (Math.round(UploadRate * 100 / (1024 * 1024)) / 100).toString() + 'MB/s';
        } else if (UploadRate > 1024) {
            iSpeed = (Math.round(UploadRate * 100 / 1024) / 100).toString() + 'KB/s';
        }

        if (Math.abs(nTimeDelta) >= 1000) // reset every second
        {
            this.LastUpload = uploaded;
            this.LastTime = currentTime;
        }
        this.LastSpeed = iSpeed;

        return iSpeed;
    },
    this.fileSize = function () {
        var oneMB = 1024 * 1024;
        this.fileUnit = this.fileSizeUnit();
        if (this.file) {
            var fileSize = 0;
            if (this.file.size > oneMB * 1024)
                fileSize = (Math.round(this.file.size * 100 / (oneMB * 1024)) / 100).toString() + 'GB';
            else if (this.file.size > oneMB)
                fileSize = (Math.round(this.file.size * 100 / (oneMB)) / 100).toString() + 'MB';
            else
                fileSize = (Math.round(this.file.size * 100 / 1024) / 100).toString() + 'KB';
            return fileSize;
        }
    };
    this.uploadingSpeed = function (totalpercentage) {
        var currentTime = (new Date()).getTime();
        var oneMB = 1024 * 1024;
        if (this.startTime) {
            var duration = (currentTime - this.startTime) / 1000;
            var speedBps = ((this.partSize * this.numberOfParts) / duration).toFixed(2);
            if (speedBps > oneMB)
                return (speedBps / (oneMB)).toFixed(2) + ' MBps';
            else
                return (speedBps / 1024).toFixed(2) + ' KBps';
        }
    };
    this.setDataObject = function (uploaded) {
        this.IsRestore = true;
        this.SFAttachId = uploaded.SFAttachId;
        this.SFAttachVersionId = uploaded.SFAttachVersionId;
        this.IsAmazon = uploaded.IsAmazon;
        this.Status = uploaded.Status;
        this.ServerFileName = uploaded.ServerFileName;
        this.UploadId = uploaded.UploadId;
        this.partsUploaded = uploaded.partsUploaded;
        this.ServerUploadID = uploaded.ServerUploadID;
        this.bucket = uploaded.bucket;
        for (var iIndex = 0; iIndex < this.Threads.length; ++iIndex)
            this.Threads[iIndex].setDataObject(uploaded.Threads[iIndex]);
    };
    this.getDataObject = function () {
        var arrThreads = [];
        for (var iIndex = 0; iIndex < this.Threads.length; ++iIndex)
            arrThreads.push(this.Threads[iIndex].getDataObject());
        return { LocalFileName: this.FileName, bucket: this.bucket, FieldValue: this.FieldValue, FieldName: this.FieldName, Folder: this.Folder, FileSize: this.FileSize, SFAttachId: this.SFAttachId, SFAttachVersionId: this.SFAttachVersionId, IsAmazon: this.IsAmazon, Status: this.Status, ServerFileName: this.ServerFileName, UploadId: this.UploadId, partsUploaded: this.partsUploaded, ServerUploadID: this.ServerUploadID, Threads: arrThreads };
    };
    this.initiateMultiPartUploader = function (baseUrl, strFolder, strFieldName, strFieldValue, strSFUrl, strSessionId) {
        this.Folder = strFolder;
        this.FieldValue = strFieldValue;
        this.FieldName = strFieldName;
        this.Status = "InProgress";
        this.SFUrl = strSFUrl;
        this.SessionId = strSessionId;
        this.baseUrl = baseUrl;
    };

    this.getPartSize = function (iFileSize) {
        var iRetMBSize = 6;
        var fiveGB = 50000 * 1024 * 1024; //4 * 1024 * 1024 * 1024;
        if (iFileSize > fiveGB) {
            iRetMBSize = 6 + Math.ceil(((iFileSize - fiveGB) / 10000));
        }
        return iRetMBSize * 1024 * 1024;
    };

    this.getThreadCount = function (iPartCount) {
        var iRet = 1;
        if (iPartCount > 100) {
            iRet = 5;
        }
        else if (iPartCount > 10) {
            iRet = 3;
        }
        return iRet;
    };
    this.genrateMd5 = function (mycallback) {
        var currentObj = this;
        debugger;
        new hashMe(this.file, function OutputHash(strmd5) {
            currentObj.strKey = currentObj.FileName + strmd5;
            mycallback(currentObj, currentObj.fileIndex, currentObj.strKey)
        });
    }
    this.generateParts = function () {
        var iFileSize = this.file.size;
        var iMinPartSize = this.getPartSize(iFileSize);
        var iPartCount = Math.ceil(iFileSize / iMinPartSize);
        var iThreadCount = this.getThreadCount(iPartCount);
        var iPartsPerThread = Math.ceil(iPartCount / iThreadCount);
        var iPartIndex = 0;
        var iFilePosition = 0;
        this.Threads = [];
        for (var iThreadIndex = 0; iThreadIndex < iThreadCount; ++iThreadIndex) {
            var threadCurrent = new enzigma.business.multiPartUploaderThread(this, iThreadIndex);
            for (var iThreadPartIndex = 0; iThreadPartIndex < iPartsPerThread && iFilePosition < iFileSize; ++iThreadPartIndex) {
                var part = new enzigma.business.multiPartUploaderPart(threadCurrent, iPartIndex, iThreadPartIndex);
                part.start = iFilePosition;

                if (iPartIndex == iPartCount - 1)
                    part.end = iFileSize;
                else
                    part.end = iFilePosition + iMinPartSize;

                iFilePosition = part.end;

                threadCurrent.parts.push(part);
                ++iPartIndex;
            }
            this.Threads.push(threadCurrent);
        }

        this.numberOfParts = iPartCount;
        this.partSize = iMinPartSize;
    };
    this.completedMultipartRequest = function () {
        var arrAllThreadParts = [];
        for (var iThreadIndex = 0; iThreadIndex < this.Threads.length; ++iThreadIndex) {
            for (var iPartIndex = 0; iPartIndex < this.Threads[iThreadIndex].parts.length; ++iPartIndex) {
                var part = this.Threads[iThreadIndex].parts[iPartIndex];
                arrAllThreadParts[part.PartNumber - 1] = new enzigma.model.partETag(part.PartNumber, part.ETag, this.partSize);
            }
        }
        return { FileName: this.ServerFileName, ServerUploadId: this.ServerUploadID, Folder: this.Folder, bucket: this.bucket, SFAttachVersionId: this.SFAttachVersionId, SFAttachId: this.SFAttachId, UploadId: this.UploadId, PartSize: this.partSize, TotalPart: this.numberOfParts, PartETags: arrAllThreadParts };
    };
    this.checkDuplicate = function () {
        var initRequest = new enzigma.model.fileInitRequest(this.file.name, this.numberOfParts, this.file.size, this.partSize, this.Folder, this.FieldName, this.FieldValue);
        //Call REST Api to create upload on the server
        enzigma.business.restClient.checkDuplicate(initRequest, this.SFUrl, this.SessionId, this, this.upload);
    };
    this.upload = function () {
        this.startTime = (new Date()).getTime();
        this.LastTime = (new Date()).getTime();
        if (!this.UploadId) {
            var initRequest = new enzigma.model.fileInitRequest(this.file.name, this.numberOfParts, this.file.size, this.partSize, this.Folder, this.FieldName, this.FieldValue);
            //Call REST Api to create upload on the server
            enzigma.business.restClient.initPartUpload(initRequest, this.SFUrl, this.SessionId, this, this.uploadCreatedOnServer);
        }
        else {
            if (this.numberOfParts <= this.partsUploaded) {
                for (var iIndex = 0; iIndex < this.Threads.length; ++iIndex) {
                    updateProgressbar(this, this.Threads[iIndex].threadNumber, this.Threads[iIndex].lastPartUploadedThreadIndex, this.Threads[iIndex].parts.length);
                }
                this.completeUpload();
            }
            else {
                for (var iIndex = 0; iIndex < this.Threads.length; ++iIndex) {
                    this.Threads[iIndex].resume();
                }
            }
        }
    };

    this.uploadCreatedOnServer = function (result) {
        this.UploadId = result.UploadId;
        this.SFAttachId = result.SFAttachId;
        this.SFAttachVersionId = result.SFAttachVersionId;
        this.ServerUploadID = result.ServerUploadId;
        this.Status = "InProgress";
        this.ServerFileName = result.FileName;
        this.IsAmazon = result.IsAmazon;
        this.bucket = result.DefaultFolder;
        // stored  current infomation to local storage
        //cacheFile.set(this.strKey, this.getDataObject());
        this.onInitCompleted(this);
        this.upload();
    };
    this.partUploadCompleted = function (part) {
        ++this.partsUploaded;
        if (this.partsUploaded == this.numberOfParts) {
            this.completeUpload();
        }
    };

    this.completeUpload = function () {
        //Call REST API to complete the multipart upload
        var completedRequest = this.completedMultipartRequest();
        if (this.IsAmazon) {
            var xmlcompleteRequest = enzigma.business.amazonstorage.getCompleteMultipartUpload(completedRequest.PartETags);
            var signRequest = { FileName: this.ServerFileName, IsCompleted: true, Bucket: this.bucket, UploadId: this.ServerUploadID };
            enzigma.business.restClient.signatureRequest(xmlcompleteRequest, this.fileIndex, signRequest, this.SFUrl, this.SessionId, this, this.amazonUploadingCompleted, this.SFAttachId, this.baseUrl);
        }
        else
            enzigma.business.restClient.completeMultipartUplod(completedRequest, this.SFUrl, this.SessionId, this, this.onCompleted);
    };
    this.amazonUploadingCompleted = function () {
        var completedRequest = this.completedMultipartRequest();
        enzigma.business.restClient.completeMultipartUplod(completedRequest, this.SFUrl, this.SessionId, this, this.onCompleted);
    }
    //this.genrateMd5();
    this.generateParts();

}

enzigma.business.multiPartUploaderThread = function (uploader, iThreadIndex) {
    this.uploader = uploader;
    this.partPercent = 0;
    this.threadNumber = iThreadIndex;
    this.parts = [];
    this.lastPartUploaded = -1;
    this.lastPartUploadedThreadIndex = -1;
    this.resume = function () {
        if (this.uploader.cancelled) {
           return;
        }
        if (this.lastPartUploadedThreadIndex + 1 >= this.parts.length) {
            //Last part of the thread already uploaded
            updateProgressbar(this.uploader, this.threadNumber, this.lastPartUploadedThreadIndex, this.parts.length);
            return;
        }
        else {
            this.parts[this.lastPartUploadedThreadIndex + 1].startUpload();
        }
    };
    this.setDataObject = function (thread) {
        this.lastPartUploaded = thread.lastPartUploaded;
        this.threadNumber = thread.threadNumber;
        this.lastPartUploadedThreadIndex = thread.lastPartUploadedThreadIndex;
        for (var iIndex = 0; iIndex < this.parts.length; ++iIndex)
            this.parts[iIndex].setDataObject(thread.parts[iIndex]);
    };
    this.getDataObject = function () {
        var arrParts = [];
        for (var iIndex = 0; iIndex < this.parts.length; ++iIndex)
            arrParts.push(this.parts[iIndex].getDataObject());
        return { threadNumber: this.threadNumber, lastPartUploaded: this.lastPartUploaded, lastPartUploadedThreadIndex: this.lastPartUploadedThreadIndex, parts: arrParts };
    };

}

enzigma.business.multiPartUploaderPart = function (threadParent, iPartIndex, iThreadPartIndex) {
    this.PartNumber = iPartIndex + 1;
    this.start = -1;
    this.end = -1;
    this.ETag = null;
    this.uploadedOn = null;
    this.thread = threadParent;
    this.threadPartNumber = iThreadPartIndex;

    this.size = function () {
        return this.end - this.start + 1;
    };
    this.setDataObject = function (part) {
        this.PartNumber = part.PartNumber;
        this.start = part.start;
        this.end = part.end;
        this.ETag = part.ETag;

    };
    this.getDataObject = function () {
        return { PartNumber: this.PartNumber, end: this.end, start: this.start, ETag: this.ETag };
    };

    this.startUpload = function () {
        if (!this.uploadedOn) {
            //Open the file
            //Splice betweeen start and end
            //close the file
            //Call REST Api to actually upload the part read above
            var blob;
            debugger;
            if (this.thread.uploader.file.slice) {// for chrome
                blob = this.thread.uploader.file.slice(this.start, this.end);
            } else if (this.thread.uploader.file.mozSlice) {// for mozilla
                blob = this.thread.uploader.file.mozSlice(this.start, this.end);
            }
            else if (this.thread.uploader.file.webkitSlice) {// for safari
                blob = this.thread.uploader.file.webkitSlice(this.start, this.end);
            }
            if (this.thread.uploader.IsAmazon) {
                var signRequest = { FileName: this.thread.uploader.ServerFileName, IsCompleted: false, PartNumber: this.PartNumber, Bucket: this.thread.uploader.bucket, UploadId: this.thread.uploader.ServerUploadID };
                enzigma.business.restClient.signatureRequest(blob, this.thread.uploader.fileIndex, signRequest, this.thread.uploader.SFUrl, this.thread.uploader.SessionId, this, this.uploadCompleted, this.thread.uploader.SFAttachId, this.thread.uploader.baseUrl);
            }
            else
                enzigma.business.restClient.uploadPart(blob, this.thread.uploader.SFUrl, this.thread.uploader.fileIndex, this.thread.uploader.SessionId, this, this.uploadCompleted);
        }
        else
            this.uploadNextPart();
    };

    this.uploadCompleted = function (result) {
        //if successful start next part or throw error
        if (this.thread.uploader.cancelled) {
            return;
        }
        this.uploadedOn = new Date();
        if (this.thread.uploader.IsAmazon) {
            this.ETag = result;
        }
        else if ($.browser.chrome)
            this.ETag = result.ETag;
        else if (result.ETag)
            this.ETag = result.ETag[0];
        else
            this.ETag = result.ETag;

        this.thread.lastPartUploadedThreadIndex = this.thread.lastPartUploadedThreadIndex + 1;
        this.thread.lastPartUploaded = this.PartNumber;
        this.thread.partPercent = 0;
        this.thread.uploader.partUploadCompleted(this);
        updateProgressbar(this.thread.uploader, this.thread.threadNumber, this.thread.lastPartUploadedThreadIndex, this.thread.parts.length);
        this.uploadNextPart();
    };

    this.uploadNextPart = function () {
        this.thread.resume();
    };
}