<%@ Page Language="C#" AutoEventWireup="true" Inherits="tools_AttachmentsMigrator" MasterPageFile="~/MasterPage.master" CodeBehind="AttachmentsMigrator.aspx.cs" %>

<%@ Import Namespace="enzigma.sforce.webapp.code" %>
<%@ Register Assembly="enzigma.controls" Namespace="enzigma.controls.web" TagPrefix="cc2" %>
<%@ Register Src="~/controls/SearchCriteria.ascx" TagName="SearchCriteria" TagPrefix="uc3" %>
<%@ Register Src="~/controls/MergeFieldHelper.ascx" TagName="MergeFieldHelper" TagPrefix="uc2" %>
<%@ Register Assembly="enzigma.controls" Namespace="enzigma.web.controls" TagPrefix="cc1" %>
<%@ Register Src="~/controls/SalesforceLogin.ascx" TagName="SalesforceLogin" TagPrefix="uc1" %>
<asp:Content ContentPlaceHolderID="PageContent" ID="PageContent" runat="server">
    <script type="text/javascript" src="../../scripts/multipart/enzigma/business/updateProgressbar.js"></script>
    <style>
        .heading-color {
            color: #005fb2;
        }

        .setMargin {
            padding-top: 22px;
        }
    </style>
    <script type="text/javascript" src="../../scripts/common.js"></script>
    <script type="text/javascript">
        $(document).ready(function () {
            $('link[href="../../App_Themes/Default/common.css"]').remove();

        });
        var progressOverview = false;
        var progressDetails = false;
        var strMigratorID = '<%=hdnMigratorID.Value%>';


        function hideToast() {
            $('#PageContent_toaststatus').css('display', 'none');
            document.getElementById('<%=lbStatus.ClientID%>').value = "";
            return false;
        }

        function ClearAllIntervals() {
            if (progressOverview)
                progressOverview.StopMonitor();
            if (progressDetails)
                progressDetails.StopMonitor();
        }

        function ResetProgress() {

            if (progressOverview)
                progressOverview.UpdateProgress(0, ' ');
            if (progressDetails)
                progressDetails.UpdateProgress(0, ' ');

            document.getElementById('PageContent_progressOverview').style.width = "100%";
            document.getElementById('PageContent_progressDetails').style.width = "100%";

            return true;
        }

        function OnStartMigration(data) {
            if (window.event) {
                window.event.cancelBubble = true;
                window.event.returnValue = false;
            }
            //document.getElementById('<%=buttonCancel.ClientID%>').disabled = false;
            if (!confirm('<%=Resources.Messages.ConfirmMigrate%>'))
                return false;

            if (!service && g_bBodyAlreadyLoaded)
                OnBodyLoad();

            if (service) {
                progressOverview.OnRetreiveProgress = 'GetMigrationProgress()';
                progressOverview.StartMonitor(1000);
                service.StartMigration(strMigratorID, DisplayOverviewStatus);
                progressDetails.OnRetreiveProgress = 'GetAttachmentsStatus()';
                progressDetails.StartMonitor();
                window.setTimeout('DisbleMigrationButtons()', 100);
            } else
                alert('Please wait for page to load, only after page is loaded this tool can run properly.');

            return false;
        }

        function DisbleMigrationButtons() {
            document.getElementById('<%=buttonRetreive.ClientID%>').disabled = true;
            document.getElementById('<%=buttonStart.ClientID%>').disabled = true;
            document.getElementById('<%=buttonCancel.ClientID%>').disabled = false;
            document.getElementById('<%=cmbLinkedObjects.ClientID%>').disabled = true;
            //document.getElementById('<%=buttonCancel.ClientID%>').OnClientClick = 'return OnCancelMigration();';
        }

        function GetAttachmentsStatus() {
            service.GetMigratingAttachments(strMigratorID, DisplayAttachmentsStatus, OnError);
        }

        function DisplayAttachmentsStatus(result) {
            if (result) {
                for (var iIndex = 0; iIndex < result.length; ++iIndex) {
                    var attachment = result[iIndex];
                    var divStatus = document.getElementById('divStatus_' + attachment.ID);
                    if (divStatus)
                        divStatus.innerHTML = attachment.Status;
                }
            } else
                alert('No records found to attach');
        }

        function DisplayOverviewStatus(result) {
            progressOverview.UpdateStatus(result.ErrorMessage);
            progressOverview.EnsureVisible();
        }

        function OnError(error) {
            if (error.get_message)
                alert(error.get_message() + '\n' + error.get_stackTrace());
        }

        function OnCancelMigration() {
            service.CancelMigration(strMigratorID, OnCancelled);
            //window.setTimeout('StopProgressMonitors()', 4000);
            //progressDetails.
            //progressOverview
        }

        function OnCancelled(result) {

            progressOverview.UpdateStatus(result.ErrorMessage);

        }

        function GetMigrationProgress() {
            service.GetMigrationProgress(strMigratorID, DisplayMigrationProgress, OnError);
        }

        function DisplayMigrationProgress(result) {
            if (result.CurrentRecordProgress.Progress > 0)
                $('.ProgressBarValue').css("background-color", "#5eb4ff", "important");
            var iProgress = (result.TotalRecords > 0) ? parseInt(100 * result.RecordsProcessed / result.TotalRecords, 10) : 0;
            progressOverview.UpdateProgress(iProgress, result.OverallStatus);
            progressDetails.UpdateProgress(result.CurrentRecordProgress.Progress, result.CurrentRecordProgress.ProgressStatus);
            progressDetails.EnsureVisible();
            if (!result.InProgress) {
                window.setTimeout('StopProgressMonitors()', 4000);
                //GetMigrationProgress();
                //GetAttachmentsStatus();
            }
        }

        function StopProgressMonitors() {
            document.getElementById('<%=buttonRetreive.ClientID%>').disabled = false;
            document.getElementById('<%=buttonStart.ClientID%>').disabled = true;
            document.getElementById('<%=buttonCancel.ClientID%>').disabled = true;
            document.getElementById('<%=cmbLinkedObjects.ClientID%>').disabled = false;
            progressOverview.StopMonitor();
            progressDetails.StopMonitor();
            GetAttachmentsStatus();
        }

        function OnToggle(strID, bDontCancel) {
            var divToggle = document.getElementById(strID);
            if (divToggle) {
                if (divToggle.style.display == 'none')
                    divToggle.style.display = '';
                else
                    divToggle.style.display = 'none'
            }
            if (window.event) {
                window.event.cancelBubble = true;
                window.event.returnValue = false;
            }
            return false;
        }

        $(document).ready(function ($) {
            OnBodyLoad();
            $("#tooltip").hover(function () {
                $("#help").css("display", "block");

            }, function () {
                $("#help").css("display", "none");

            });
        });

        function OnBodyLoad() {
            service = new enzigma.sforce.webapp.webservices.InternalFTPAttachmentsService();
            progressOverview = <%=progressOverview.ClientID%>_obj;
            progressDetails = <%=progressDetails.ClientID%>_obj;
            document.getElementById('<%=buttonCancel.ClientID%>').disabled = true;
            document.getElementById('<%=buttonStart.ClientID%>').disabled = true;
        };
        var g_Validator = false;

        function CheckLimit() {
            var strComment = document.getElementById('<%=edComment.ClientID%>').value;
            if (strComment.length > 255) {
                alert('Maximum 255 characters allowed.');
                //g_Validator.isvalid = 'visible';
                //ValidatorUpdateDisplay(true);//g_Validator);//btnRetreive
                document.getElementById('<%=buttonRetreive.ClientID%>').disabled = true;
            } else {
                //ValidatorUpdateDisplay(false);
                document.getElementById('<%=buttonRetreive.ClientID%>').disabled = false;
            }
        };

        var g_bBodyAlreadyLoaded = false;
        var service = false;
        var m_iProgressInterval = false;
    </script>
    <link href="../../css/vendor/slds/assets/styles/salesforce-lightning-design-system.min.css" rel="stylesheet" />
    <asp:ScriptManager ID="ScriptManager" runat="server" OnAsyncPostBackError="ScriptManager_AsyncPostBackError">
        <Services>
            <asp:ServiceReference Path="~/WebServices/FTPAttachments.asmx" />
        </Services>
    </asp:ScriptManager>

    <div class="slds-scope">
        <div class="slds-p-around_small">
            <div class="slds-page-header">
                <div class="slds-grid">
                    <div class="slds-col slds-has-flexi-truncate">
                        <div class="slds-media slds-no-space slds-grow">
                            <div class="slds-media__figure">
                                <span class="slds-icon_container slds-icon-standard-opportunity" title="FTP Attachments Migration Tool">
                                    <svg class="slds-icon slds-page-header__icon slds-p-around--xx-small" aria-hidden="true">
                                         <use xlink:href="../../css/vendor/slds/assets/icons/action-sprite/svg/symbols.svg#record"></use>
                                    </svg>
                                </span>
                            </div>
                            <div runat="server" id="tdTitle" class="slds-media__body">
                                <nav>
                                    <ol class="slds-breadcrumb slds-line-height_reset">
                                        <ul class="slds-breadcrumb__item">
                                            <span>Tool</span>
                                        </ul>
                                    </ol>
                                </nav>
                                <h1 class="slds-page-header__title slds-m-right_small slds-align-middle slds-truncate" title="">FTP Attachments Migration Tool</h1>
                            </div>
                        </div>
                    </div>
                    <div class="slds-col slds-no-flex slds-grid slds-align-top">
                    </div>
                </div>
                <div class="slds-grid slds-page-header__detail-row">
                    <div class="slds-grid slds-wrap slds-p-around--small">
                        <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                            <div class="slds-form-element">
                                <div class="slds-form-element__icon slds-align-middle">
                                    <span class="slds-text-body_regular">This application is add-on for FTP Attachments applications. It can be used to migrate your Salesforce attachments to FTP Attachments application.</span>
                                    <button class="slds-button slds-button_icon slds-button slds-button_icon" id="tooltip" aria-describedby="help" title="Help">
                                        <svg class="slds-button__icon" aria-hidden="true">
                                             <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#info" />
                                         </svg>
                                        <span class="slds-assistive-text">Help</span>
                                    </button>
                                    <span class="slds-popover slds-popover_tooltip slds-p-around_xx-small" role="tooltip" id="help" style="display: none; position: absolute; max-width: 65rem;">
                                        <span class="slds-text-color_inverse" style="font-size: 11px;">Please make sure you backup your Salesforce attachments before you start using this tool, we will not be responsible for any loss of data. Also it is suggested that do not migrate more than 500 records per day, everytime you migrate the attachments verify they are migrated in FTP Attachments successfully. In case of any issues you can login to your Salesforce Recycle Bin and undelete the attachments.This tool is intended to be used by only Salesforce experts, who has thorough knowledge of Salesforce and its data management.</span>
                                    </span>
                                    <p><a href="../../help/FTPAttachments/AttachmentsMigrator.aspx" target="_blank">Help! How to use this tool?</a></p>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="slds-p-horizontal_small slds-p-bottom_small">
            <article class="slds-card slds-m-top_x-small">
        <div class="slds-card__header slds-grid">
            <header class="slds-media slds-media_center slds-has-flexi-truncate">
                <div class="slds-media__figure"></div>
            </header>
        </div>
        <div class="slds-card__body slds-card__body_inner">
    <article class="slds-card slds-card_boundary">
        <footer class="slds-text-align_left slds-p-around--small">
            <asp:UpdatePanel ID="panelPage" runat="server" UpdateMode="Conditional" ChildrenAsTriggers="False">
                <ContentTemplate>
                    <div class="slds-grid slds-wrap slds-p-top_small">
                        <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                            <asp:UpdatePanel ID="panelPurchase" runat="server">
                                <ContentTemplate>
                                    <span class="slds-text-color_error"><asp:Label ID="lbPurcahseToUse" runat="server" SkinID="Error"></asp:Label></span>
                                </ContentTemplate>
                                <Triggers>
                                    <asp:AsyncPostBackTrigger ControlID="buttonRetreive" EventName="Click" />
                                </Triggers>
                            </asp:UpdatePanel>
                        </div>
                    </div>
                    <div class="slds-grid slds-wrap">
                        <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1 slds-align_absolute-center">
                            <div id="toaststatus" class="slds-scrollable" style="display: none;" runat="server">
                                    <div class="demo-only">
                                           <div class="slds-notify_container slds-is-relative">
                                                 <div class="slds-notify slds-notify_toast slds-theme_info" role="alert">
                                                        <span class="slds-assistive-text">error</span>
                                                             <span class="slds-icon_container slds-icon-utility-info slds-m-right_small slds-no-flex slds-align-top" title="Description of icon when needed">
                                                                            <svg class="slds-icon slds-icon_small" aria-hidden="true">
                                                                                   <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#info" />
                                                                            </svg>
                                                           </span>
                                                           <div class="slds-notify__content">
                                                                            <asp:Label ID="lbStatus" runat="server"  Width="100%" CssClass="slds-text-body--regular"></asp:Label>
                                                                            <asp:Label ID="lbParentError" runat="server" CssClass="slds-text-body--regular"></asp:Label>  
                                                           </div>
                                                         
                                                           <button class="slds-button slds-button_icon slds-notify__close slds-button_icon-inverse" title="Close" id="btnClose" onclick="return hideToast()">
                                                                            <svg class="slds-button__icon slds-button__icon_large" aria-hidden="true">
                                                                                 <use xmlns:xlink="http://www.w3.org/1999/xlink" xlink:href="../../css/vendor/slds/assets/icons/utility-sprite/svg/symbols.svg#close" />
                                                                            </svg>
                                                                            <span class="slds-assistive-text">Close</span>
                                                                        </button>
                                                  </div>
                                            </div>
                                    </div>
                               </div>
                        </div>
                    </div>
                  <%--  <div class="slds-grid slds-wrap">
                        <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                            <p class="slds-text-body_regular">
                                <asp:Label ID="lbParentError" runat="server" SkinID="Error"></asp:Label>
                            </p>
                        </div>
                    </div>--%>
                    <div class="slds-grid slds-wrap slds-p-top_small">
                        <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                            <asp:Panel ID="panelDisplayTool" runat="server" Enabled="false">
                                <asp:UpdatePanel ID="panelTool" runat="server" ChildrenAsTriggers="False" UpdateMode="Conditional">
                                    <ContentTemplate>                             
                                        <div class="slds-grid slds-wrap slds-p-top_small">
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2 slds-p-right_xx-large">
                                                <div class="slds-form-element">
                                                    <label class="slds-form-element__label" for="form-element-01"><span class="slds-text-body_regular" style="font-weight:normal;">Object</span>&nbsp
                                                        <cc2:Help ID="Help1" runat="server" HelpMessageID="Resources.Help.MigratorObject"></cc2:Help>
                                                    </label>
                                                    <div class="slds-form-element__control">
                                                        <asp:HiddenField ID="hdAttachmentObject" runat="server" />
                                                        <asp:ObjectDataSource ID="LinkableObjects" runat="server" SelectMethod="GetLinkableObjects" TypeName="enzigma.sforce.webapp.code.business.AttachFTPLink">
                                                            <SelectParameters>
                                                                <asp:SessionParameter Name="strSFUrl" SessionField="SFUrl" Type="String" />
                                                                <asp:SessionParameter Name="strSFSessionID" SessionField="SFSessionID" Type="String" />
                                                                <asp:ControlParameter ControlID="hdAttachmentObject" Name="strObjectType" PropertyName="Value" Type="String" />
                                                            </SelectParameters>
                                                        </asp:ObjectDataSource>
                                                        <asp:DropDownList ID="cmbLinkedObjects" CssClass="slds-select" runat="server" AutoPostBack="True" OnSelectedIndexChanged="cmbLinkedObjects_SelectedIndexChanged">
                                                        </asp:DropDownList>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2 slds-p-right_xx-large">
                                                <div class="slds-form-element">
                                                    <label class="slds-form-element__label" for="form-element-01"> <span class="slds-text-body_regular" style="font-weight:normal;">Server Profile</span>&nbsp
                                                        <cc2:Help ID="Help8" runat="server" HelpMessageID="Resources.Help.ServerProfile"></cc2:Help>
                                                    </label>
                                                    <div class="slds-form-element__control">
                                                        <asp:DropDownList ID="cmbServerProfiles" CssClass="slds-select" runat="server" DataSourceID="ServerProfiles" DataTextField="Text" DataValueField="Text" ValidationGroup="MigrationTool" OnDataBound="cmbServerProfiles_DataBound">
                                                        </asp:DropDownList>
                                                        <asp:RequiredFieldValidator ID="reqServerProfile" runat="server" ControlToValidate="cmbServerProfiles" ErrorMessage="Please select a profile"></asp:RequiredFieldValidator>
                                                        <asp:ObjectDataSource ID="ServerProfiles" runat="server" SelectMethod="GetServerProfiles" TypeName="enzigma.sforce.webapp.code.business.FTPAttachmentsSettings">
                                                            <SelectParameters>
                                                                <asp:SessionParameter Name="strCustomerID" SessionField="UserID" Type="String" />
                                                            </SelectParameters>
                                                        </asp:ObjectDataSource>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="slds-grid slds-wrap slds-p-top_small">
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                                                <div class="slds-form-element">
                                                    <label class="slds-form-element__label" for="form-element-01"><span class="slds-text-body_regular" style="font-weight:normal;">Add Field To Folder</span>&nbsp
                                                       <cc2:Help ID="Help7" runat="server" HelpMessageID="Resources.Help.MigratorFolderMergeField"></cc2:Help>
                                                    </label>
                                                    <div class="slds-form-element__control">
                                                        <asp:UpdatePanel ID="UpdatePanel4" runat="server" UpdateMode="Conditional" ChildrenAsTriggers="False">
                                                            <ContentTemplate>
                                                                <uc2:MergeFieldHelper ID="MergeFieldHelper1" runat="server" />
                                                            </ContentTemplate>
                                                            <Triggers>
                                                                <asp:AsyncPostBackTrigger ControlID="cmbLinkedObjects" EventName="SelectedIndexChanged" />
                                                            </Triggers>
                                                        </asp:UpdatePanel>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="slds-grid slds-wrap slds-p-top_small">
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                                                <div class="slds-form-element">
                                                    <label class="slds-form-element__label" for="form-element-01"><span class="slds-text-body_regular" style="font-weight:normal;">Comment</span>&nbsp
                                                        <cc2:Help ID="Help2" runat="server" HelpMessageID="Resources.Help.MigratorComment"></cc2:Help>
                                                    </label>
                                                    <div class="slds-form-element__control">
                                                        <asp:UpdatePanel ID="UpdatePanel3" runat="server" ChildrenAsTriggers="False" UpdateMode="Conditional">
                                                            <ContentTemplate>
                                                                <asp:TextBox ID="edComment" runat="server" TextMode="MultiLine" MaxLength="5" CssClass="slds-input"></asp:TextBox>
                                                                <asp:CustomValidator ID="cuvComment" runat="server" ClientValidationFunction="CheckLimit" ControlToValidate="edComment" Display="Dynamic" ErrorMessage="Max 255 characters allowed."></asp:CustomValidator>
                                                            </ContentTemplate>
                                                            <Triggers>
                                                                <asp:AsyncPostBackTrigger ControlID="cmbLinkedObjects" EventName="SelectedIndexChanged" />
                                                            </Triggers>
                                                        </asp:UpdatePanel>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="slds-grid slds-wrap slds-p-top_small">
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                                                <div class="slds-form-element">
                                                    <label class="slds-form-element__label" for="form-element-01"><span class="slds-text-body_regular" style="font-weight:normal;">Storage Folder</span>&nbsp
                                                        <cc2:Help ID="Help6" runat="server" CssClass="HelpMessage" HelpMessageID="Resources.Help.DefaultFolder"></cc2:Help>
                                                    </label>
                                                    <div class="slds-form-element__control">
                                                        <asp:UpdatePanel ID="UpdatePanel5" runat="server" ChildrenAsTriggers="False" UpdateMode="Conditional">
                                                            <ContentTemplate>
                                                                <asp:RequiredFieldValidator ID="reqFolder" runat="server" ControlToValidate="edFolder" Display="Dynamic" ErrorMessage="Please enter Folder where attachments will be stored" Width="340px" Enabled="False"></asp:RequiredFieldValidator>
                                                                <asp:TextBox ID="edFolder" runat="server" CssClass="slds-input" TextMode="MultiLine"></asp:TextBox>
                                                            </ContentTemplate>
                                                            <Triggers>
                                                                <asp:AsyncPostBackTrigger ControlID="cmbLinkedObjects" EventName="SelectedIndexChanged" />
                                                            </Triggers>
                                                        </asp:UpdatePanel>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="slds-grid slds-wrap slds-p-top_small">
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2">
                                                <div class="slds-form-element">
                                                    <label class="slds-form-element__label" for="form-element-01"><span class="slds-text-body_regular" style="font-weight:normal;">Limit</span>&nbsp
                                                        <cc2:Help ID="Help4" runat="server" HelpMessageID="Resources.Help.MigratorLimit"></cc2:Help>
                                                    </label>
                                                    <div class="slds-form-element__control slds-p-right_xx-large">
                                                        <asp:UpdatePanel ID="UpdatePanel8" runat="server" ChildrenAsTriggers="False" UpdateMode="Conditional">
                                                            <ContentTemplate>
                                                                <asp:TextBox ID="edLimit" runat="server" CssClass="slds-input" MaxLength="4">1000</asp:TextBox>
                                                                <asp:RegularExpressionValidator ID="reqLimit" runat="server" ControlToValidate="edLimit" ErrorMessage="Please enter a valid number greather than 0" ValidationExpression="^[0-9]+$" Display="Dynamic"></asp:RegularExpressionValidator>
                                                                <asp:CompareValidator ID="compareLimitEval" runat="server" ControlToValidate="edLimit" Display="Dynamic" ErrorMessage="For evaluation maximum limit allowed is 5 records" Operator="LessThanEqual" Type="Integer" ValueToCompare="5"></asp:CompareValidator>
                                                                <asp:CompareValidator ID="compareLimitPurchased" runat="server" ControlToValidate="edLimit" Display="Dynamic" ErrorMessage="Maximum 1000 records can be processed in one go." Operator="LessThanEqual" Type="Integer" ValueToCompare="1000" Enabled="False"></asp:CompareValidator>
                                                            </ContentTemplate>
                                                            <Triggers>
                                                                <asp:AsyncPostBackTrigger ControlID="cmbLinkedObjects" EventName="SelectedIndexChanged" />
                                                            </Triggers>
                                                        </asp:UpdatePanel>
                                                    </div>
                                                </div>
                                            </div>

                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2">
                                                <div class="slds-grid slds-wrap setMargin">
                                                    <div class="slds-col slds-size_1-of-2 slds-medium-size_1-of-2 slds-large-size_1-of-2">
                                                        <div class="slds-form-element">
                                                            <div class="slds-form-element__control">
                                                                <asp:UpdatePanel ID="UpdatePanel2" runat="server" UpdateMode="Conditional">
                                                                    <ContentTemplate>
                                                                        <uc3:SearchCriteria ID="criteriaAttachment" ObjectType="Attachment" runat="server" ControlDiv="divAttachmentFilter" />
                                                                    </ContentTemplate>
                                                                </asp:UpdatePanel>
                                                            </div>
                                                        </div>
                                                    </div>
                                                    <div class="slds-col slds-size_1-of-2 slds-medium-size_1-of-2 slds-large-size_1-of-2">
                                                        <div class="slds-form-element"> 
                                                            <div class="slds-form-element__control">
                                                                <asp:UpdatePanel ID="UpdatePanel1" runat="server" UpdateMode="Conditional">
                                                                    <ContentTemplate>
                                                                        <uc3:SearchCriteria ID="criteriaParent" runat="server" ControlDiv="divParentFilter" />
                                                                    </ContentTemplate>
                                                                    <Triggers>
                                                                        <asp:AsyncPostBackTrigger ControlID="cmbLinkedObjects" EventName="SelectedIndexChanged" />
                                                                    </Triggers>
                                                                </asp:UpdatePanel>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>

                                        <div class="slds-grid slds-wrap slds-p-top_small">
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                                                <asp:UpdateProgress ID="UpdateProgress2" runat="server">
                                                    <ProgressTemplate>
                                                      <div class="slds-spinner_container">
                                                                        <div class="demo-only">
                                                                            <div role="status" class="slds-spinner slds-spinner_medium slds-spinner_brand">
                                                                                <span class="slds-assistive-text">Loading</span>
                                                                                <div class="slds-spinner__dot-a"></div>
                                                                                <div class="slds-spinner__dot-b"></div>
                                                                            </div>
                                                                        </div>
                                                       </div>
                                                    </ProgressTemplate>
                                                </asp:UpdateProgress>
                                            </div>
                                        </div>

                                        <asp:UpdatePanel ID="UpdatePanel9" runat="server">
                                            <ContentTemplate>
                                                    <div class="slds-grid slds-wrap slds-p-top_small">
                                                        <div class="slds-col slds-size_1-of-2 slds-medium-size_1-of-4 slds-large-size_1-of-4"> <asp:Button ID="buttonRetreive" runat="server" CssClass="slds-button slds-button_neutral" OnClientClick="return ResetProgress();" OnClick="btnRetreive_Click" Text="Retrieve" SkinID="DefaultButton"></asp:Button></div>
                                                        <div class="slds-col slds-size_1-of-2 slds-medium-size_1-of-4 slds-large-size_1-of-4"><asp:Button ID="buttonStart" runat="server" CssClass="slds-button slds-button_neutral" Text="Start Migrating" CausesValidation="False" OnClientClick="return OnStartMigration();" SkinID="DefaultButton" UseSubmitBehavior="False"></asp:Button> </div>
                                                        <div class="slds-col slds-size_1-of-2 slds-medium-size_1-of-4 slds-large-size_1-of-4"><asp:Button ID="buttonCancel" runat="server" CssClass="slds-button slds-button_neutral" Text="Cancel" CausesValidation="False" OnClientClick="return OnCancelMigration();" UseSubmitBehavior="False"></asp:Button> </div>
                                                    </div>    
                                            </ContentTemplate>
                                        </asp:UpdatePanel>
                                                                                 
                                        <div class="slds-grid slds-wrap slds-p-top_small">
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2 slds-p-around_small">
                                                <cc1:ProgressBar ID="progressOverview" runat="server" CssClass="ProgressBar" />
                                            </div>
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-2 slds-large-size_1-of-2 slds-p-around_small">
                                                <cc1:ProgressBar ID="progressDetails" runat="server" CssClass="ProgressBar" />
                                            </div>
                                        </div>

                                        <div class="slds-grid slds-wrap slds-p-top_small">
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                                                <asp:Label ID="lbResult" runat="server"></asp:Label>
                                            </div>
                                        </div>

                                        <div class="slds-grid slds-wrap">
                                            <div class="slds-col slds-size_1-of-1 slds-medium-size_1-of-1 slds-large-size_1-of-1">
                                                <asp:ObjectDataSource ID="SFAttachments" runat="server" SelectMethod="GetSFAttachments" TypeName="enzigma.sforce.webapp.code.sforce.SFAttachment" CacheDuration="1">
                                                    <SelectParameters>
                                                        <asp:SessionParameter Name="strSFUrl" SessionField="SFUrl" Type="String" />
                                                        <asp:ControlParameter ControlID="hdSFSessionID" DefaultValue="" Name="strSFSessionID" PropertyName="Value" Type="String" />
                                                        <asp:SessionParameter DefaultValue="" Name="strOrgID" SessionField="OrgID" Type="String" />
                                                        <asp:SessionParameter DefaultValue="" Name="strUserID" SessionField="UserID" Type="String" />
                                                        <asp:ControlParameter ControlID="cmbLinkedObjects" Name="strObject" PropertyName="SelectedValue" Type="String" />
                                                        <asp:ControlParameter ControlID="edFolder" Name="strFolder" PropertyName="Text" Type="String" />
                                                        <asp:ControlParameter ControlID="hdCriteria" Name="strCriteria" PropertyName="Value" Type="String" />
                                                        <asp:ControlParameter ControlID="edLimit" DefaultValue="1000" Name="iLimit" PropertyName="Text" Type="Int32" />
                                                        <asp:ControlParameter ControlID="hdnMigratorID" DefaultValue="" Name="strMigratorID" PropertyName="Value" Type="String" />
                                                        <asp:ControlParameter ControlID="cmbServerProfiles" Name="strServerProfile" PropertyName="SelectedValue" Type="String" />
                                                        <asp:ControlParameter ControlID="edComment" Name="strComment" PropertyName="Text" Type="String" />
                                                    </SelectParameters>
                                                </asp:ObjectDataSource>
                                                <asp:HiddenField ID="hdSFSessionID" runat="server" />
                                                <asp:HiddenField ID="hdnOrgID" runat="server" />
                                                <asp:HiddenField ID="hdnMigratorID" runat="server" />
                                                <asp:HiddenField ID="hdnSFBaseUrl" runat="server" />
                                                <asp:UpdatePanel ID="UpdatePanel6" runat="server" ChildrenAsTriggers="False" UpdateMode="Conditional">
                                                    <ContentTemplate>
                                                        <asp:Label ID="lbAttachmentsListCaption" runat="server"></asp:Label>
                                                                                               
                                                        <div class="row">  
                                                                <div class="col-lg-12 ">  
                                                                    <div class="table-responsive"> 
                                                                            <asp:GridView ID="gridAttachments" runat="server" AutoGenerateColumns="False" DataKeyNames="ID" EmptyDataText="No records found with specified criteria" OnDataBound="gridAttachments_DataBound" CaptionAlign="Right"  Width="100%" CssClass="table table-striped table-bordered table-hover">
                                                            <Columns>
                                                                <asp:TemplateField HeaderText="Parent" >
                                                                    <ItemTemplate>
                                                                        <asp:HyperLink ID="HyperLink1" runat="server" NavigateUrl='<%# hdnSFBaseUrl.Value + Eval("ParentID") %>' Text='<%# Eval("ParentID") %>'></asp:HyperLink>
                                                                    </ItemTemplate>
                                                                </asp:TemplateField>
                                                                <asp:TemplateField HeaderText="Name" >
                                                                    <EditItemTemplate>
                                                                        <asp:TextBox ID="TextBox1" runat="server" Text='<%# Bind("FileName") %>'></asp:TextBox>
                                                                    </EditItemTemplate>
                                                                    <ItemTemplate>
                                                                        <asp:HyperLink ID="lnkAttachment" runat="server" NavigateUrl='<%# hdnSFBaseUrl.Value + Eval("ID") + "/e" %>' Target="_blank" Text='<%# Eval("FileName") %>'></asp:HyperLink>
                                                                    </ItemTemplate>
                                                                </asp:TemplateField>
                                                                <asp:BoundField DataField="Folder" HeaderText="Folder" HeaderStyle-CssClass="visible-lg" ItemStyle-CssClass="visible-lg" />
                                                                <asp:BoundField DataField="DisplaySize" HeaderText="Size" ItemStyle-CssClass="visible-xs" HeaderStyle-CssClass="visible-xs" />
                                                                <asp:BoundField DataField="FieldName" HeaderText="Field Name" HeaderStyle-CssClass="visible-md" ItemStyle-CssClass="visible-md"/>
                                                                <asp:BoundField DataField="ServerProfile" HeaderText="Server Profile" ItemStyle-CssClass="hidden-xs" HeaderStyle-CssClass="hidden-xs"/>
                                                                <asp:TemplateField HeaderText="Status">
                                                                    <ItemTemplate>
                                                                        <div id="divStatus_<%#Eval(" ID ")%>">
                                                                            Not Processed
                                                                        </div>
                                                                    </ItemTemplate>
                                                                </asp:TemplateField>
                                                            </Columns>
                                                            <HeaderStyle Wrap="True" />
                                                        </asp:GridView>
                                                                        </div>
                                                                    </div>
                                                            </div>
                                                    </ContentTemplate>
                                                    <Triggers>
                                                        <asp:AsyncPostBackTrigger ControlID="buttonRetreive" EventName="Click" />
                                                    </Triggers>
                                                </asp:UpdatePanel>
                                                <asp:HiddenField ID="hdFillControls" runat="server" />
                                                <asp:HiddenField ID="hdCriteria" runat="server" />
                                                <asp:HiddenField ID="hdObjectType" runat="server" />
                                            </div>
                                        </div>
                                    </ContentTemplate>
                                </asp:UpdatePanel>
                            </asp:Panel>
                        </div>
                    </div>
                </ContentTemplate>
            </asp:UpdatePanel>
        </footer>
    </article>
</div>
    </article>
        </div>
    </div>

    <script type="text/javascript">
        $(document).ready(function () {
            $('.ProgressBarValue').css("background-color", "#dddbda");
            $('#PageContent_progressOverview_Text').css("top", "-19px");
            $('#PageContent_progressDetails_Text').css("top", "-19px");
        });

        RegisterWindowEventHandler('load', function () {
            g_bBodyAlreadyLoaded = true;
        });
        RegisterWindowEventHandler('unload', ClearAllIntervals);


    </script>
    <script language="javascript" type="text/javascript">
        function PositionUpdateProgress() {
            var imgProgress = document.getElementById('imgProgress');
            if (innerWidth) {
                imgProgress.style.left = innerWidth / 2;
                imgProgress.style.top = innerHeight / 2;
            } else {
                imgProgress.style.left = document.body.clientWidth / 2;
                imgProgress.style.top = document.body.clientHeight / 2;
            }
        }
    </script>
</asp:Content>
